#include <stdio.h>
#include <stdlib.h>
#include "hg_dfaarray.h"

char *
read_file (char * filename)
{
  FILE * fp;
  int filesize;
  char * filebuf;

  fp = fopen (filename, "rb");
  if (fp == 0)
    {
      fprintf (stderr, "%s:   ϴ.\n", filename);
      exit (-1);
    }
  fseek (fp, 0, 2);
  filesize = ftell (fp);
  rewind (fp);
  filebuf = (char *) malloc (filesize+1);
  if (filebuf == 0)
    {
      fprintf(stderr, "޸𸮸 Ҵ  ϴ.\n");
      exit(-1);
    }
  if (fread (filebuf, 1, filesize, fp) != filesize)
    {
      fprintf (stderr, "  %d Ʈ   ϴ.\n", filesize);
      free (filebuf);
      exit (-1);
    }
  fclose (fp);
  filebuf[filesize] = '\0';

  return filebuf;
}

void
usage (void)
{
  printf ("ѱ grep v0.0.1\n");
  printf ("hgrep [options] PATTERN [FILE...]\n");
  printf ("hgrep [options] [-e PATTERN | -f FILE] [FILE...]\n");

}

int
main(int argc, char * argv[])
{
  int lineno=0, using_pipe=0, i;
  char * filebuf, * t, c;
  struct dfa_array * re;

  if (argc == 2)
    {
      using_pipe++;
      t = (char *) malloc(1024*10);
    }
  else if (argc == 3)
      filebuf = read_file (argv[2]);
  else
    {
      usage ();
      exit (1);
    }

  re = hg_regexp_compile (argv[1]);

  if (using_pipe) /* using pipe */
    {
      while ((c = getchar ()) != EOF)
        {
          for (i=0; c != '\n' && c != EOF ;i++)
            {
              t[i] = c;
              c = getchar ();
            } 
          t[i++] = '\n';
          t[i++] = '\0';
          hg_regexp_search (re, t);
          lineno++;
          if (re->pos != -1)
            printf ("%6d: %s", lineno, t);
        }
    }
  else
    {  /* using file */
      i=0;
      while (filebuf[i] != '\0')
        {
	  if(lineno == 0)	/* ^ Ÿڸ  Ʈ  */
            t = filebuf+i;
	  else
            t = filebuf+i-1;
          while (filebuf[i] != '\n')
	    i++;
          i++;
          c = filebuf[i];
          filebuf[i] = '\0';
          hg_regexp_search (re, t);
          lineno++;
          if (re->pos != -1)
	    {
	      if (lineno == 1)
	        printf ("%s", t);
	      else
	        printf ("%s", t+1);
	    }
          filebuf[i] = c;  /*  */
        }
      free (filebuf);
    }

  hg_regexp_free(re);

  return 0;
}
