#ifndef HG_RE_HEADER
#define HG_RE_HEADER

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <signal.h>
#include "han_libc/han_lib.h"
#include "hg_dfaarray.h"

#define FETCH(c, r)					\
  {							\
    (c) = (char *) ((*r)++);				\
  }							\

#define MALLOC(p, t, n)					\
  {							\
    ((p) = (t *) malloc((n) * sizeof (t)));		\
    memset((p), '\0', (n) * sizeof (t));		\
  } 							\

#define DFA_TABLE_NUM	0x1b
#define DFA_TABLE_MAX	0x100
#define ENG_RANGE	0x100
#define KOR_RANGE	0x60
#define KOR_FSTB_P	0xb0
#define KOR_SNDB_P	0xa0

/*  ǥ  */
char * re_t=NULL;
char ** re = &re_t;

void show_stack(void);
void prt_equtab(int,int);
void prt_trans(int **, int, int, int);


/*  ǥ ɺ ӽ÷  ִ 
 * ɺ ̺ ɺ 񱳿 . */
char char_buf[0x100], *chp = char_buf;
char * last_w;

/* lexical м Ǵ  */
typedef enum
{
  end_t,		/*  */
  l_par_t,		/* ( */
  r_par_t,		/* ) */
  plus_t,		/* + */
  star_t,		/* * */
  or_t,			/* | */
  and_t,		/* & */
  iden_t,		/*  */
  l_brac_t,		/* [ */
  r_brac_t,		/* ] */
  ssac_t,		/* ^ */
  money_t,		/* $ */
  rev_slash_t,		/* \ */
  slash_t,		/* / */
  bar_t,		/* - */
  dot_t, 		/* . */
  l_lpar_t,		/* { */
  r_lpar_t,		/* } */
  coron_t,		/* : */
  comma_t,		/* , */
  ask_t			/* ? */
} lexical;

/*  м ÿ ö󰡴 ǥ .
 *    Ű . */
typedef enum
{
  RULE,		/* RULE:          -> ǥ $ */
  PAR,		/* PAR:   ǥ  -> '(' ǥ $ ')'    */
  LPAR,		/* LPAR:  ǥ  -> '{' ǥ $ '}'    */
  OPT,		/* OPT:   ǥ  -> '[' ǥ $ ']'    */
  OR,		/* OR:    ǥ  -> ǥ '|' ǥ $    */
  BAR,		/* BAR:   ǥ  -> ǥ '-' ǥ $    */
  CORON,	/* CORON: ǥ  -> ǥ ':' ǥ $    */
  COMMA,	/* COMMA: ǥ  -> ǥ ',' ǥ $    */
  AND,		/* AND:   ǥ  -> ǥ ǥ $        */
  SSAC		/* SSAC:  ǥ  -> ^ ǥ $		*/
} stack_tag;

/* ļ Ʈ ϳ 尡   ִ . */
typedef enum
{
  sym_x,		/*  0  E0	: */
  dot_x,		/*  1 .		: */
  ssac_x,		/*  2 ^		: */
  money_x,		/*  3 $		: */
  rev_slash_x,		/*  4 \		: */
  zero_x,		/*  5 0		: */
  one_x,		/*  6 1		: */
  and_x,		/*  7 E0&E1	: */
  or_x,			/*  8 E0|E1	: */
  bar_x,		/*  9 E0-E1	: */
  star_x,		/* 10 E0*	: */
  plus_x,		/* 11 E0+	: */
  comma_x,		/* 12 E0,E1	: */
  opt_x,		/* 13 [E0] 	: */
  lopt_x,	 	/* 14 {E0} 	: */
  coron_x,		/* 15 E0:E1	: */
  ask_x			/* 16 ?		: */
} exp_tag;

/*  */
struct stack_dummy
{
  stack_tag tag;
  int q;
};

#define STACK_MAX  100
#define TOP ((SP - 1)->tag)
#define POP() ((--SP)->q)

struct stack_dummy stack[STACK_MAX], *SP;

struct symbol
{
  char * name;
  int hash;
  struct symbol * next, * tail;
};

#define HASH_MAX 0x100
struct symbol * hashtab[HASH_MAX], * first_b = NULL, * last_b;

struct exp
{
  exp_tag tag;
  int hash, class;
  int args;
  struct exp * tail;
  union {
    struct symbol * leaf;
    int * arg;
  } body;
};

#define EXP_MAX		0x200
struct exp * exp_hash[EXP_MAX];

#define EQU_EXTEND	0x100
struct equation
{
  struct exp * value;
  int hash;
  unsigned stack:1;
  int index;
};

struct equation * equ_tab = NULL;
int equs = 0, equ_max = 0;

struct item
{
  struct symbol * LHS;
  int size, * RHS;
  int index;
};

struct item * i_buf;
int i_s, i_max;

struct state
{
  int class, states, *s_list;
  int empty, shifts, ssac_got, money, reverse, dot, lopt_merge;
  struct {
    struct symbol * LHS;
    int RHS;
  } * sh_list;
};

struct state * s_tab;
int s_s;

struct equiv
{
  struct state * L, * R;
};

struct equiv * e_tab;
int e_s, e_max;

int *x_stack = 0; int x_s = 0, x_max = 0;
#define X_EXTEND 4

#define MAX_ERRORS	25
int LINE = 1, ERRORS = 0;

int mode=0;
#define MODE_NOT_META		0x1	/* Ÿڷ ν    */
#define MODE_IGNORE_SSAC	0x2	/* [ ~ ] ǥĿ  ^  */
#define MODE_NEED_RAW_NUM	0x4	/* { , } ǥĿ ڸ ״  */
#define MODE_NEED_LOPT_MERGE	0x8	/* { , } ǥĿ Merge  ʿ */
#define MODE_NOT_NEED_CONV	0x10	/* ǥ ȯ ʿ  */
#define MODE_IGNORE_SPACE	0x20	/*  Ȥ      */

#define LOPT_MERGE_MAX		0x100
int lopt_merge_start[LOPT_MERGE_MAX];
int lopt_merge_end[LOPT_MERGE_MAX];

extern void prt_i_buf(struct item *);
extern void prt_s_tab(struct state *);
extern void prt_x_stack(void);

#endif /* HG_RE_HEADER */
