/*
 * Hangul Regular Expression
 * Copyright (C) 2001 Wongyo Jung & Hyejin Soang & IGRUS & Inha University
 *
 * This program is  free software; you can  redistribute it and/or modify
 * it under the terms  of the GNU General Public  License as published by
 * the  Free Software Foundation; either version  2,  or (at your option)
 * any later version.
 *
 * This program is distributed  in the hope that  it will be  useful, but
 * WITHOUT    ANY  WARRANTY;  without   even   the  implied  warranty  of
 * MERCHANTABILITY  or  FITNESS FOR  A PARTICULAR   PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should  have received a  copy of  the GNU  General Public  License
 * along with   this  program; if   not,  write  to   the Free   Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * Contact : Wongyo Jung  - andsoon@igrus.inha.ac.kr
 *           Hyejin Soang - redlcoak@igrus.inha.ac.kr
 *           IGRUS        - http://igrus.inha.ac.kr
 *           Inha Univ.   - http://www.inha.ac.kr
 */
#include <string.h>
#include <stdlib.h>

/* ޸ Ҵ ũ */
#define MALLOC(p, t, n)                                 \
        {                                               \
		((p) = (t *) malloc((n) * sizeof (t))); \
		memset((p), '\0', (n) * sizeof (t));	\
	}                                               \

/*  Ʈ ̷ ѱ ù° Ʈ ˻մϴ. */
int 
hg_ishangul_fb(unsigned char c1)
{
	/*  ϼ ѱ 츸 ˻ մϴ. */
	if( ((c1 >= 0xb0 && c1 <= 0xc8 ) || c1 == 0xa4) ) {
		return 1;
	}

	return 0;
}

/*  Ʈ ̷ ѱ ι° Ʈ ˻մϴ. */
int 
hg_ishangul_sb( unsigned char c2)
{
	/*  ϼ ѱ 츸 ˻ մϴ. */
	if( (c2 >= 0xa1 && c2 <= 0xfe) ) {
		return 1;
	}

	return 0;
}

/* ڷ   ѱ ƴ ˻մϴ. */
int 
hg_ishangul(unsigned char c1, unsigned char c2)
{
	/*  ϼ ѱ 츸 ˻ մϴ. */
	if( ((c1 >= 0xb0 && c1 <= 0xc8 ) || c1 == 0xa4) 
		&& (c2 >= 0xa1 && c2 <= 0xfe) ) {
		return 1;
	}

	return 0;
}

/*   ѱ   к ϴ.
 *
 *  Ʒ ϴ.
 *
 * 	ʼ ߼  ƴ϶	== 0
 * 	ʼ 				== 1
 * 	߼				== 2
 * 					== 3
 *
 * 	ʼϼ    ִ  == 4
 */
int 
hg_ishangul_type(unsigned char c1, unsigned char c2)
{
	if( c1 == 0xa4 ) {	/* ,  κ */
		if( c2 >= 0xa1 && c2 <= 0xbe ) {	/* ʼ,  κ */
			if( c2 == 0xa1 )
				return 4;
			if( c2 == 0xa2 )
				return 4;
			if( c2 == 0xa3 )
				return 3;
			if( c2 == 0xa4 )
				return 4;
			if( c2 == 0xa5 )
				return 3;
			if( c2 == 0xa6 )
				return 3;
			if( c2 == 0xa7 )
				return 4;
			if( c2 == 0xa8 )
				return 1;
			if( c2 == 0xa9 )
				return 4;
			if( c2 == 0xaa )
				return 3;
			if( c2 == 0xab )
				return 3;
			if( c2 == 0xac )
				return 3;
			if( c2 == 0xad )
				return 3;
			if( c2 == 0xae )
				return 3;
			if( c2 == 0xaf )
				return 3;
			if( c2 == 0xb0 )
				return 3;
			if( c2 == 0xb1 )
				return 4;
			if( c2 == 0xb2 )
				return 4;
			if( c2 == 0xb3 )
				return 1;
			if( c2 == 0xb4 )
				return 3;
			if( c2 == 0xb5 )
				return 4;
			if( c2 == 0xb6 )
				return 4;
			if( c2 == 0xb7 )
				return 4;
			if( c2 == 0xb8 )
				return 4;
			if( c2 == 0xb9 )
				return 1;
			if( c2 == 0xba )
				return 4;
			if( c2 == 0xbb )
				return 4;
			if( c2 == 0xbc )
				return 4;
			if( c2 == 0xbd )
				return 4;
			if( c2 == 0xbe )
				return 4;
		} else if ( c2 >= 0xbf && c2 <= 0xd3 ) {
			return 2;	/* ߼ κ */
		} else {
			return 0;
		}
	}

	return 0;
}

char *
hg_ksc5601_to_eng(unsigned char c1, unsigned char c2)
{
	unsigned int ** haneng;
	int s1;
	char ** s2;
	char * s3;
	char * ret;
	

	unsigned int ksc5601_to_eng_25[] = {
		-1, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
		0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9, 0xa, 0xb, 0xc, 0xd, 0xe, 0xf, 0x10, 0x11, 
		0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
		0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
		0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
		0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 
	};

	char * ksc5601_to_eng_26[] = {
	NULL, "Ga", "Gag", "Gan", "Gad", "Gal", "Galg", "Galm", "Gam", "Gab", "Gabs", "Gas", "Gass", "Gang", "Gaj", "Gac",
	"Gat", "Gap", "Gah", "Gae", "Gaeg", "Gaen", "Gael", "Gaem", "Gaeb", "Gaes", "Gaess", "Gaeng", "Gya", "Gyag", "Gyan", "Gyal",
	"Gyas", "Gyang", "Gyae", "Gyaen", "Gyael", "Geo", "Geog", "Geon", "Geod", "Geol", "Geolm", "Geom", "Geob", "Geos", "Geoss", "Geong",
	"Geoj", "Geot", "Geop", "Geoh", "Ge", "Gen", "Gel", "Gem", "Geb", "Ges", "Gess", "Geng", "Gyeo", "Gyeog", "Gyeogg", "Gyeon",
	"Gyeod", "Gyeol", "Gyeom", "Gyeob", "Gyeos", "Gyeoss", "Gyeong", "Gyeot", "Gye", "Gyen", "Gyel", "Gyeb", "Gyes", "Go", "Gog", "Gon", 
	"God", "Gol", "Golm", "Gols", "Golh", "Gom", "Gob", "Gos", "Gong", "Goj", "Gwa", "Gwag", "Gwan", "Gwal", "Gwalm", NULL };

	char * ksc5601_to_eng_0[] = { NULL, "Ga", "Gag", "Gan", "Gad", "Gal", "Galg", "Galm", "Gam", "Gab", "Gabs", "Gas", "Gass", "Gang", "Gaj", "Gac", 
	"Gat", "Gap", "Gah", "Gae", "Gaeg", "Gaen", "Gael", "Gaem", "Gaeb", "Gaes", "Gaess", "Gaeng", "Gya", "Gyag", "Gyan", "Gyal", 
	"Gyas", "Gyang", "Gyae", "Gyaen", "Gyael", "Geo", "Geog", "Geon", "Geod", "Geol", "Geolm", "Geom", "Geob", "Geos", "Geoss", "Geong", 
	"Geoj", "Geot", "Geop", "Geoh", "Ge", "Gen", "Gel", "Gem", "Geb", "Ges", "Gess", "Geng", "Gyeo", "Gyeog", "Gyeogg", "Gyeon", 
	"Gyeod", "Gyeol", "Gyeom", "Gyeob", "Gyeos", "Gyeoss", "Gyeong", "Gyeot", "Gye", "Gyen", "Gyel", "Gyeb", "Gyes", "Go", "Gog", "Gon", 
	"God", "Gol", "Golm", "Gols", "Golh", "Gom", "Gob", "Gos", "Gong", "Goj", "Gwa", "Gwag", "Gwan", "Gwal", "Gwalm", NULL };

	char * ksc5601_to_eng_1[] = { NULL, "Gwam", "Gwab", "Gwas", "Gwang", "Gwae", "Gwaen", "Gwael", "Gwaeb", "Gwaess", "Gwaeng", "Goe", "Goeg", "Goen", "Goel", "Goem", 
	"Goeb", "Goes", "Goeng", "Gyo", "Gyon", "Gyol", "Gyob", "Gyos", "Gu", "Gug", "Gun", "Gud", "Gul", "Gulg", "Gulm", "Gulh", 
	"Gum", "Gub", "Gus", "Gung", "Guj", "Gweo", "Gweog", "Gweon", "Gweol", "Gweoss", "Gweong", "Gwe", "Gwes", "Gwi", "Gwig", "Gwin", 
	"Gwil", "Gwim", "Gwib", "Gwis", "Gyu", "Gyun", "Gyul", "Geu", "Geug", "Geun", "Geud", "Geul", "Geulg", "Geum", "Geub", "Geus", 
	"Geung", "Gyi", "Gi", "Gig", "Gin", "Gid", "Gil", "Gilm", "Gim", "Gib", "Gis", "Ging", "Gij", "Gip", "Gga", "Ggag", 
	"Ggagg", "Ggan", "Ggal", "Ggalm", "Ggam", "Ggab", "Ggas", "Ggass", "Ggang", "Ggat", "Ggae", "Ggaeg", "Ggaen", "Ggael", "Ggaem", NULL };

	char * ksc5601_to_eng_2[] = { NULL, "Ggaeb", "Ggaes", "Ggaess", "Ggaeng", "Ggya", "Ggyag", "Ggyal", "Ggeo", "Ggeog", "Ggeogg", "Ggeon", "Ggeol", "Ggeom", "Ggeob", "Ggeos", 
	"Ggeoss", "Ggeong", "Gge", "Ggeg", "Ggen", "Ggem", "Gges", "Ggeng", "Ggyeo", "Ggyeon", "Ggyeol", "Ggyeos", "Ggyeoss", "Ggyeot", "Ggye", "Ggo", 
	"Ggog", "Ggon", "Ggonh", "Ggol", "Ggom", "Ggob", "Ggos", "Ggong", "Ggoj", "Ggoc", "Ggwa", "Ggwag", "Ggwal", "Ggwass", "Ggwang", "Ggwae", 
	"Ggwaeg", "Ggwaeng", "Ggoe", "Ggoen", "Ggoel", "Ggoem", "Ggoeb", "Ggoeng", "Ggyo", "Ggu", "Ggug", "Ggun", "Ggul", "Ggulh", "Ggum", "Ggub", 
	"Ggus", "Ggung", "Gguj", "Ggweo", "Ggweol", "Ggweoss", "Ggweong", "Ggwe", "Ggweg", "Ggwen", "Ggwel", "Ggwem", "Ggweb", "Ggwess", "Ggwi", "Ggwin", 
	"Ggwil", "Ggwim", "Ggwib", "Ggyu", "Ggeu", "Ggeug", "Ggeun", "Ggeunh", "Ggeul", "Ggeulm", "Ggeulh", "Ggeum", "Ggeub", "Ggeus", "Ggeung", NULL };

	char * ksc5601_to_eng_3[] = { NULL, "Ggeut", "Ggi", "Ggig", "Ggin", "Ggil", "Ggim", "Ggib", "Ggis", "Gging", "Na", "Nag", "Nagg", "Nan", "Nad", "Nal", 
	"Nalg", "Nalm", "Nam", "Nab", "Nas", "Nass", "Nang", "Naj", "Nac", "Nat", "Nah", "Nae", "Naeg", "Naen", "Nael", "Naem", 
	"Naeb", "Naes", "Naess", "Naeng", "Nya", "Nyag", "Nyan", "Nyal", "Nyam", "Nyang", "Neo", "Neog", "Neogs", "Neon", "Neol", "Neolm", 
	"Neolb", "Neom", "Neob", "Neos", "Neoss", "Neong", "Neoh", "Ne", "Neg", "Nen", "Nel", "Nem", "Neb", "Nes", "Ness", "Neng", 
	"Nyeo", "Nyeog", "Nyeon", "Nyeol", "Nyeom", "Nyeob", "Nyeoss", "Nyeong", "Nyeok", "Nye", "Nyen", "No", "Nog", "Non", "Nol", "Nolm", 
	"Nom", "Nob", "Nos", "Nong", "Nop", "Noh", "Nwa", "Nwan", "Nwal", "Nwass", "Noe", "Noen", "Noel", "Noem", "Noeb", NULL };

	char * ksc5601_to_eng_4[] = { NULL, "Noes", "Nyo", "Nyog", "Nyon", "Nyol", "Nyob", "Nyos", "Nyong", "Nu", "Nug", "Nun", "Nud", "Nul", "Num", "Nub", 
	"Nus", "Nung", "Nweo", "Nweoss", "Nwe", "Nwi", "Nwin", "Nwil", "Nwim", "Nwib", "Nyu", "Nyug", "Nyul", "Nyum", "Nyub", "Nyung", 
	"Neu", "Neug", "Neun", "Neul", "Neulg", "Neulm", "Neum", "Neub", "Neus", "Neung", "Neuj", "Neup", "Nyi", "Nyin", "Nyil", "Ni", 
	"Nig", "Nin", "Nil", "Nilm", "Nim", "Nib", "Nis", "Ning", "Nip", "Da", "Dag", "Dagg", "Dan", "Dad", "Dal", "Dalg", 
	"Dalm", "Dalb", "Dalh", "Dam", "Dab", "Das", "Dass", "Dang", "Daj", "Dac", "Dah", "Dae", "Daeg", "Daen", "Dael", "Daem", 
	"Daeb", "Daes", "Daess", "Daeng", "Dya", "Deo", "Deog", "Deogg", "Deon", "Deod", "Deol", "Deolm", "Deolb", "Deom", "Deob", NULL };

	char * ksc5601_to_eng_5[] = { NULL, "Deos", "Deong", "Deoc", "Deop", "De", "Deg", "Den", "Del", "Dem", "Deb", "Des", "Dess", "Deng", "Dyeo", "Dyeon", 
	"Dyeol", "Dyeoss", "Dyeong", "Dye", "Dyen", "Do", "Dog", "Don", "Dod", "Dol", "Dolm", "Dols", "Dom", "Dob", "Dos", "Dong", 
	"Doc", "Dot", "Dwa", "Dwan", "Dwal", "Dwae", "Dwaess", "Doe", "Doen", "Doel", "Doem", "Doeb", "Does", "Dyo", "Du", "Dug", 
	"Dun", "Dul", "Dum", "Dub", "Dus", "Dung", "Dweo", "Dweoss", "Dwe", "Dweng", "Dwi", "Dwin", "Dwil", "Dwib", "Dwis", "Dwing", 
	"Dyu", "Dyun", "Dyul", "Dyum", "Dyung", "Deu", "Deug", "Deun", "Deud", "Deul", "Deulm", "Deum", "Deub", "Deus", "Deung", "Dyi", 
	"Di", "Dig", "Din", "Did", "Dil", "Dim", "Dib", "Dis", "Diss", "Ding", "Dij", "Dda", "Ddag", "Ddan", "Ddal", NULL };

	char * ksc5601_to_eng_6[] = { NULL, "Ddam", "Ddab", "Ddas", "Ddass", "Ddang", "Ddah", "Ddae", "Ddaeg", "Ddaen", "Ddael", "Ddaem", "Ddaeb", "Ddaes", "Ddaess", "Ddaeng", 
	"Ddeo", "Ddeog", "Ddeon", "Ddeol", "Ddeolm", "Ddeolb", "Ddeom", "Ddeob", "Ddeos", "Ddeoss", "Ddeong", "Ddeoh", "Dde", "Ddeg", "Dden", "Ddel", 
	"Ddem", "Ddeb", "Ddes", "Ddess", "Ddeng", "Ddyeo", "Ddyeoss", "Ddo", "Ddog", "Ddon", "Ddol", "Ddong", "Ddwa", "Ddwal", "Ddwae", "Ddoe", 
	"Ddoen", "Ddu", "Ddug", "Ddun", "Ddul", "Ddulh", "Ddum", "Ddung", "Ddwe", "Ddwi", "Ddwin", "Ddwil", "Ddwim", "Ddwib", "Ddwing", "Ddeu", 
	"Ddeug", "Ddeun", "Ddeud", "Ddeul", "Ddeum", "Ddeub", "Ddeus", "Ddyi", "Ddyin", "Ddyil", "Ddyim", "Ddyib", "Ddi", "Ddin", "Ddil", "Ddim", 
	"Ddib", "Ddis", "Dding", "Ra", "Rag", "Ran", "Ral", "Ram", "Rab", "Ras", "Rass", "Rang", "Raj", "Rap", "Rah", NULL };

	char * ksc5601_to_eng_7[] = { NULL, "Rae", "Raeg", "Raen", "Rael", "Raem", "Raeb", "Raes", "Raess", "Raeng", "Rya", "Ryag", "Ryan", "Ryas", "Ryang", "Reo", 
	"Reog", "Reon", "Reol", "Reom", "Reob", "Reos", "Reoss", "Reong", "Reoh", "Re", "Reg", "Ren", "Rel", "Rem", "Reb", "Res", 
	"Reng", "Ryeo", "Ryeog", "Ryeon", "Ryeol", "Ryeom", "Ryeob", "Ryeos", "Ryeoss", "Ryeong", "Rye", "Ryen", "Ryeb", "Ryes", "Ro", "Rog", 
	"Ron", "Rol", "Rom", "Rob", "Ros", "Rong", "Rwa", "Rwan", "Rwang", "Rwaess", "Roe", "Roen", "Roel", "Roem", "Roeb", "Roes", 
	"Roeng", "Ryo", "Ryon", "Ryol", "Ryob", "Ryos", "Ryong", "Ru", "Rug", "Run", "Rul", "Rum", "Rub", "Rus", "Rung", "Rweo", 
	"Rweoss", "Rwe", "Rwi", "Rwig", "Rwin", "Rwil", "Rwim", "Rwis", "Rwing", "Ryu", "Ryug", "Ryun", "Ryul", "Ryum", "Ryub", NULL };

	char * ksc5601_to_eng_8[] = { NULL, "Ryus", "Ryung", "Reu", "Reug", "Reun", "Reul", "Reum", "Reub", "Reus", "Reung", "Reuj", "Reut", "Reup", "Ri", "Rig", 
	"Rin", "Ril", "Rim", "Rib", "Ris", "Ring", "Ma", "Mag", "Man", "Manh", "Mad", "Mal", "Malg", "Malm", "Mam", "Mab", 
	"Mas", "Mang", "Maj", "Mat", "Mah", "Mae", "Maeg", "Maen", "Mael", "Maem", "Maeb", "Maes", "Maess", "Maeng", "Maej", "Mya", 
	"Myag", "Myal", "Myang", "Meo", "Meog", "Meon", "Meol", "Meolm", "Meom", "Meob", "Meos", "Meong", "Meoj", "Meoh", "Me", "Meg", 
	"Men", "Mel", "Mem", "Meb", "Mes", "Mess", "Meng", "Myeo", "Myeog", "Myeon", "Myeol", "Myeos", "Myeoss", "Myeong", "Myeoc", "Mye", 
	"Mo", "Mog", "Mogs", "Mon", "Mol", "Molm", "Mom", "Mob", "Mos", "Mong", "Mwa", "Mwan", "Mwass", "Mwang", "Moe", NULL };

	char * ksc5601_to_eng_9[] = { NULL, "Moen", "Moel", "Moeb", "Moes", "Moeng", "Myo", "Myon", "Myol", "Myob", "Myos", "Mu", "Mug", "Mugg", "Mun", "Mud", 
	"Mul", "Mulg", "Mulm", "Mum", "Mub", "Mus", "Mung", "Mut", "Muh", "Mweo", "Mweon", "Mweol", "Mweob", "Mweos", "Mwe", "Mwi", 
	"Mwin", "Mwil", "Myu", "Myun", "Myul", "Myum", "Myus", "Meu", "Meun", "Meul", "Meum", "Meus", "Mi", "Mig", "Min", "Mid", 
	"Mil", "Milm", "Mim", "Mib", "Mis", "Miss", "Ming", "Mic", "Mit", "Ba", "Bag", "Bagg", "Bags", "Ban", "Bad", "Bal", 
	"Balg", "Balm", "Balb", "Bam", "Bab", "Bas", "Bang", "Bat", "Bae", "Baeg", "Baen", "Bael", "Baem", "Baeb", "Baes", "Baess", 
	"Baeng", "Baet", "Bya", "Byag", "Byan", "Byab", "Beo", "Beog", "Beon", "Beod", "Beol", "Beolm", "Beom", "Beob", "Beos", NULL };

	char * ksc5601_to_eng_10[] = { NULL, "Beong", "Beoj", "Be", "Beg", "Ben", "Bed", "Bel", "Bem", "Beb", "Bes", "Bess", "Beng", "Byeo", "Byeog", "Byeon", 
	"Byeol", "Byeob", "Byeos", "Byeoss", "Byeong", "Byeot", "Bye", "Byen", "Bo", "Bog", "Bogg", "Bon", "Bol", "Bom", "Bob", "Bos", 
	"Bong", "Bwa", "Bwan", "Bwass", "Bwae", "Bwaess", "Boe", "Boeg", "Boen", "Boel", "Boem", "Boeb", "Byo", "Byon", "Bu", "Bug", 
	"Bun", "Bud", "Bul", "Bulg", "Bulm", "Bum", "Bub", "Bus", "Bung", "But", "Bup", "Bweo", "Bweol", "Bweoss", "Bwe", "Bwi", 
	"Bwig", "Bwin", "Bwil", "Bwing", "Byu", "Byun", "Byul", "Byum", "Byus", "Byung", "Beu", "Beug", "Beun", "Beul", "Beum", "Beub", 
	"Beus", "Bi", "Big", "Bin", "Bil", "Bilm", "Bim", "Bib", "Bis", "Bing", "Bij", "Bic", "Bba", "Bbag", "Bban", NULL };

	char * ksc5601_to_eng_11[] = { NULL, "Bbal", "Bbalm", "Bbam", "Bbab", "Bbas", "Bbass", "Bbang", "Bbah", "Bbae", "Bbaeg", "Bbaen", "Bbael", "Bbaem", "Bbaeb", "Bbaes", 
	"Bbaess", "Bbaeng", "Bbya", "Bbyag", "Bbyam", "Bbeo", "Bbeog", "Bbeon", "Bbeod", "Bbeol", "Bbeom", "Bbeos", "Bbeoss", "Bbeong", "Bbe", "Bbeng", 
	"Bbyeo", "Bbyeog", "Bbyeom", "Bbyeob", "Bbyeos", "Bbyeoss", "Bbyeong", "Bbo", "Bbog", "Bbon", "Bbol", "Bbom", "Bbob", "Bbong", "Bboe", "Bbyo", 
	"Bbyong", "Bbu", "Bbug", "Bbun", "Bbul", "Bbum", "Bbus", "Bbung", "Bbyu", "Bbyung", "Bbeu", "Bbeun", "Bbeul", "Bbeum", "Bbeub", "Bbi", 
	"Bbig", "Bbin", "Bbil", "Bbim", "Bbib", "Bbis", "Bbing", "Sa", "Sag", "Sags", "San", "Sad", "Sal", "Salg", "Salm", "Sam", 
	"Sab", "Sas", "Sass", "Sang", "Sat", "Sae", "Saeg", "Saen", "Sael", "Saem", "Saeb", "Saes", "Saess", "Saeng", "Sya", NULL };

	char * ksc5601_to_eng_12[] = { NULL, "Syag", "Syan", "Syal", "Syam", "Syab", "Syas", "Syang", "Syae", "Syaen", "Syael", "Syaem", "Syaeng", "Seo", "Seog", "Seogg", 
	"Seogs", "Seon", "Seod", "Seol", "Seolm", "Seolb", "Seom", "Seob", "Seos", "Seoss", "Seong", "Seop", "Se", "Seg", "Sen", "Sel", 
	"Sem", "Seb", "Ses", "Sess", "Seng", "Syeo", "Syeog", "Syeon", "Syeol", "Syeom", "Syeob", "Syeos", "Syeoss", "Syeong", "Sye", "Syen", 
	"Syel", "Syeng", "So", "Sog", "Sogg", "Son", "Sol", "Solm", "Som", "Sob", "Sos", "Song", "Sot", "Swa", "Swag", "Swan", 
	"Swal", "Swang", "Swae", "Swaen", "Swael", "Swaem", "Swaes", "Swaess", "Soe", "Soen", "Soel", "Soem", "Soeb", "Soes", "Syo", "Syog", 
	"Syon", "Syol", "Syom", "Syob", "Syos", "Syong", "Su", "Sug", "Sun", "Sud", "Sul", "Sum", "Sub", "Sus", "Sung", NULL };

	char * ksc5601_to_eng_13[] = { NULL, "Suc", "Sut", "Sup", "Sweo", "Sweoss", "Swe", "Sweg", "Swen", "Swel", "Swem", "Sweng", "Swi", "Swig", "Swin", "Swil", 
	"Swim", "Swib", "Swis", "Swing", "Syu", "Syug", "Syul", "Syum", "Syus", "Syung", "Seu", "Seug", "Seun", "Seul", "Seulg", "Seum", 
	"Seub", "Seus", "Seung", "Si", "Sig", "Sin", "Sid", "Sil", "Silh", "Sim", "Sib", "Sis", "Sing", "Sip", "Ssa", "Ssag", 
	"Ssags", "Ssan", "Ssal", "Ssam", "Ssab", "Ssass", "Ssang", "Ssah", "Ssae", "Ssaeg", "Ssaen", "Ssael", "Ssaem", "Ssaeb", "Ssaess", "Ssaeng", 
	"Ssyang", "Sseo", "Sseog", "Sseon", "Sseol", "Sseolm", "Sseom", "Sseob", "Sseoss", "Sseong", "Sse", "Ssen", "Ssel", "Ssyen", "Sso", "Ssog", 
	"Sson", "Ssod", "Ssol", "Ssolm", "Ssom", "Ssob", "Ssong", "Sswa", "Sswag", "Sswan", "Sswass", "Sswae", "Sswaess", "Ssoe", "Ssoen", NULL };

	char * ksc5601_to_eng_14[] = { NULL, "Ssoel", "Ssoem", "Ssoeb", "Ssyo", "Ssu", "Ssug", "Ssun", "Ssul", "Ssum", "Ssub", "Ssung", "Ssweo", "Ssweoss", "Sswe", "Sswi", 
	"Sswin", "Ssyung", "Sseu", "Sseug", "Sseun", "Sseul", "Sseulm", "Sseulh", "Sseum", "Sseub", "Ssyi", "Ssyin", "Ssyil", "Ssyim", "Ssi", "Ssig", 
	"Ssin", "Ssil", "Ssim", "Ssib", "Ssis", "Ssing", "A", "Ag", "An", "Anj", "Anh", "Al", "Alg", "Alm", "Alh", "Am", 
	"Ab", "As", "Ass", "Ang", "At", "Ap", "Ae", "Aeg", "Aen", "Ael", "Aem", "Aeb", "Aes", "Aess", "Aeng", "Ya", 
	"Yag", "Yan", "Yal", "Yalb", "Yam", "Yab", "Yas", "Yang", "Yat", "Yah", "Yae", "Yaen", "Yael", "Yaeb", "Eo", "Eog", 
	"Eon", "Eonj", "Eod", "Eol", "Eolg", "Eolm", "Eom", "Eob", "Eobs", "Eos", "Eoss", "Eong", "Eoj", "Eok", "Eop", NULL };

	char * ksc5601_to_eng_15[] = { NULL, "E", "Eg", "En", "El", "Em", "Eb", "Es", "Eng", "Yeo", "Yeog", "Yeogg", "Yeon", "Yeol", "Yeolm", "Yeolb", 
	"Yeom", "Yeob", "Yeobs", "Yeos", "Yeoss", "Yeong", "Yeot", "Yeop", "Yeoh", "Ye", "Yen", "Yel", "Yem", "Yeb", "Yes", "Yess", 
	"O", "Og", "On", "Ol", "Olg", "Olm", "Ols", "Olh", "Om", "Ob", "Os", "Ong", "Oc", "Wa", "Wag", "Wan", 
	"Wal", "Wam", "Wab", "Was", "Wass", "Wang", "Wae", "Waeg", "Waen", "Waem", "Waes", "Waeng", "Oe", "Oeg", "Oen", "Oel", 
	"Oem", "Oeb", "Oes", "Oeng", "Yo", "Yog", "Yon", "Yol", "Yom", "Yob", "Yos", "Yong", "U", "Ug", "Un", "Ul", 
	"Ulg", "Ulm", "Um", "Ub", "Us", "Ung", "Weo", "Weog", "Weon", "Weol", "Weom", "Weob", "Weoss", "Weong", "We", NULL };

	char * ksc5601_to_eng_16[] = { NULL, "Weg", "Wen", "Wel", "Wem", "Web", "Weng", "Wi", "Wig", "Win", "Wil", "Wim", "Wib", "Wis", "Wing", "Yu", 
	"Yug", "Yun", "Yul", "Yum", "Yub", "Yus", "Yung", "Yuc", "Eu", "Eug", "Eun", "Eul", "Eulp", "Eum", "Eub", "Eus", 
	"Eung", "Euj", "Euc", "Euk", "Eut", "Eup", "Euh", "Yi", "Yin", "Yil", "Yim", "Yis", "I", "Ig", "In", "Il", 
	"Ilg", "Ilm", "Ilh", "Im", "Ib", "Is", "Iss", "Ing", "Ij", "Ip", "Ja", "Jag", "Jan", "Janh", "Jad", "Jal", 
	"Jalm", "Jam", "Jab", "Jas", "Jass", "Jang", "Jaj", "Jae", "Jaeg", "Jaen", "Jael", "Jaem", "Jaeb", "Jaes", "Jaess", "Jaeng", 
	"Jya", "Jyag", "Jyan", "Jyanh", "Jyal", "Jyam", "Jyang", "Jyae", "Jyaen", "Jyael", "Jeo", "Jeog", "Jeon", "Jeol", "Jeolm", NULL };

	char * ksc5601_to_eng_17[] = { NULL, "Jeom", "Jeob", "Jeos", "Jeong", "Jeoj", "Je", "Jeg", "Jen", "Jel", "Jem", "Jeb", "Jes", "Jeng", "Jyeo", "Jyeon", 
	"Jyeol", "Jyeom", "Jyeob", "Jyeoss", "Jyeong", "Jye", "Jo", "Jog", "Jon", "Jol", "Jolm", "Jom", "Job", "Jos", "Jong", "Joj", 
	"Joc", "Joh", "Jwa", "Jwag", "Jwal", "Jwab", "Jwas", "Jwang", "Jwae", "Jwaess", "Jwaeng", "Joe", "Joen", "Joel", "Joem", "Joeb", 
	"Joes", "Joeng", "Jyo", "Jyog", "Jyon", "Jyong", "Ju", "Jug", "Jun", "Jul", "Julg", "Julm", "Jum", "Jub", "Jus", "Jung", 
	"Jweo", "Jweoss", "Jwe", "Jwi", "Jwig", "Jwin", "Jwil", "Jwim", "Jwib", "Jwis", "Jyu", "Jyun", "Jyul", "Jyum", "Jeu", "Jeug", 
	"Jeun", "Jeul", "Jeum", "Jeub", "Jeus", "Jeung", "Ji", "Jig", "Jin", "Jid", "Jil", "Jilm", "Jim", "Jib", "Jis", NULL };

	char * ksc5601_to_eng_18[] = { NULL, "Jing", "Jij", "Jit", "Jip", "Jja", "Jjag", "Jjan", "Jjanh", "Jjal", "Jjalb", "Jjam", "Jjab", "Jjas", "Jjass", "Jjang", 
	"Jjae", "Jjaeg", "Jjaen", "Jjael", "Jjaem", "Jjaeb", "Jjaes", "Jjaess", "Jjaeng", "Jjya", "Jjyan", "Jjyang", "Jjeo", "Jjeog", "Jjeon", "Jjeol", 
	"Jjeom", "Jjeob", "Jjeos", "Jjeoss", "Jjeong", "Jje", "Jjeng", "Jjyeo", "Jjyeoss", "Jjo", "Jjog", "Jjon", "Jjol", "Jjom", "Jjob", "Jjos", 
	"Jjong", "Jjoc", "Jjwa", "Jjwag", "Jjwal", "Jjwass", "Jjwae", "Jjwaess", "Jjoe", "Jjoen", "Jjoel", "Jjoem", "Jjoeb", "Jjyong", "Jju", "Jjug", 
	"Jjun", "Jjul", "Jjum", "Jjub", "Jjung", "Jjweo", "Jjweoss", "Jjweong", "Jjwi", "Jjyu", "Jjeu", "Jjeum", "Jjeus", "Jjeung", "Jji", "Jjig", 
	"Jjin", "Jjil", "Jjim", "Jjib", "Jjing", "Jjij", "Jjih", "Ca", "Cag", "Can", "Canh", "Cal", "Cam", "Cab", "Cas", NULL };

	char * ksc5601_to_eng_19[] = { NULL, "Cass", "Cang", "Caj", "Cae", "Caeg", "Caen", "Cael", "Caem", "Caeb", "Caes", "Caess", "Caeng", "Cya", "Cyan", "Cyanh", 
	"Cyal", "Cyam", "Cyang", "Ceo", "Ceog", "Ceon", "Ceol", "Ceom", "Ceob", "Ceos", "Ceoss", "Ceong", "Ce", "Ceg", "Cen", "Cel", 
	"Cem", "Ceb", "Ces", "Ceng", "Cyeo", "Cyeon", "Cyeoss", "Cye", "Cyen", "Cyeng", "Co", "Cog", "Con", "Col", "Com", "Cob", 
	"Cos", "Cong", "Cwa", "Cwan", "Cwal", "Cwang", "Coe", "Coen", "Coel", "Coem", "Coeb", "Coes", "Coeng", "Cyo", "Cyom", "Cu", 
	"Cug", "Cun", "Cul", "Cum", "Cub", "Cus", "Cung", "Cweo", "Cweoss", "Cwe", "Cwen", "Cwi", "Cwin", "Cwil", "Cwim", "Cwib", 
	"Cwis", "Cwing", "Cyu", "Cyun", "Cyul", "Cyum", "Cyung", "Ceu", "Ceug", "Ceun", "Ceul", "Ceum", "Ceub", "Ceus", "Ceung", NULL };

	char * ksc5601_to_eng_20[] = { NULL, "Ci", "Cig", "Cin", "Cid", "Cil", "Cilg", "Cim", "Cib", "Cis", "Cing", "Ka", "Kag", "Kan", "Kal", "Kam", 
	"Kab", "Kas", "Kang", "Kae", "Kaeg", "Kaen", "Kael", "Kaem", "Kaeb", "Kaes", "Kaess", "Kaeng", "Kya", "Kyag", "Kyang", "Keo", 
	"Keog", "Keon", "Keod", "Keol", "Keom", "Keob", "Keos", "Keoss", "Keong", "Ke", "Keg", "Ken", "Kel", "Kem", "Keb", "Kes", 
	"Keng", "Kyeo", "Kyeon", "Kyeol", "Kyeom", "Kyeob", "Kyeos", "Kyeoss", "Kyeong", "Kye", "Ko", "Kog", "Kon", "Kol", "Kom", "Kob", 
	"Kos", "Kong", "Kwa", "Kwag", "Kwan", "Kwal", "Kwam", "Kwang", "Kwae", "Kwaeng", "Koe", "Koel", "Kyo", "Ku", "Kug", "Kun", 
	"Kul", "Kum", "Kub", "Kus", "Kung", "Kweo", "Kweon", "Kweol", "Kweong", "Kwe", "Kweng", "Kwi", "Kwig", "Kwin", "Kwil", NULL };

	char * ksc5601_to_eng_21[] = { NULL, "Kwim", "Kwib", "Kwis", "Kwing", "Kyu", "Kyun", "Kyul", "Kyum", "Keu", "Keug", "Keun", "Keul", "Keum", "Keub", "Keung", 
	"Ki", "Kig", "Kin", "Kil", "Kim", "Kib", "Kis", "King", "Ta", "Tag", "Tan", "Tal", "Talg", "Tam", "Tab", "Tas", 
	"Tass", "Tang", "Tae", "Taeg", "Taen", "Tael", "Taem", "Taeb", "Taes", "Taess", "Taeng", "Tya", "Tyang", "Teo", "Teog", "Teon", 
	"Teol", "Teolm", "Teom", "Teob", "Teos", "Teoss", "Teong", "Te", "Teg", "Ten", "Tel", "Tem", "Teb", "Tes", "Teng", "Tyeo", 
	"Tyeon", "Tyeoss", "Tye", "Tyen", "To", "Tog", "Ton", "Tol", "Tom", "Tob", "Tos", "Tong", "Top", "Twa", "Twan", "Twae", 
	"Toe", "Toen", "Toes", "Toeng", "Tyo", "Tu", "Tug", "Tun", "Tul", "Tum", "Tub", "Tus", "Tung", "Tweo", "Tweoss", NULL };

	char * ksc5601_to_eng_22[] = { NULL, "Twe", "Twi", "Twig", "Twin", "Twil", "Twim", "Twib", "Twing", "Tyu", "Tyun", "Tyul", "Tyum", "Tyung", "Teu", "Teug", 
	"Teun", "Teud", "Teul", "Teulm", "Teum", "Teub", "Teus", "Tyi", "Tyin", "Tyil", "Tyim", "Tyib", "Ti", "Tig", "Tin", "Til", 
	"Tim", "Tib", "Tis", "Ting", "Pa", "Pag", "Pagg", "Pan", "Pal", "Palm", "Pam", "Pab", "Pas", "Pass", "Pang", "Pat", 
	"Pae", "Paeg", "Paen", "Pael", "Paem", "Paeb", "Paes", "Paess", "Paeng", "Pya", "Pyag", "Peo", "Peog", "Peon", "Peol", "Peom", 
	"Peob", "Peos", "Peoss", "Peong", "Pe", "Peg", "Pen", "Pel", "Pem", "Peb", "Pes", "Peng", "Pyeo", "Pyeon", "Pyeol", "Pyeom", 
	"Pyeob", "Pyeoss", "Pyeong", "Pye", "Pyel", "Pyeb", "Pyes", "Po", "Pog", "Pon", "Pol", "Pom", "Pob", "Pos", "Pong", NULL };

	char * ksc5601_to_eng_23[] = { NULL, "Pwa", "Pwang", "Poe", "Poen", "Pyo", "Pyon", "Pyol", "Pyob", "Pyos", "Pu", "Pug", "Pun", "Pud", "Pul", "Pulm", 
	"Pum", "Pub", "Pus", "Pung", "Pweo", "Pweong", "Pwi", "Pwin", "Pwil", "Pwim", "Pwis", "Pyu", "Pyun", "Pyul", "Pyum", "Pyus", 
	"Pyung", "Peu", "Peun", "Peul", "Peum", "Peub", "Peus", "Pi", "Pig", "Pin", "Pil", "Pim", "Pib", "Pis", "Ping", "Ha", 
	"Hag", "Han", "Hal", "Halt", "Ham", "Hab", "Has", "Hang", "Hae", "Haeg", "Haen", "Hael", "Haem", "Haeb", "Haes", "Haess", 
	"Haeng", "Hya", "Hyang", "Heo", "Heog", "Heon", "Heol", "Heolm", "Heom", "Heob", "Heos", "Heong", "He", "Heg", "Hen", "Hel", 
	"Hem", "Heb", "Hes", "Heng", "Hyeo", "Hyeog", "Hyeon", "Hyeol", "Hyeom", "Hyeob", "Hyeos", "Hyeoss", "Hyeong", "Hye", "Hyen", NULL };

	char * ksc5601_to_eng_24[] = { NULL, "Hyel", "Hyeb", "Ho", "Hog", "Hon", "Hol", "Holt", "Hom", "Hob", "Hos", "Hong", "Hot", "Hwa", "Hwag", "Hwan", 
	"Hwal", "Hwas", "Hwang", "Hwae", "Hwaeg", "Hwaen", "Hwaes", "Hwaeng", "Hoe", "Hoeg", "Hoen", "Hoel", "Hoeb", "Hoes", "Hoeng", "Hyo", 
	"Hyon", "Hyol", "Hyob", "Hyos", "Hu", "Hug", "Hun", "Hul", "Hult", "Hum", "Hus", "Hung", "Hweo", "Hweon", "Hweol", "Hweom", 
	"Hweong", "Hwe", "Hweg", "Hwen", "Hwel", "Hweng", "Hwi", "Hwig", "Hwin", "Hwil", "Hwim", "Hwib", "Hwis", "Hwing", "Hyu", "Hyug", 
	"Hyun", "Hyul", "Hyum", "Hyus", "Hyung", "Heu", "Heug", "Heun", "Heunh", "Heud", "Heul", "Heulg", "Heum", "Heub", "Heus", "Heung", 
	"Heut", "Hyi", "Hyin", "Hyil", "Hyim", "Hyib", "Hying", "Hi", "Hig", "Hin", "Hil", "Him", "Hib", "His", "Hing", NULL };

	MALLOC(haneng, unsigned int *, 27);

	haneng[0] = (unsigned int *) ksc5601_to_eng_25;
	haneng[1] = (unsigned int *) ksc5601_to_eng_26;
	haneng[2] = (unsigned int *) ksc5601_to_eng_0;
	haneng[3] = (unsigned int *) ksc5601_to_eng_1;
	haneng[4] = (unsigned int *) ksc5601_to_eng_2;
	haneng[5] = (unsigned int *) ksc5601_to_eng_3;
	haneng[6] = (unsigned int *) ksc5601_to_eng_4;
	haneng[7] = (unsigned int *) ksc5601_to_eng_5;
	haneng[8] = (unsigned int *) ksc5601_to_eng_6;
	haneng[9] = (unsigned int *) ksc5601_to_eng_7;
	haneng[10] = (unsigned int *) ksc5601_to_eng_8;
	haneng[11] = (unsigned int *) ksc5601_to_eng_9;
	haneng[12] = (unsigned int *) ksc5601_to_eng_10;
	haneng[13] = (unsigned int *) ksc5601_to_eng_11;
	haneng[14] = (unsigned int *) ksc5601_to_eng_12;
	haneng[15] = (unsigned int *) ksc5601_to_eng_13;
	haneng[16] = (unsigned int *) ksc5601_to_eng_14;
	haneng[17] = (unsigned int *) ksc5601_to_eng_15;
	haneng[18] = (unsigned int *) ksc5601_to_eng_16;
	haneng[19] = (unsigned int *) ksc5601_to_eng_17;
	haneng[20] = (unsigned int *) ksc5601_to_eng_18;
	haneng[21] = (unsigned int *) ksc5601_to_eng_19;
	haneng[22] = (unsigned int *) ksc5601_to_eng_20;
	haneng[23] = (unsigned int *) ksc5601_to_eng_21;
	haneng[24] = (unsigned int *) ksc5601_to_eng_22;
	haneng[25] = (unsigned int *) ksc5601_to_eng_23;
	haneng[26] = (unsigned int *) ksc5601_to_eng_24;

	c1 = ((char)c1) & 0xff;
	c2 = ((char)c2) & 0xff;

	s1 = haneng[0][(c1-0xa0)];
	s2 = (char **) haneng[s1];
	s3 = s2[(c2-0xa0)];

	if(s3 == NULL){
		free(haneng);
		return NULL;
	}

	ret = malloc(strlen(s3)+1);
	memset(ret, '\0', strlen(s3)+1);
	memcpy(ret, s3, strlen(s3));

	free(haneng);
	return s3;
}

char *
hg_haneng(char * src)
{
	int i=0, j=0;
	char * c, * dst;

	dst = (char *) malloc(0x100);
	memset(dst, '\0', 0x100);

	while(src[i] != '\0') {
		if(hg_ishangul(src[i], src[i+1])) {
			c = hg_ksc5601_to_eng(src[i], src[i+1]);
			i+=2;
		} else {
			c = (char *) malloc(2);
			c[0] = src[i];
			c[1] = '\0';
			i++;
		}
		memcpy(dst+j, c, strlen(c));
		j += strlen(c);
	}

	return dst;
}


/* ѱ DFA ȯ ̺.
 *
 * ̰ ""    ""   иϴ  մϴ. */
unsigned int **
hg_make_hgdfa_b(void)
{
	unsigned int ** hg_dfa_a4;

	unsigned int ksc5601_to_a4_0[] = {
		-1, 0x0, 0x0, 0x0, 0x1, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
		0x2, 0x3, 0x4, 0x5, 0x6, 0x7, 0x8, 0x9, 0xa, 0xb, 0xc, 0xd, 0xe, 0xf, 0x10, 0x11, 
		0x12, 0x13, 0x14, 0x15, 0x16, 0x17, 0x18, 0x19, 0x1a, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
		0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
		0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
		0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 
	};

	/* ʼ ߼      Ʒ    
	 * ȯϰ ˴ϴ. */
	unsigned int ksc5601_to_a4_1[] = {
		-1, 0xa1ffa1, 0xa2ffa2, 0xffffa3, 0xa4ffa4, 0xffffa5, 0xffffa6, 0xa7ffa7, 0xa8ffff, 0xa9ffa9, 0xffffaa, 0xffffab, 0xffffac, 0xffffad, 0xffffae, 0xffffaf, 
		0xffffb0, 0xb1ffb1, 0xb2ffb2, 0xb3ffff, 0xffffb4, 0xb5ffb5, 0xb6ffb6, 0xb7ffb7, 0xb8ffb8, 0xb9ffff, 0xbaffba, 0xbbffbb, 0xbcffbc, 0xbdffbd, 0xbeffbe, 0xffbfff, 
		0xffc0ff, 0xffc1ff, 0xffc2ff, 0xffc3ff, 0xffc4ff, 0xffc5ff, 0xffc6ff, 0xffc7ff, 0xffc8ff, 0xffc9ff, 0xffcaff, 0xffcbff, 0xffccff, 0xffcdff, 0xffceff, 0xffcfff, 
		0xffd0ff, 0xffd1ff, 0xffd2ff, 0xffd3ff, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
		0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 
		0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0 
	};

	unsigned int ksc5601_to_a4_2[] = {
		-1, 0xa1bf00, 0xa1bfa1, 0xa1bfa4, 0xa1bfa7, 0xa1bfa9, 0xa1bfaa, 0xa1bfab, 0xa1bfb1, 0xa1bfb2, 0xa1bfb4, 0xa1bfb5, 0xa1bfb6, 0xa1bfb7, 0xa1bfb8, 0xa1bfba, 
		0xa1bfbc, 0xa1bfbd, 0xa1bfbe, 0xa1c000, 0xa1c0a1, 0xa1c0a4, 0xa1c0a9, 0xa1c0b1, 0xa1c0b2, 0xa1c0b5, 0xa1c0b6, 0xa1c0b7, 0xa1c100, 0xa1c1a1, 0xa1c1a4, 0xa1c1a9, 
		0xa1c1b5, 0xa1c1b7, 0xa1c2a1, 0xa1c2a4, 0xa1c2a9, 0xa1c300, 0xa1c3a1, 0xa1c3a4, 0xa1c3a7, 0xa1c3a9, 0xa1c3ab, 0xa1c3b1, 0xa1c3b2, 0xa1c3b5, 0xa1c3b6, 0xa1c3b7, 
		0xa1c3b8, 0xa1c3bc, 0xa1c3bd, 0xa1c3be, 0xa1c400, 0xa1c4a4, 0xa1c4a9, 0xa1c4b1, 0xa1c4b2, 0xa1c4b5, 0xa1c4b6, 0xa1c4b7, 0xa1c500, 0xa1c5a1, 0xa1c5a2, 0xa1c5a4, 
		0xa1c5a7, 0xa1c5a9, 0xa1c5b1, 0xa1c5b2, 0xa1c5b5, 0xa1c5b6, 0xa1c5b7, 0xa1c5bc, 0xa2c600, 0xa1c6a4, 0xa1c6a9, 0xa1c6b2, 0xa1c6b5, 0xa1c700, 0xa1c7a1, 0xa1c7a4, 
		0xa1c7a7, 0xa1c7a9, 0xa1c7ab, 0xa1c7ad, 0xa1c7b0, 0xa1c7b1, 0xa1c7b2, 0xa1c7b5, 0xa1c7b7, 0xa1c7b8, 0xa1c800, 0xa1c8a1, 0x0, 0xa1c8a9, 0xa1c8ab, 0x0 
		};



	unsigned int ksc5601_to_a4_3[] = {
		-1, 0xa1c8b1, 0xa1c8b2, 0xa1c8b5, 0xa1c8b7, 0xa1c900, 0xa1c9a4, 0xa1c9a9, 0xa1c9b2, 0xa1c9b6, 0xa1c9b7, 0xa1ca00, 0xa1caa1, 0xa1caa4, 0xa1caa9, 0xa1cab1, 
		0xa1cab2, 0xa1cab5, 0xa1cab7, 0xa1cb00, 0xa1cba4, 0xa1cba9, 0xa1cbb2, 0xa1cbb5, 0xa1cc00, 0xa1cca1, 0xa1cca4, 0xa1cca7, 0xa1cca9, 0xa1ccaa, 0xa1ccab, 0xa1ccb0, 
		0xa1ccb1, 0xa1ccb2, 0xa1ccb5, 0xa1ccb7, 0xa1ccb8, 0xa1cd00, 0xa1cda1, 0xa1cda4, 0xa1cda9, 0xa1cdb6, 0xa1cdb7, 0xa1ce00, 0xa1ceb5, 0xa1cf00, 0xa1cfa1, 0xa1cfa4, 
		0xa1cfa9, 0xa1cfb1, 0xa1cfb2, 0xa1cfb5, 0xa1d000, 0xa1d0a4, 0xa1d0a9, 0xa1d100, 0xa1d1a1, 0xa1d1a4, 0xa1d1a7, 0xa1d1a9, 0xa1d1aa, 0xa1d1b1, 0xa1d1b2, 0xa1d1b5, 
		0xa1d1b7, 0xa1d200, 0xa1d300, 0xa1d3a1, 0xa1d3a4, 0xa1d3a7, 0xa1d3a9, 0xa1d3ab, 0xa1d3b1, 0xa1d3b2, 0xa1d3b5, 0xa1d3b7, 0xa1d3b8, 0xa1d3bd, 0xa2bf00, 0xa2bfa1, 
		0xa2bfa2, 0x0, 0xa2bfa9, 0xa2bfab, 0xa2bfb1, 0x0, 0xa2bfb5, 0x0, 0xa2bfb7, 0xa2bfbc, 0xa2c000, 0xa2c0a1, 0xa2c0a4, 0xa2c0a9, 0xa2c0b1, 0x0 
	};

	unsigned int ksc5601_to_a4_4[] = {
		-1, 0xa2c0b2, 0xa2c0b5, 0xa2c0b6, 0xa2c0b7, 0xa2c100, 0xa2c1a1, 0xa2c1a9, 0xa2c300, 0xa2c3a1, 0xa2c3a2, 0xa2c3a4, 0xa2c3a9, 0xa2c3b1, 0xa2c3b2, 0xa2c3b5, 
		0xa2c3b6, 0xa2c3b7, 0xa2c400, 0xa2c4a1, 0xa2c4a4, 0xa2c4b1, 0xa2c4b5, 0xa2c4b7, 0xa2c500, 0xa2c5a4, 0xa2c5a9, 0xa2c5b5, 0xa2c5b6, 0xa2c5bc, 0x0, 0xa2c700, 
		0xa2c7a1, 0xa2c7a4, 0xa2c7a6, 0xa2c7a9, 0xa2c7b1, 0xa2c7b2, 0xa2c7b5, 0xa2c7b7, 0xa2c7b8, 0xa2c7ba, 0xa2c800, 0xa2c8a1, 0xa2c8a9, 0xa2c8b6, 0xa2c8b7, 0xa2c900, 
		0xa2c9a1, 0xa2ccb7, 0xa2ca00, 0xa2caa4, 0xa2caa9, 0xa2cab1, 0xa2cab2, 0xa2cab7, 0xa2cb00, 0xa2cc00, 0xa2cca1, 0xa2cca4, 0xa2cca9, 0xa2ccb0, 0xa2ccb1, 0xa2ccb2, 
		0xa2ccb5, 0x0, 0xa2ccb8, 0xa2cd00, 0xa2cda9, 0xa2cdb6, 0xa2cdb7, 0xa2ce00, 0xa2cea1, 0xa2cea4, 0xa2cea9, 0xa2ceb1, 0xa2ceb2, 0xa2ceb6, 0xa2cf00, 0xa2cfa4, 
		0xa2cfa9, 0xa2cfb1, 0xa2cfb2, 0xa2d000, 0xa2d100, 0xa2d1a1, 0xa2d1a4, 0xa2d1a6, 0xa2d1a9, 0xa2d1ab, 0xa2d1b0, 0xa2d1b1, 0xa2d1b2, 0xa2d1b5, 0xa2d1b7, 0x0 
	};

	unsigned int ksc5601_to_a4_5[] = {
		-1, 0xa2d1bc, 0xa2d300, 0xa2d3a1, 0xa2d3a4, 0xa2d3a9, 0xa2d3b1, 0xa2d3b2, 0xa2d3b5, 0xa2d3b7, 0xa4bf00, 0xa4bfa1, 0xa4bfa2, 0xa4bfa4, 0xa4bfa7, 0xa4bfa9, 
		0xa4bfaa, 0xa4bfab, 0xa4bfb1, 0xa4bfb2, 0xa4bfb5, 0xa4bfb6, 0xa4bfb7, 0xa4bfb8, 0xa4bfba, 0xa4bfbc, 0xa4bfbe, 0xa4c000, 0xa4c0a1, 0xa4c0a4, 0xa4c0a9, 0xa4c0b1, 
		0xa4c0b2, 0xa4c0b5, 0xa4c0b6, 0xa4c0b7, 0xa4c100, 0xa4c1a1, 0xa4c1a4, 0xa4c1a9, 0xa4c1b1, 0xa4c1b7, 0xa4c300, 0xa4c3a1, 0xa4c3a3, 0xa4c3a4, 0xa4c3a9, 0xa4c3ab, 
		0xa4c3ac, 0xa4c3b1, 0xa4c3b2, 0xa4c3b5, 0xa4c3b6, 0xa4c3b7, 0xa4c3be, 0xa4c400, 0xa4c4a1, 0xa4c4a4, 0xa4c4a9, 0xa4c4b1, 0xa4c4b2, 0xa4c4b5, 0xa4c4b6, 0xa4c4b7, 
		0xa4c500, 0xa4c5a1, 0xa4c5a4, 0xa4c5a9, 0xa4c5b1, 0xa4c5b2, 0xa4c5b6, 0xa4c5b7, 0xa4c5bb, 0xa4c600, 0xa4c6a4, 0xa4c700, 0xa4c7a1, 0xa4c7a4, 0xa4c7a9, 0xa4c7ab, 
		0xa4c7b1, 0xa4c7b2, 0xa4c7b5, 0xa4c7b7, 0xa4c7bd, 0xa4c7be, 0xa4c800, 0xa4c8a4, 0xa4c8a9, 0xa4c8b6, 0xa4ca00, 0xa4caa4, 0x0, 0xa4cab1, 0xa4cab2, 0x0 
	};

	unsigned int ksc5601_to_a4_6[] = {
		-1, 0xa4cab5, 0xa4cb00, 0xa4cba1, 0xa4cba4, 0xa4cba9, 0xa4cbb2, 0xa4cbb5, 0xa4cbb7, 0xa4cc00, 0xa4cca1, 0xa4cca4, 0xa4cca7, 0xa4cca9, 0xa4ccb1, 0xa4ccb2, 
		0xa4ccb5, 0xa4ccb7, 0xa4cd00, 0xa4cdb6, 0xa4ce00, 0xa4cf00, 0xa4cfa4, 0xa4cfa9, 0xa4cfb1, 0xa4cfb2, 0xa4d000, 0xa4d0a1, 0xa4d0a9, 0xa4d0b1, 0xa4d0b2, 0xa4d0b7, 
		0xa4d100, 0xa4d1a1, 0xa4d1a4, 0xa4d1a9, 0xa4d1aa, 0xa4d1ab, 0xa4d1b1, 0xa4d1b2, 0xa4d1b5, 0xa4d1b7, 0xa4d1b8, 0xa4d1bd, 0xa4d200, 0xa4d2a4, 0xa4d2a9, 0xa4d300, 
		0xa4d3a1, 0xa4d3a4, 0xa4d3a9, 0xa4d3ab, 0xa4d3b1, 0xa4d3b2, 0xa4d3b5, 0xa4d3b7, 0xa4d3bd, 0xa7bf00, 0xa7bfa1, 0xa7bfa2, 0xa7bfa4, 0xa7bfa7, 0xa7bfa9, 0xa7bfaa, 
		0xa7bfab, 0xa7bfac, 0xa7bfb0, 0xa7bfb1, 0xa7bfb2, 0xa7bfb5, 0xa7bfb6, 0xa7bfb7, 0xa7bfb8, 0xa7bfba, 0xa7bfbe, 0xa7c000, 0xa7c0a1, 0xa7c0a4, 0xa7c0a9, 0xa7c0b1, 
		0xa7c0b2, 0xa7c0b5, 0xa7c0b6, 0xa7c0b7, 0xa7c100, 0xa7c300, 0xa7c3a1, 0xa7c3a2, 0xa7c3a4, 0xa7c3a7, 0xa7c3a9, 0xa7c3ab, 0xa7c3ac, 0xa7c3b1, 0xa7c3b2, 0x0 
	};

	unsigned int ksc5601_to_a4_7[] = {
		-1, 0xa7c3b5, 0xa7c3b7, 0xa7c3ba, 0xa7c3bd, 0xa7c400, 0xa7c4a1, 0xa7c4a4, 0xa7c4a9, 0xa7c4b1, 0xa7c4b2, 0xa7c4b5, 0xa7c4b6, 0xa7c4b7, 0xa7c500, 0xa7c5a4, 
		0xa7c5a9, 0xa7c5b6, 0xa7c5b7, 0xa7c600, 0xa7c6a4, 0xa7c700, 0xa7c7a1, 0xa7c7a7, 0x0, 0xa7c7a9, 0xa7c7ab, 0xa7c7ad, 0xa7c7b1, 0xa7c7b2, 0xa7c7b5, 0xa7c7b7, 
		0xa7c7ba, 0xa7c7bc, 0xa7c800, 0xa7c8a4, 0xa7c8a9, 0xa7c900, 0xa7c9b6, 0xa7ca00, 0xa7caa4, 0xa7caa9, 0xa7cab1, 0xa7cab2, 0xa7cab5, 0xa7cb00, 0xa7cc00, 0xa7cca1, 
		0xa7cca4, 0xa7cca9, 0xa7ccb1, 0xa7ccb2, 0xa7ccb5, 0xa7ccb7, 0xa7cd00, 0xa7cdb5, 0xa7ce00, 0xa7ceb7, 0xa7cf00, 0xa7cfa4, 0xa7cfa9, 0xa7cfb2, 0xa7cfb5, 0xa7cfb7, 
		0xa7d000, 0xa7d0a4, 0xa7d0a9, 0xa7d0b1, 0xa7d0b2, 0xa7d100, 0xa7d1a1, 0xa7d1a4, 0xa7d1a7, 0xa7d1a9, 0xa7d1ab, 0xa7d1b1, 0xa7d1b2, 0xa7d1b5, 0xa7d1b7, 0xa7d200, 
		0xa7d300, 0xa7d3a1, 0xa7d3a4, 0xa7d3a7, 0xa7d3a9, 0xa7d3b1, 0xa7d3b2, 0xa7d3b5, 0xa7d3b6, 0xa7d3b7, 0xa7d3b8, 0xa8bf00, 0xa8bfa1, 0xa8bfa4, 0xa8bfa9, 0x0 
	};

	unsigned int ksc5601_to_a4_8[] = {
		-1, 0xa8bfb1, 0xa8bfb2, 0xa8bfb5, 0xa8bfb6, 0xa8bfb7, 0xa8bfbe, 0xa8c000, 0xa8c0a1, 0xa8c0a4, 0xa8c0a9, 0xa8c0b1, 0xa8c0b2, 0xa8c0b5, 0xa8c0b6, 0xa8c0b7, 
		0xa8c300, 0xa8c3a1, 0xa8c3a4, 0xa8c3a9, 0xa8c3ab, 0xa8c3ac, 0xa8c3b1, 0xa8c3b2, 0xa8c3b5, 0xa8c3b6, 0xa8c3b7, 0xa8c3be, 0xa8c400, 0xa8c4a1, 0xa8c4a4, 0xa8c4a9, 
		0xa8c4b1, 0xa8c4b2, 0xa8c4b5, 0xa8c4b6, 0xa8c4b7, 0xa8c500, 0xa8c5b6, 0xa8c700, 0xa8c7a1, 0xa8c7a4, 0xa8c7a9, 0xa8c7b7, 0xa8c800, 0xa8c8a9, 0xa8c900, 0xa8ca00, 
		0xa8caa4, 0xa8cc00, 0xa8cca1, 0xa8cca4, 0xa8cca9, 0xa8ccb0, 0xa8ccb1, 0xa8ccb7, 0xa8ce00, 0xa8cf00, 0xa8cfa4, 0xa8cfa9, 0xa8cfb1, 0xa8cfb2, 0xa8cfb7, 0xa8d100, 
		0xa8d1a1, 0xa8d1a4, 0xa8d1a7, 0xa8d1a9, 0xa8d1b1, 0xa8d1b2, 0xa9cbb7, 0xa8d200, 0xa8d2a4, 0xa8d2a9, 0xa8d2b1, 0xa8d2b2, 0xa8d300, 0xa8d3a4, 0xa8d3a9, 0xa8d3b1, 
		0xa8d3b2, 0xa8d3b5, 0xa8d3b7, 0xa9bf00, 0xa9bfa1, 0xa9bfa4, 0xa9bfa9, 0xa9bfb1, 0xa9bfb2, 0xa9bfb5, 0xa9bfb6, 0xa9bfb7, 0xa9bfb8, 0xa9bfbd, 0xa9bfbe, 0x0 
	};

	unsigned int ksc5601_to_a4_9[] = {
		-1, 0xa9c000, 0xa9c0a1, 0xa9c0a4, 0xa9c0a9, 0xa9c0b1, 0xa9c0b2, 0xa9c0b5, 0xa9c0b6, 0xa9c0b7, 0xa9c100, 0xa9c1a1, 0xa9c1a4, 0xa9c1b5, 0xa9c1b7, 0xa9c300, 
		0xa9c3a1, 0xa9c3a4, 0xa9c3a9, 0xa9c3b1, 0xa9c3b2, 0xa9c3b5, 0xa9c3b6, 0xa9c3b7, 0xa9c3be, 0xa9c400, 0xa9c4a1, 0xa9c4a4, 0xa9c4a9, 0xa9c4b1, 0xa9c4b2, 0xa9c4b5, 
		0xa9c4b7, 0xa9c500, 0xa9c5a1, 0xa9c5a4, 0xa9c5a9, 0xa9c5b1, 0xa9c5b2, 0xa9c5b5, 0xa9c5b6, 0x0, 0xa9c600, 0xa9c6a4, 0xa9c6b2, 0xa9c6b5, 0xa9c700, 0xa9c7a1, 
		0xa9c7a4, 0xa9c7a9, 0xa9c7b1, 0xa9c7b2, 0xa9c7b5, 0xa9c7b7, 0xa9c800, 0xa9c8a4, 0xa9c8b7, 0xa9c9b6, 0xa9ca00, 0xa9caa4, 0xa9caa9, 0xa9cab1, 0xa9cab2, 0xa9cab5, 
		0xa9cab7, 0xa9cb00, 0xa9cba4, 0xa9cba9, 0x0, 0xa9cbb5, 0x0, 0xa9cc00, 0xa9cca1, 0xa9cca4, 0xa9cca9, 0xa9ccb1, 0xa9ccb2, 0xa9ccb5, 0xa9ccb7, 0xa9cd00, 
		0xa9cdb6, 0xa9ce00, 0xa9cf00, 0xa9cfa1, 0xa9cfa4, 0xa9cfa9, 0xa9cfb1, 0xa9cfb5, 0xa9cfb7, 0xa9d000, 0xa9d0a1, 0xa9d0a4, 0xa9d0a9, 0xa9d0b1, 0xa9d0b2, 0x0 
	};

	unsigned int ksc5601_to_a4_10[] = {
		-1, 0xa9d0b5, 0xa9d0b7, 0xa9d100, 0xa9d1a1, 0xa9d1a4, 0xa9d1a9, 0xa9d1b1, 0xa9d1b2, 0xa9d1b5, 0xa9d1b7, 0xa9d1b8, 0xa9d1bc, 0xa9d1bd, 0xa9d300, 0xa9d3a1, 
		0xa9d3a4, 0xa9d3a9, 0xa9d3b1, 0xa9d3b2, 0xa9d3b5, 0xa9d3b7, 0xb1bf00, 0xb1bfa1, 0xb1bfa4, 0xb1bfa6, 0xb1bfa7, 0xb1bfa9, 0xb1bfaa, 0xb1bfab, 0xb1bfb1, 0xb1bfb2, 
		0xb1bfb5, 0xb1bfb7, 0xb1bfb8, 0xb1bfbc, 0xb1bfbe, 0xb1c000, 0xb1c0a1, 0xb1c0a4, 0xb1c0a9, 0xb1c0b1, 0xb1c0b2, 0xb1c0b5, 0xb1c0b6, 0xb1c0b7, 0xb1c0b8, 0xb1c100, 
		0xb1c1a1, 0xb1c1a9, 0xb1c1b7, 0xb1c300, 0xb1c3a1, 0xb1c3a4, 0xb1c3a9, 0xb1c3ab, 0xb1c3b1, 0xb1c3b2, 0xb1c3b5, 0xb1c3b7, 0xb1c3b8, 0xb1c3be, 0xb1c400, 0xb1c4a1, 
		0xb1c4a4, 0xb1c4a9, 0xb1c4b1, 0xb1c4b2, 0xb1c4b5, 0xb1c4b6, 0xb1c4b7, 0xb1c500, 0xb1c5a1, 0xb1c5a4, 0xb1c5a9, 0xb1c5b5, 0xb1c5b6, 0xb1c5b7, 0xb1c5ba, 0xb1c600, 
		0xb1c700, 0xb1c7a1, 0xb1c7a3, 0xb1c7a4, 0xb1c7a9, 0xb1c7ab, 0xb1c7b1, 0xb1c7b2, 0xb1c7b5, 0xb1c7b7, 0xb1c800, 0xb1c8a4, 0xb1c8b6, 0xb1c8b7, 0xb1ca00, 0x0 
	};

	unsigned int ksc5601_to_a4_11[] = {
		-1, 0xb1caa4, 0xb1caa9, 0xb1cab2, 0xb1cab5, 0xb1cab7, 0xb1cb00, 0xb1cba4, 0xb1cba9, 0xb1cbb2, 0xb1cbb5, 0xb1cc00, 0xb1cca1, 0xb1cca2, 0xb1cca4, 0xb1cca7, 
		0xb1cca9, 0xb1ccaa, 0xb1ccab, 0xb1ccb1, 0xb1ccb2, 0xb1ccb5, 0xb1ccb7, 0xb1ccbc, 0xb1ccbe, 0xb1cd00, 0xb1cda4, 0xb1cda9, 0xb1cdb2, 0xb1cdb5, 0xb1ce00, 0xb1cf00, 
		0xb1cfa4, 0xb1cfa9, 0xb1d000, 0xb1d0a4, 0xb1d0a9, 0xb1d0b1, 0xb1d0b5, 0xb1d100, 0xb1d1a4, 0xb1d1a9, 0xb1d1b1, 0xb1d1b5, 0xb1d300, 0xb1d3a1, 0xb1d3a4, 0xb1d3a7, 
		0xb1d3a9, 0xb1d3ab, 0xb1d3b1, 0xb1d3b2, 0xb1d3b5, 0xb1d3b6, 0xb1d3b7, 0xb1d3ba, 0xb1d3bc, 0xb2bf00, 0xb2bfa1, 0xb2bfa2, 0xb2bfa3, 0xb2bfa4, 0xb2bfa7, 0xb2bfa9, 
		0xb2bfaa, 0xb2bfab, 0xb2bfac, 0xb2bfb1, 0xb2bfb2, 0xb2bfb5, 0xb2bfb7, 0xb2bfbc, 0xb2c000, 0xb2c0a1, 0xb2c0a4, 0xb2c0a9, 0xb2c0b1, 0xb2c0b2, 0xb2c0b5, 0xb2c0b6, 
		0xb2c0b7, 0xb2c0bc, 0xb2c100, 0xb2c1a1, 0xb2c1a4, 0xb2c1b2, 0xb2c300, 0xb2c3a1, 0xb2c3a4, 0xb2c3a7, 0xb2c3a9, 0xb2c3ab, 0xb2c3b1, 0xb2c3b2, 0xb2c3b5, 0x0 
	};


	unsigned int ksc5601_to_a4_12[] = {
		-1, 0xb2c3b7, 0xb2c3b8, 0xb2c400, 0xb2c4a1, 0xb2c4a4, 0xb2c4a7, 0xb2c4a9, 0xb2c4b1, 0xb2c4b2, 0xb2c4b5, 0xb2c4b6, 0xb2c4b7, 0xb2c500, 0xb2c5a1, 0xb2c5a4, 
		0xb2c5a9, 0xb2c5b2, 0xb2c5b5, 0xb2c5b6, 0xb2c5b7, 0xb2c5bc, 0xb2c600, 0xb2c6a4, 0xb2c700, 0xb2c7a1, 0xb2c7a2, 0xb2c7a4, 0xb2c7a9, 0xb2c7b1, 0xb2c7b2, 0xb2c7b5, 
		0xb2c7b7, 0xb2c800, 0xb2c8a4, 0xb2c8b6, 0xb2c900, 0xb2c9b6, 0xb2ca00, 0xb2caa1, 0xb2caa4, 0xb2caa9, 0xb2cab1, 0xb2cab2, 0xb2cb00, 0xb2cba4, 0xb2cc00, 0xb2cca1, 
		0xb2cca4, 0xb2cca7, 0xb2cca9, 0xb2ccaa, 0xb2ccab, 0xb2ccb1, 0xb2ccb2, 0xb2ccb5, 0xb2ccb7, 0xb2ccbc, 0xb2ccbd, 0xb2cd00, 0xb2cda9, 0xb2cdb6, 0xb2ce00, 0xb2cf00, 
		0xb2cfa1, 0xb2cfa4, 0xb2cfa9, 0xb2cfb7, 0xb2d000, 0xb2d0a4, 0xb2d0a9, 0xb2d0b1, 0xb2d0b5, 0xb2d0b7, 0xb2d100, 0xb2d1a1, 0xb2d1a4, 0xb2d1a9, 0xb2d1b1, 0xb2d1b2, 
		0xb2d1b5, 0xb2d300, 0xb2d3a1, 0xb2d3a4, 0xb2d3a9, 0xb2d3ab, 0xb2d3b1, 0xb2d3b2, 0xb2d3b5, 0xb2d3b7, 0xb2d3b8, 0xb2d3ba, 0xb3bf00, 0xb3bfa1, 0xb3bfa4, 0x0 
	};

	unsigned int ksc5601_to_a4_13[] = {
		-1, 0xb3bfa9, 0xb3bfab, 0xb3bfb1, 0xb3bfb2, 0xb3bfb5, 0xb3bfb6, 0xb3bfb7, 0xb3bfbe, 0xb3c000, 0xb3c0a2, 0xb3c0a4, 0xb3c0a9, 0xb3c0b1, 0xb3c0b2, 0xb3c0b5, 
		0xb3c0b6, 0xb3c0b7, 0xb3c100, 0xb3c1a1, 0xb3c1b1, 0xb3c300, 0xb3c3a1, 0xb3c3a4, 0xb3c3a7, 0xb3c3a9, 0xb3c3b1, 0xb3c3b5, 0xb3c3b6, 0xb3c3b7, 0xb3c400, 0xb3c4b7, 
		0xb3c500, 0xb3c5a1, 0xb3c5b1, 0xb3c5b2, 0xb3c5b5, 0xb3c5b6, 0xb3c5b7, 0xb3c700, 0xb3c7a1, 0xb3c7a4, 0xb3c7a9, 0xb3c7b1, 0xb3c7b2, 0xb3c7b7, 0xb3ca00, 0xb3cb00, 
		0xb3cbb7, 0xb3cc00, 0xb3cca1, 0xb3cca4, 0xb3cca9, 0xb3ccb1, 0xb3ccb5, 0xb3ccb7, 0xb3d000, 0xb3d0b7, 0xb3d100, 0xb3d1a4, 0xb3d1a9, 0xb3d1b1, 0xb3d1b2, 0xb3d300, 
		0xb3d3a1, 0xb3d3a4, 0xb3d3a9, 0xb3d3b1, 0xb3d3b2, 0xb3d3b5, 0xb3d3b7, 0xb5bf00, 0xb5bfa1, 0xb5bfa3, 0xb5bfa4, 0xb5bfa7, 0xb5bfa9, 0xb5bfaa, 0xb5bfab, 0xb5bfb1, 
		0xb5bfb2, 0xb5bfb5, 0xb5bfb6, 0xb5bfb7, 0xb5bfbc, 0xb5c000, 0xb5c0a1, 0xb5c0a4, 0xb5c0a9, 0xb5c0b1, 0xb5c0b2, 0xb5c0b5, 0xb5c0b6, 0xb5c0b7, 0xb5c100, 0x0 
	};

	unsigned int ksc5601_to_a4_14[] = {
		-1, 0xb5c1a1, 0xb5c1a4, 0xb5c1a9, 0xb5c1b1, 0xb5c1b2, 0xb5c1b5, 0xb5c1b7, 0xb5c200, 0xb5c2a4, 0xb5c2a9, 0xb5c2b1, 0xb5c2b7, 0xb5c300, 0xb5c3a1, 0xb5c3a2, 
		0xb5c3a3, 0xb5c3a4, 0xb5c3a7, 0xb5c3a9, 0xb5c3ab, 0xb5c3ac, 0xb5c3b1, 0xb5c3b2, 0xb5c3b5, 0xb5c3b6, 0xb5c3b7, 0xb5c3bd, 0xb5c400, 0xb5c4a1, 0xb5c4a4, 0xb5c4a9, 
		0xb5c4b1, 0xb5c4b2, 0xb5c4b5, 0xb5c4b6, 0xb5c4b7, 0xb5c500, 0xb5c5a1, 0xb5c5a4, 0xb5c5a9, 0xb5c5b1, 0xb5c5b2, 0xb5c5b5, 0xb5c5b6, 0xb5c5b7, 0xb5c600, 0xb5c6a4, 
		0xb5c6a9, 0xb5c6b7, 0xb5c700, 0xb5c7a1, 0xb5c7a2, 0xb5c7a4, 0xb5c7a9, 0xb5c7ab, 0xb5c7b1, 0xb5c7b2, 0xb5c7b5, 0xb5c7b7, 0xb5c7bc, 0xb5c800, 0xb5c8a1, 0xb5c8a4, 
		0xb5c8a9, 0xb5c8b7, 0xb5c900, 0xb5c9a4, 0xb5c9a9, 0xb5c9b1, 0xb5c9b5, 0xb5c9b6, 0xb5ca00, 0xb5caa4, 0xb5caa9, 0xb5cab1, 0xb5cab2, 0xb5cab5, 0xb5cb00, 0xb5cba1, 
		0xb5cba4, 0xb5cba9, 0xb5cbb1, 0xb5cbb2, 0xb5cbb5, 0xb5cbb7, 0xb5cc00, 0xb5cca1, 0xb5cca4, 0xb5cca7, 0xb5cca9, 0xb5ccb1, 0xb5ccb2, 0xb5ccb5, 0xb5ccb7, 0x0 
	};


	unsigned int ksc5601_to_a4_15[] = {
		-1, 0xb5ccba, 0xb5ccbc, 0xb5ccbd, 0xb5cd00, 0xb5cdb6, 0xb5ce00, 0xb5cea1, 0xb5cea4, 0xb5cea9, 0xb5ceb1, 0xb5ceb7, 0xb5cf00, 0xb5cfa1, 0xb5cfa4, 0xb5cfa9, 
		0xb5cfb1, 0xb5cfb2, 0xb5cfb5, 0xb5cfb7, 0xb5d000, 0xb5d0a1, 0xb5d0a9, 0xb5d0b1, 0xb5d0b5, 0xb5d0b7, 0xb5d100, 0xb5d1a1, 0xb5d1a4, 0xb5d1a9, 0xb7c6b5, 0xb5d1b1, 
		0xb5d1b2, 0xb5d1b5, 0xb5d1b7, 0xb5d300, 0xb5d3a1, 0xb5d3a4, 0xb5d3a7, 0xb5d3a9, 0xb5d3b0, 0xb5d3b1, 0xb5d3b2, 0xb5d3b5, 0xb5d3b7, 0xb5d3bd, 0xb6bf00, 0xb6bfa1, 
		0xb6bfa3, 0xb6bfa4, 0xb6bfa9, 0xb6bfb1, 0xb6bfb2, 0xb6bfb6, 0xb6bfb7, 0xb6bfbe, 0xb6c000, 0xb6c0a1, 0xb6c0a4, 0xb6c0a9, 0xb6c0b1, 0xb6c0b2, 0xb6c0b6, 0xb7caa9, 
		0xb6c1b7, 0xb6c300, 0xb6c3a1, 0xb6c3a4, 0xb6c3a9, 0xb6c3ab, 0xb6c3b1, 0xb6c3b2, 0xb6c3b6, 0xb6c3b7, 0xb6c400, 0xb6c4a4, 0xb6c4a9, 0xb6c6a4, 0xb6c700, 0xb6c7a1, 
		0xb6c7a4, 0xb6c7a7, 0xb6c7a9, 0xb6c7ab, 0xb6c7b1, 0xb6c7b2, 0xb6c7b7, 0xb6c800, 0xb6c8a1, 0xb6c8a4, 0xb6c8b6, 0xb6c900, 0xb6c9b6, 0xb6ca00, 0xb6caa4, 0x0 
		};

	unsigned int ksc5601_to_a4_16[] = {
		-1, 0xb6caa9, 0xb6cab1, 0xb6cab2, 0xb6cb00, 0xb6cc00, 0xb6cca1, 0xb6cca4, 0xb6cca9, 0xb6ccb1, 0xb6ccb2, 0xb6ccb7, 0xb6cd00, 0xb6cdb6, 0xb6ce00, 0xb6cf00, 
		0xb6cfa4, 0xb6d0b7, 0xb6d100, 0xb6d1a1, 0xb6d1a4, 0xb6d1a9, 0xb6d1ab, 0xb6d1b0, 0xb6d1b1, 0xb6d1b2, 0xb6d200, 0xb6d2a4, 0xb6d2a9, 0xb6d2b1, 0xb6d300, 0xb6d3a1, 
		0xb6d3a4, 0xb6d3a9, 0xb6d3b1, 0xb6d3b2, 0xb6d3b5, 0xb6d3b7, 0xb7bf00, 0xb7bfa1, 0xb7bfa4, 0xb7bfa5, 0xb7bfa6, 0xb7bfa9, 0xb7bfaa, 0xb7bfab, 0xb7bfb0, 0xb7bfb1, 
		0xb7bfb2, 0xb7bfb5, 0xb7bfb6, 0xb7bfb7, 0xb7bfbc, 0xb7bfbd, 0xb7c000, 0xb7c0a1, 0xb7c0a4, 0xb7c0a9, 0xb7c0b1, 0xb7c0b2, 0xb7c0b5, 0xb7c0b6, 0xb7c0b7, 0xb7c100, 
		0xb7c1a1, 0xb7c1a4, 0xb7c1a9, 0xb7c1ac, 0xb7c1b1, 0xb7c1b2, 0xb7c1b5, 0xb7c1b7, 0xb7c1bc, 0xb7c1be, 0xb7c200, 0xb7c2a4, 0xb7c2a9, 0xb7c2b2, 0xb7c300, 0xb7c3a1, 
		0xb7c3a4, 0xb7c3a5, 0xb7c3a7, 0xb7c3a9, 0xb7c3aa, 0xb7c3ab, 0xb7c3b1, 0xb7c3b2, 0xb7c3b4, 0xb7c3b5, 0xb7c3b6, 0xb7c3b7, 0xb7c3b8, 0xb7c3bb, 0xb7c3bd, 0x0 
	};


	unsigned int ksc5601_to_a4_17[] = {
		-1, 0xb7c400, 0xb7c4a1, 0xb7c4a4, 0xb7c4a9, 0xb7c4b1, 0xb7c4b2, 0xb7c4b5, 0xb7c4b7, 0xb7c500, 0xb7c5a1, 0xb7c5a2, 0xb7c5a4, 0xb7c5a9, 0xb7c5ab, 0xb7c5ac, 
		0xb7c5b1, 0xb7c5b2, 0xb7c5b4, 0xb7c5b5, 0xb7c5b6, 0xb7c5b7, 0xb7c5bc, 0xb7c5bd, 0xb7c5be, 0xb7c600, 0xb7c6a4, 0xb7c6a9, 0xb7c6b1, 0xb7c6b2, 0x0, 0xb7c6b6, 
		0xb7c700, 0xb7c7a1, 0xb7c7a4, 0xb7c7a9, 0xb7c7aa, 0xb7c7ab, 0xb7c7ad, 0xb7c7b0, 0xb7c7b1, 0xb7c7b2, 0xb7c7b5, 0xb7c7b7, 0xb7c7ba, 0xb7c800, 0xb7c8a1, 0xb7c8a4, 
		0xb7c8a9, 0xb7c8b1, 0xb7c8b2, 0xb7c8b5, 0xb7c8b6, 0xb7c8b7, 0xb7c900, 0xb7c9a1, 0xb7c9a4, 0xb7c9b1, 0xb7c9b5, 0xb7c9b7, 0xb7ca00, 0xb7caa1, 0xb7caa4, 0x0, 
		0xb7cab1, 0xb7cab2, 0xb7cab5, 0xb7cab7, 0xb7cb00, 0xb7cba1, 0xb7cba4, 0xb7cba9, 0xb7cbb1, 0xb7cbb2, 0xb7cbb5, 0xb7cbb7, 0xb7cc00, 0xb7cca1, 0xb7cca4, 0xb7cca9, 
		0xb7ccaa, 0xb7ccab, 0xb7ccb1, 0xb7ccb2, 0xb7ccb5, 0xb7ccb7, 0xb7cd00, 0xb7cda1, 0xb7cda4, 0xb7cda9, 0xb7cdb1, 0xb7cdb2, 0xb7cdb6, 0xb7cdb7, 0xb7ce00, 0x0 
	};


	unsigned int ksc5601_to_a4_18[] = {
		-1, 0xb7cea1, 0xb7cea4, 0xb7cea9, 0xb7ceb1, 0xb7ceb2, 0xb7ceb7, 0xb7cf00, 0xb7cfa1, 0xb7cfa4, 0xb7cfa9, 0xb7cfb1, 0xb7cfb2, 0xb7cfb5, 0xb7cfb7, 0xb7d000, 
		0xb7d0a1, 0xb7d0a4, 0xb7d0a9, 0xb7d0b1, 0xb7d0b2, 0xb7d0b5, 0xb7d0b7, 0xb7d0ba, 0xb7d100, 0xb7d1a1, 0xb7d1a4, 0xb7d1a9, 0xb7d1af, 0xb7d1b1, 0xb7d1b2, 0xb7d1b5, 
		0xb7d1b7, 0xb7d1b8, 0xb7d1ba, 0xb7d1bb, 0xb7d1bc, 0xb7d1bd, 0xb7d1be, 0xb7d200, 0xb7d2a4, 0xb7d2a9, 0xb7d2b1, 0xb7d2b5, 0xb7d300, 0xb7d3a1, 0xb7d3a4, 0xb7d3a9, 
		0xb7d3aa, 0xb7d3ab, 0xb7d3b0, 0xb7d3b1, 0xb7d3b2, 0xb7d3b5, 0xb7d3b6, 0xb7d3b7, 0xb7d3b8, 0xb7d3bd, 0xb8bf00, 0xb8bfa1, 0xb8bfa4, 0xb8bfa6, 0xb8bfa7, 0xb8bfa9, 
		0xb8bfab, 0xb8bfb1, 0xb8bfb2, 0xb8bfb5, 0xb8bfb6, 0xb8bfb7, 0xb8bfb8, 0xb8c000, 0xb8c0a1, 0xb8c0a4, 0xb8c0a9, 0xb8c0b1, 0xb8c0b2, 0xb8c0b5, 0xb8c0b6, 0xb8c0b7, 
		0xb8c100, 0xb8c1a1, 0xb8c1a4, 0xb8c1a6, 0xb8c1a9, 0xb8c1b1, 0xb8c1b7, 0xb8c200, 0xb8c2a4, 0xb8c2a9, 0xb8c300, 0xb8c3a1, 0xb8c3a4, 0xb8c3a9, 0xb8c3ab, 0x0 
	};

	unsigned int ksc5601_to_a4_19[] = {
		-1, 0xb8c3b1, 0xb8c3b2, 0xb8c3b5, 0xb8c3b7, 0xb8c3b8, 0xb8c400, 0xb8c4a1, 0xb8c4a4, 0xb8c4a9, 0xb8c4b1, 0xb8c4b2, 0xb8c4b5, 0xb8c4b7, 0xb8c500, 0xb8c5a4, 
		0xb8c5a9, 0xb8c5b1, 0xb8c5b2, 0xb8c5b6, 0xb8c5b7, 0xb8c600, 0xb8c700, 0xb8c7a1, 0xb8c7a4, 0xb8c7a9, 0xb8c7ab, 0xb8c7b1, 0xb8c7b2, 0xb8c7b5, 0xb8c7b7, 0xb8c7b8, 
		0xb8c7ba, 0xb8c7be, 0xb8c800, 0xb8c8a1, 0xb8c8a9, 0xb8c8b2, 0xb8c8b5, 0xb8c8b7, 0xb8c900, 0xb8c9b6, 0xb8c9b7, 0xb8ca00, 0xb8caa4, 0xb8caa9, 0xb8cab1, 0xb8cab2, 
		0xb8cab5, 0xb8cab7, 0xb8cb00, 0xb8cba1, 0xb8cba4, 0xb8cbb7, 0xb8cc00, 0xb8cca1, 0xb8cca4, 0xb8cca9, 0xb8ccaa, 0xb8ccab, 0xb8ccb1, 0xb8ccb2, 0xb8ccb5, 0xb8ccb7, 
		0xb8cd00, 0xb8cdb6, 0xb8ce00, 0xb8cf00, 0xb8cfa1, 0xb8cfa4, 0xb8cfa9, 0xb8cfb1, 0xb8cfb2, 0xb8cfb5, 0xb8d000, 0xb8d0a4, 0xb8d0a9, 0xb8d0b1, 0xb8d100, 0xb8d1a1, 
		0xb8d1a4, 0xb8d1a9, 0xb8d1b1, 0xb8d1b2, 0xb8d1b5, 0xb8d1b7, 0xb8d300, 0xb8d3a1, 0xb8d3a4, 0xb8d3a7, 0xb8d3a9, 0xb8d3ab, 0xb8d3b1, 0xb8d3b2, 0xb8d3b5, 0x0 
	};

	unsigned int ksc5601_to_a4_20[] = {
		-1, 0xb8d3b7, 0xb8d3b8, 0xb8d3bc, 0xb8d3bd, 0xb9bf00, 0xb9bfa1, 0xb9bfa4, 0xb9bfa6, 0xb9bfa9, 0xb9bfac, 0xb9bfb1, 0xb9bfb2, 0xb9bfb5, 0xb9bfb6, 0xb9bfb7, 
		0xb9c000, 0xb9c0a1, 0xb9c0a4, 0xb9c0a9, 0xb9c0b1, 0xb9c0b2, 0xb9c0b5, 0xb9c0b6, 0xb9c0b7, 0xb9c100, 0xb9c1a4, 0xb9c1b7, 0xb9c300, 0xb9c3a1, 0xb9c3a4, 0xb9c3a9, 
		0xb9c3b1, 0xb9c3b2, 0xb9c3b5, 0xb9c3b6, 0xb9c3b7, 0xb9c400, 0xb9c4b7, 0xb9c500, 0xb9c5b6, 0xb9c700, 0xb9c7a1, 0xb9c7a4, 0xb9c7a9, 0xb9c7b1, 0xb9c7b2, 0xb9c7b5, 
		0xb9c7b7, 0xb9c7ba, 0xb9c800, 0xb9c8a1, 0xb9c8a9, 0xb9c8b6, 0xb9c900, 0xb9c9b6, 0xb9ca00, 0xb9caa4, 0xb9caa9, 0xb9cab1, 0xb9cab2, 0xb9cbb7, 0xb9cc00, 0xb9cca1, 
		0xb9cca4, 0xb9cca9, 0xb9ccb1, 0xb9ccb2, 0xb9ccb7, 0xb9cd00, 0xb9cdb6, 0xb9cdb7, 0xb9cf00, 0xb9d000, 0xb9d100, 0xb9d1b1, 0xb9d1b5, 0xb9d1b7, 0xbacfb1, 0xb9d3a1, 
		0xb9d3a4, 0xb9d3a9, 0xb9d3b1, 0xb9d3b2, 0xb9d3b7, 0xb9d3b8, 0xb9d3be, 0xbabf00, 0xbabfa1, 0xbabfa4, 0xbabfa6, 0xbabfa9, 0xbabfb1, 0xbabfb2, 0xbabfb5, 0x0 
	};

	unsigned int ksc5601_to_a4_21[] = {
		-1, 0xbabfb6, 0xbabfb7, 0xbabfb8, 0xbac000, 0xbac0a1, 0xbac0a4, 0xbac0a9, 0xbac0b1, 0xbac0b2, 0xbac0b5, 0xbac0b6, 0xbac0b7, 0xbac100, 0xbac1a4, 0xbac1a6, 
		0xbac1a9, 0xbac1b1, 0xbac1b7, 0xbac300, 0xbac3a1, 0xbac3a4, 0xbac3a9, 0xbac3b1, 0xbac3b2, 0xbac3b5, 0xbac3b6, 0xbac3b7, 0xbac400, 0xbac4a1, 0xbac4a4, 0xbac4a9, 
		0xbac4b1, 0xbac4b2, 0xbac4b5, 0xbac4b7, 0xbac500, 0xbac5a4, 0xbac5b6, 0xbac600, 0xbac6a4, 0xbac6b7, 0xbac700, 0xbac7a1, 0xbac7a4, 0xbac7a9, 0xbac7b1, 0xbac7b2, 
		0xbac7b5, 0xbac7b7, 0xbac800, 0xbac8a4, 0xbac8a9, 0xbac8b7, 0xbaca00, 0xbacaa4, 0xbacaa9, 0xbacab1, 0xbacab2, 0xbacab5, 0xbacab7, 0xbacb00, 0xbacbb1, 0xbacc00, 
		0xbacca1, 0xbacca4, 0xbacca9, 0xbaccb1, 0xbaccb2, 0xbaccb5, 0xbaccb7, 0xbacd00, 0xbacdb6, 0xbace00, 0xbacea4, 0xbacf00, 0xbacfa4, 0xbacfa9, 0x0, 0xbacfb2, 
		0xbacfb5, 0xbacfb7, 0xbad000, 0xbad0a4, 0xbad0a9, 0xbad0b1, 0xbad0b7, 0xbad100, 0xbad1a1, 0xbad1a4, 0xbad1a9, 0xbad1b1, 0xbad1b2, 0xbad1b5, 0xbad1b7, 0x0 
	};

	unsigned int ksc5601_to_a4_22[] = {
		-1, 0xbad300, 0xbad3a1, 0xbad3a4, 0xbad3a7, 0xbad3a9, 0xbad3aa, 0xbad3b1, 0xbad3b2, 0xbad3b5, 0xbad3b7, 0xbbbf00, 0xbbbfa1, 0xbbbfa4, 0xbbbfa9, 0xbbbfb1, 
		0xbbbfb2, 0xbbbfb5, 0xbbbfb7, 0xbbc000, 0xbbc0a1, 0xbbc0a4, 0xbbc0a9, 0xbbc0b1, 0xbbc0b2, 0xbbc0b5, 0xbbc0b6, 0xbbc0b7, 0xbbc100, 0xbbc1a1, 0xbbc1b7, 0xbbc300, 
		0xbbc3a1, 0xbbc3a4, 0xbbc3a7, 0xbbc3a9, 0xbbc3b1, 0xbbc3b2, 0xbbc3b5, 0xbbc3b6, 0xbbc3b7, 0xbbc400, 0xbbc4a1, 0xbbc4a4, 0xbbc4a9, 0xbbc4b1, 0xbbc4b2, 0xbbc4b5, 
		0xbbc4b7, 0xbbc500, 0xbbc5a4, 0xbbc5a9, 0xbbc5b1, 0xbbc5b2, 0xbbc5b5, 0xbbc5b6, 0xbbc5b7, 0xbbc600, 0xbbc700, 0xbbc7a1, 0xbbc7a4, 0xbbc7a9, 0xbbc7b1, 0xbbc7b2, 
		0xbbc7b5, 0xbbc7b7, 0xbbc800, 0xbbc8a1, 0xbbc8a4, 0xbbc8a9, 0xbbc8b1, 0xbbc8b7, 0xbbc900, 0xbbc9b7, 0xbbca00, 0xbbcaa9, 0xbbcb00, 0xbbcc00, 0xbbcca1, 0xbbcca4, 
		0xbbcca9, 0xbbccb1, 0xbbccb2, 0xbbccb5, 0xbbccb7, 0xbbcd00, 0xbbcda4, 0xbbcda9, 0xbbcdb7, 0xbbce00, 0xbbceb7, 0xbbcf00, 0xbbcfa1, 0xbbcfa4, 0xbbcfa9, 0x0 
	};

	unsigned int ksc5601_to_a4_23[] = {
		-1, 0xbcce00, 0xbbcfb2, 0xbbcfb5, 0xbbcfb7, 0xbbd000, 0xbbd0a4, 0xbbd0a9, 0xbbd0b1, 0xbbd100, 0xbbd1a1, 0xbbd1a4, 0xbbd1a9, 0xbbd1b1, 0xbbd1b2, 0xbbd1b7, 
		0xbbd300, 0xbbd3a1, 0xbbd3a4, 0xbbd3a9, 0xbbd3b1, 0xbbd3b2, 0xbbd3b5, 0xbbd3b7, 0xbcbf00, 0xbcbfa1, 0xbcbfa4, 0xbcbfa9, 0xbcbfaa, 0xbcbfb1, 0xbcbfb2, 0xbcbfb5, 
		0xbcbfb6, 0xbcbfb7, 0xbcc000, 0xbcc0a1, 0xbcc0a4, 0xbcc0a9, 0xbcc0b1, 0xbcc0b2, 0xbcc0b5, 0xbcc0b6, 0xbcc0b7, 0xbcc100, 0xbcc1b7, 0xbcc300, 0xbcc3a1, 0xbcc3a4, 
		0xbcc3a9, 0xbcc3ab, 0xbcc3b1, 0xbcc3b2, 0xbcc3b5, 0xbcc3b6, 0xbcc3b7, 0xbcc400, 0xbcc4a1, 0xbcc4a4, 0xbcc4a9, 0xbcc4b1, 0xbcc4b2, 0xbcc4b5, 0xbcc4b7, 0xbcc500, 
		0xbcc5a4, 0xbcc5b6, 0xbcc600, 0xbcc6a4, 0xbcc700, 0xbcc7a1, 0xbcc7a4, 0xbcc7a9, 0xbcc7b1, 0xbcc7b2, 0xbcc7b5, 0xbcc7b7, 0xbcc7bd, 0xbcc800, 0xbcc8a4, 0xbcc900, 
		0xbcca00, 0xbccaa4, 0xbccab5, 0xbccab7, 0xbccb00, 0xbccc00, 0xbccca1, 0xbccca4, 0xbccca9, 0xbcccb1, 0xbcccb2, 0xbcccb5, 0xbcccb7, 0xbccd00, 0xbccdb6, 0x0 
	};


	unsigned int ksc5601_to_a4_24[] = {
		-1, 0x0, 0xbccf00, 0xbccfa1, 0xbccfa4, 0xbccfa9, 0xbccfb1, 0xbccfb2, 0xbccfb7, 0xbcd000, 0xbcd0a4, 0xbcd0a9, 0xbcd0b1, 0xbcd0b7, 0xbcd100, 0xbcd1a1, 
		0xbcd1a4, 0xbcd1a7, 0xbcd1a9, 0xbcd1ab, 0xbcd1b1, 0xbcd1b2, 0xbcd1b5, 0xbcd200, 0xbcd2a4, 0xbcd2a9, 0xbcd2b1, 0xbcd2b2, 0xbcd300, 0xbcd3a1, 0xbcd3a4, 0xbcd3a9, 
		0xbcd3b1, 0xbcd3b2, 0xbcd3b5, 0xbcd3b7, 0xbdbf00, 0xbdbfa1, 0xbdbfa2, 0xbdbfa4, 0xbdbfa9, 0xbdbfab, 0xbdbfb1, 0xbdbfb2, 0xbdbfb5, 0xbdbfb6, 0xbdbfb7, 0xbdbfbc, 
		0xbdc000, 0xbdc0a1, 0xbdc0a4, 0xbdc0a9, 0xbdc0b1, 0xbdc0b2, 0xbdc0b5, 0xbdc0b6, 0xbdc0b7, 0xbdc100, 0xbdc1a1, 0xbdc300, 0xbdc3a1, 0xbdc3a4, 0xbdc3a9, 0xbdc3b1, 
		0xbdc3b2, 0xbdc3b5, 0xbdc3b6, 0xbdc3b7, 0xbdc400, 0xbdc4a1, 0xbdc4a4, 0xbdc4a9, 0xbdc4b1, 0xbdc4b2, 0xbdc4b5, 0xbdc4b7, 0xbdc600, 0xbdc6a4, 0xbdc6a9, 0xbdc6b1, 
		0xbdc6b2, 0xbdc6b6, 0xbdc6b7, 0x0, 0x0, 0x0, 0x0, 0xbdc700, 0xbdc7a1, 0xbdc7a4, 0xbdc7a9, 0x0, 0xbdc7b2, 0xbdc7b5, 0xbdc7b7, 0x0 
	};

	unsigned int ksc5601_to_a4_25[] = {
		-1, 0xbdc800, 0xbdc8b7, 0xbdca00, 0xbdcaa4, 0xbdcb00, 0xbdcba4, 0xbdcba9, 0xbdcbb2, 0xbdcbb5, 0xbdcc00, 0xbdcca1, 0xbdcca4, 0xbdcca7, 0xbdcca9, 0xbdccab, 
		0xbdccb1, 0xbdccb2, 0xbdccb5, 0xbdccb7, 0xbdcd00, 0xbdcdb7, 0xbdcf00, 0xbdcfa4, 0xbdcfa9, 0xbdcfb1, 0xbdcfb5, 0xbdd000, 0xbdd0a4, 0xbdd0a9, 0xbdd0b1, 0xbdd0b5, 
		0xbdd0b7, 0xbdd100, 0xbdd1a4, 0xbdd1a9, 0xbdd1b1, 0xbdd1b2, 0xbdd1b5, 0xbdd300, 0xbdd3a1, 0xbdd3a4, 0xbdd3a9, 0xbdd3b1, 0xbdd3b2, 0xbdd3b5, 0xbdd3b7, 0xbebf00, 
		0xbebfa1, 0xbebfa4, 0xbebfa9, 0xbebfae, 0xbebfb1, 0xbebfb2, 0xbebfb5, 0xbebfb7, 0xbec000, 0xbec0a1, 0xbec0a4, 0xbec0a9, 0xbec0b1, 0xbec0b2, 0xbec0b5, 0xbec0b6, 
		0xbec0b7, 0xbec100, 0xbec1b7, 0xbec300, 0xbec3a1, 0xbec3a4, 0xbec3a9, 0xbec3ab, 0xbec3b1, 0xbec3b2, 0xbec3b5, 0xbec3b7, 0xbec400, 0xbec4a1, 0xbec4a4, 0xbec4a9, 
		0xbec4b1, 0xbec4b2, 0xbec4b5, 0xbec4b7, 0xbec500, 0xbec5a1, 0xbec5a4, 0xbec5a9, 0xbec5b1, 0xbec5b2, 0xbec5b5, 0xbec5b6, 0xbec5b7, 0xbec600, 0xbec6a4, 0x0 
	};
	unsigned int ksc5601_to_a4_26[] = {
		-1, 0xbec6a9, 0xbec6b2, 0xbec700, 0xbec7a1, 0xbec7a4, 0xbec7a9, 0xbec7ae, 0xbec7b1, 0xbec7b2, 0xbec7b5, 0xbec7b7, 0xbec7bc, 0xbec800, 0xbec8a1, 0xbec8a4, 
		0xbec8a9, 0xbec8b5, 0xbec8b7, 0xbec900, 0xbec9a1, 0xbec9a4, 0xbec9b5, 0xbec9b7, 0xbeca00, 0xbecaa1, 0xbecaa4, 0xbecaa9, 0xbecab2, 0xbecab5, 0xbecab7, 0xbecb00, 
		0xbecba4, 0xbecba9, 0xbecbb2, 0xbecbb5, 0xbecc00, 0xbecca1, 0xbecca4, 0xbecca9, 0xbeccae, 0xbeccb1, 0xbeccb5, 0xbeccb7, 0xbecd00, 0xbecda4, 0xbecda9, 0xbecdb1, 
		0xbecdb7, 0xbece00, 0xbecea1, 0xbecea4, 0xbecea9, 0xbeceb7, 0xbecf00, 0xbecfa1, 0xbecfa4, 0xbecfa9, 0xbecfb1, 0xbecfb2, 0xbecfb5, 0xbecfb7, 0xbed000, 0xbed0a1, 
		0xbed0a4, 0xbed0a9, 0xbed0b1, 0xbed0b5, 0xbed0b7, 0xbed100, 0xbed1a1, 0xbed1a4, 0xbed1a6, 0xbed1a7, 0xbed1a9, 0xbed1aa, 0xbed1b1, 0xbed1b2, 0xbed1b5, 0xbed1b7, 
		0xbed1bc, 0xbed200, 0xbed2a4, 0xbed2a9, 0xbed2b1, 0xbed2b2, 0xbed2b7, 0xbed300, 0xbed3a1, 0xbed3a4, 0xbed3a9, 0xbed3b1, 0xbed3b2, 0xbed3b5, 0xbed3b7, 0x0 
	};

	MALLOC(hg_dfa_a4, unsigned int *, 27);

	hg_dfa_a4[0] = ksc5601_to_a4_0;
	hg_dfa_a4[1] = ksc5601_to_a4_1;
	hg_dfa_a4[2] = ksc5601_to_a4_2;
	hg_dfa_a4[3] = ksc5601_to_a4_3;
	hg_dfa_a4[4] = ksc5601_to_a4_4;
	hg_dfa_a4[5] = ksc5601_to_a4_5;
	hg_dfa_a4[6] = ksc5601_to_a4_6;
	hg_dfa_a4[7] = ksc5601_to_a4_7;
	hg_dfa_a4[8] = ksc5601_to_a4_8;
	hg_dfa_a4[9] = ksc5601_to_a4_9;
	hg_dfa_a4[10] = ksc5601_to_a4_10;
	hg_dfa_a4[11] = ksc5601_to_a4_11;
	hg_dfa_a4[12] = ksc5601_to_a4_12;
	hg_dfa_a4[13] = ksc5601_to_a4_13;
	hg_dfa_a4[14] = ksc5601_to_a4_14;
	hg_dfa_a4[15] = ksc5601_to_a4_15;
	hg_dfa_a4[16] = ksc5601_to_a4_16;
	hg_dfa_a4[17] = ksc5601_to_a4_17;
	hg_dfa_a4[18] = ksc5601_to_a4_18;
	hg_dfa_a4[19] = ksc5601_to_a4_19;
	hg_dfa_a4[20] = ksc5601_to_a4_20;
	hg_dfa_a4[21] = ksc5601_to_a4_21;
	hg_dfa_a4[22] = ksc5601_to_a4_22;
	hg_dfa_a4[23] = ksc5601_to_a4_23;
	hg_dfa_a4[24] = ksc5601_to_a4_24;
	hg_dfa_a4[25] = ksc5601_to_a4_25;
	hg_dfa_a4[26] = ksc5601_to_a4_26;

	return hg_dfa_a4;
}
/*
 * ѱ ϼ  DFA ȯ ̺
 *
 * ռ  ϴ. made by aso(andsoon@igrus.inha.ac.kr)
 */
unsigned int **
hg_make_hgdfa_f(void)
{
	unsigned int ** hg_dfa;

	/* ʼ, ߼,   ѱ ڵ DFA Դϴ.
	 *   ۵Ǿϴ. ̷ ׷ ϴ 
	 * ӵ Դϴ. */
	unsigned int c_dfa[] = {	/* ʼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/-1,  1,  2,  0,  3,  0,  0,  4,  5,  6,  0,  0,  0,  0,  0,  0,
	/*             							*/
	/*0x20*/ 0,  7,  8,174,  0,  9, 10, 11, 12,255, 13, 14, 15, 16, 17,  0,
	/*0x30*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x40*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};
	unsigned int c_dfa1_1[] = {	/*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 18,
	/*                                      */
	/*0x30*/ 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34,
	/*              */
	/*0x40*/ 35, 36,367, 37,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};
	unsigned int c_dfa1_2[] = {       /*  + ߼ */
	/*	  0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                     */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 38,
	/*                                       */
	/*0x30*/ 39, 40,  0, 41, 42, 43,368, 44, 45, 46, 47,369, 48, 49, 50, 51,
	/*               */
	/*0x40*/370, 52,  0, 53,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_3[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/-1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 54,
	/*                                      */
	/*0x30*/55, 56,  0, 57, 58, 59, 60, 61, 62,  0, 63, 64, 65, 66,371, 67,
	/*              */
	/*0x40*/68, 69,  70, 71,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_4[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/-1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x20*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 72,
	/*0x30*/73,372,  0, 74, 75, 76, 77, 78, 79, 80, 81,373, 82, 83, 84, 85,
	/*0x40*/86, 87, 88, 89,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_5[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/-1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0, 90,
	/*                                      */
	/*0x30*/91,  0,  0, 92, 93,  94, 0, 95, 96, 97, 98,  0, 99,  0,100,101,
	/*              */
	/*0x40*/ 0,102,103,104,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_6[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/-1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,105,
	/*                                      */
	/*0x30*/106,107,  0,108,109,110,111,112,113,114,115,116,117,118,119,120,
	/*              */
	/*0x40*/121,122, 0,123,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_7[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/-1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,124,
	/*                                      */
	/*0x30*/125,126,  0,127,128,129,130,131,132, 0,133,134,135,136,137,138,
	/*              */
	/*0x40*/139,140, 0,141,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_8[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/-1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,142,
	/*                                      */
	/*0x30*/143,144,  0,145,146,147,148,149,150,151,152,153,154,155,156,157,
	/*              */
	/*0x40*/158,159, 0,160,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/ 0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_18[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,161,
	/*                                       */
	/*0x30*/162,163,  0,164,165,166,  0,167,  0,  0,168,169,170,  0,  0,  0,
	/*              */
	/*0x40*/171,172,  0,173,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_9[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,175,
	/*                                       */
	/*0x30*/176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,
	/*              */
	/*0x40*/192,193,  0,194,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_10[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,195,
	/*                                       */
	/*0x30*/196,197,  0,198,199,  0,200,201,202,203,204,205,206,207,208,209,
	/*              */
	/*0x40*/210,211,212,213,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_11[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,214,
	/*                                       */
	/*0x30*/215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,
	/*              */
	/*0x40*/231,232,233,234,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_12[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,235,
	/*                                       */
	/*0x30*/236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,
	/*              */
	/*0x40*/252,253,  0,254,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_19[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,256,
	/*                                       */
	/*0x30*/257,258,  0,259,260,261,  0,262,263,264,265,266,267,268,  0,269,
	/*              */
	/*0x40*/270,271,  0,272,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_13[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,273,
	/*                                       */
	/*0x30*/274,275,  0,276,277,278,279,280,281,  0,282,283,284,285,286,287,
	/*              */
	/*0x40*/288,289,  0,290,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_14[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,291,
	/*                                       */
	/*0x30*/292,293,  0,294,295,296,297,298,299,300,301,302,303,304,305,306,
	/*              */
	/*0x40*/307,308,  0,309,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_15[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,310,
	/*                                       */
	/*0x30*/311,312,  0,313,314,315,316,317,318,319,320,321,322,323,324,325,
	/*              */
	/*0x40*/326,327,328,329,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_16[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,330,
	/*                                       */
	/*0x30*/331,332,  0,333,334,335,335,337,338,  0,339,340,341,342,  0,343,
	/*              */
	/*0x40*/344,345,  0,346,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	unsigned int c_dfa1_17[] = {       /*  + ߼ */
	/*	 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
	/*0x10*/ -1,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*                                                                    */
	/*0x20*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,347,
	/*                                       */
	/*0x30*/348,349,  0,350,351,352,353,354,355,356,357,358,359,360,361,362,
	/*              */
	/*0x40*/363,364,365,366,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x50*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
	/*0x60*/  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
	};

	/* ⼭   "ʼ+߼"  ¿   ""  κеԴϴ. ׷  '' ''
	 *      ϼ(ks5601)  ڷ  ֽϴ.
	 *
	 *  : "ʼ+߼"      ʴ 0xa8 ġ    Դϴ. ̰ ϳ Ʈ(trick)̹Ƿ
	 * ũ Ű澲 ñ ٶϴ.  0xa0  ġ  ʴİ Ŵٸ, װ    νø ƽð
	 * ڰ(argument)   0xa0 ŭ      0x00  Ű Ǿ ֽϴ. ׷  0xa0 ġ
	 * -1  ־ ִ Դϴ. */

	/*								         								*/
	unsigned int c_dfa_ga_0[] = {	/*  */
	/*0xa0*/     -1, 0xb0a2, 0x0000, 0x0000, 0xb0a3, 0x0000, 0x0000, 0xb0a4, 0xb0a1, 0xb0a5, 0xb0a6, 0xb0a7, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb0a8, 0xb0a9, 0x0000, 0xb0aa, 0xb0ab, 0xb0ac, 0xb0ad, 0xb0ae, 0x0000, 0xb0af, 0x0000, 0xb0b0, 0xb0b1, 0xb0b2
	};
	unsigned int c_dfa_ga_1[] = {	/*  */
	/*0xa0*/     -1, 0xb0b4, 0x0000, 0x0000, 0xb0b5, 0x0000, 0x0000, 0x0000, 0xb0b3, 0xb0b6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb0b7, 0xb0b8, 0x0000, 0x0000, 0xb0b9, 0xb0ba, 0xb0bb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};
	unsigned int c_dfa_ga_2[] = {	/*  */
	/*0xa0*/     -1, 0xb0bd, 0x0000, 0x0000, 0xb0be, 0x0000, 0x0000, 0x0000, 0xb0bc, 0xb0bf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb0c0, 0x0000, 0xb0c1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_3[] = {	/*  */
	/*0xa0*/     -1, 0xb0c2, 0x0000, 0x0000, 0xb0c3, 0x0000, 0x0000, 0x0000, 0x0000, 0xb0c4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
		 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};
	unsigned int c_dfa_ga_4[] = {	/*  */
	/*0xa0*/     -1, 0xb0c6, 0x0000, 0x0000, 0xb0c7, 0x0000, 0x0000, 0xb0c8, 0xb0c5, 0xb0c9, 0x0000, 0xb0ca, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb0cb, 0xb0cc, 0x0000, 0x0000, 0xb0cd, 0xb0ce, 0xb0cf, 0xb0d0, 0x0000, 0x0000, 0x0000, 0xb0d1, 0xb0d2, 0xb0d3
	};

	unsigned int c_dfa_ga_5[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb0d5, 0x0000, 0x0000, 0x0000, 0xb0d4, 0xb0d6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb0d7, 0xb0d8, 0x0000, 0x0000, 0xb0d9, 0xb0da, 0xb0db, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_6[] = {	/*  */
	/*0xa0*/     -1, 0xb0dd, 0xb0de, 0x0000, 0xb0df, 0x0000, 0x0000, 0xb0e0, 0xb0dc, 0xb0e1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb0e2, 0xb0e3, 0x0000, 0x0000, 0xb0e4, 0xb0e5, 0xb0e6, 0x0000, 0x0000, 0x0000, 0x0000, 0xb0e7, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_7[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb0e9, 0x0000, 0x0000, 0x0000, 0xb0e8, 0xb0ea, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xb0eb, 0x0000, 0x0000, 0xb0ec, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_8[] = {	/*  */
	/*0xa0*/     -1, 0xb0ee, 0x0000, 0x0000, 0xb0ef, 0x0000, 0x0000, 0xb0f0, 0xb0ed, 0xb0f1, 0x0000, 0xb0f2, 0x0000, 0xb0f3, 0x0000, 0x0000,
	/*0xb0*/ 0xb0f4, 0xb0f5, 0xb0f6, 0x0000, 0x0000, 0xb0f7, 0x0000, 0xb0f8, 0xb0f9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_9[] = {	/*  */
	/*0xa0*/     -1, 0xb0fb, 0x0000, 0x0000, 0xb0fd, 0x0000, 0x0000, 0x0000, 0xb0fa, 0xb0fd, 0x0000, 0xb0fe, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb1a1, 0xb1a2, 0x0000, 0x0000, 0xb1a3, 0x0000, 0xb1a4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_10[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb1a6, 0x0000, 0x0000, 0x0000, 0xb1a5, 0xb1a7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xb1a8, 0x0000, 0x0000, 0x0000, 0xb1a9, 0xb1aa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_11[] = {	/*  */
	/*0xa0*/     -1, 0xb1ac, 0x0000, 0x0000, 0xb1ad, 0x0000, 0x0000, 0x0000, 0xb1ab, 0xb1ae, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb1af, 0xb1b0, 0x0000, 0x0000, 0xb1b1, 0x0000, 0xb1b2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_12[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb1b4, 0x0000, 0x0000, 0x0000, 0xb1b3, 0xb1b5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xb1b6, 0x0000, 0x0000, 0xb1b7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_13[] = {	/*  */
	/*0xa0*/     -1, 0xb1b9, 0x0000, 0x0000, 0xb1ba, 0x0000, 0x0000, 0xb1bb, 0xb1b8, 0xb1bc, 0xb1bd, 0xb1be, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0xb1bf, 0xb1c0, 0xb1c1, 0x0000, 0x0000, 0xb1c2, 0x0000, 0xb1c3, 0xb1c4,0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_14[] = {	/*  */
	/*0xa0*/     -1, 0xb1c6, 0x0000, 0x0000, 0xb1c7, 0x0000, 0x0000, 0x0000, 0xb1c5, 0xb1c8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb1c9, 0xb1ca, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_15[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb1cb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb1cc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_16[] = {	/*  */
	/*0xa0*/     -1, 0xb1ce, 0x0000, 0x0000, 0xb1cf, 0x0000, 0x0000, 0x0000, 0xb1cd, 0xb1d0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb1d1, 0xb1d2, 0x0000, 0x0000, 0xb1d3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};


	unsigned int c_dfa_ga_17[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb1d5, 0x0000, 0x0000, 0x0000, 0xb1d4, 0xb1d6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_18[] = {	/*  */
	/*0xa0*/     -1, 0xb1d8, 0x0000, 0x0000, 0xb1d9, 0x0000, 0x0000, 0xb1da, 0xb1d7, 0xb1db, 0xb1dc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb1dd, 0xb1de, 0x0000, 0x0000, 0xb1df, 0x0000, 0xb1e0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_20[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb1e1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ga_19[] = {	/*  */
	/*0xa0*/     -1, 0xb1e3, 0x0000, 0x0000, 0xb1e4, 0x0000, 0x0000, 0xb1e5, 0xb1e2, 0xb1e6, 0x0000, 0xb1e7, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb1e8, 0xb1e9, 0x0000, 0x0000, 0xb1ea, 0x0000, 0xb1eb, 0xb1ec, 0x0000, 0x0000, 0x0000, 0x0000, 0xb1ed, 0x0000
	};


	unsigned int c_dfa_gga_0[] = {	/*  */
	/*0xa0*/     -1, 0xb1ef, 0xb1f0, 0x0000, 0xb1f1, 0x0000, 0x0000, 0x0000, 0xb1ee, 0xb1f2, 0x0000, 0xb1f3, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb1f4, 0x0000, 0x0000, 0x0000, 0xb1f6, 0x0000, 0xb1f8, 0x0000, 0x0000, 0x0000, 0x0000, 0xb1f9, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_1[] = {	/*  */
	/*0xa0*/     -1, 0xb1fb, 0x0000, 0x0000, 0xb1fc, 0x0000, 0x0000, 0x0000, 0xb1fa, 0xb1fd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb1fe, 0xb2a1, 0x0000, 0x0000, 0xb2a2, 0xb2a3, 0xb2a4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_2[] = {	/*  */
	/*0xa0*/     -1, 0xb2a6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb2a5, 0xb2a7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_3[] = {	/*  */
	/*0xa0*/     -1, 0xb2a9, 0xb2aa, 0x0000, 0xb2ab, 0x0000, 0x0000, 0x0000, 0xb2a8, 0xb2ac, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb2ad, 0xb2ae, 0x0000, 0x0000, 0xb2af, 0xb2b0, 0xb2b1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_4[] = {	/*  */
	/*0xa0*/     -1, 0xb2b3, 0x0000, 0x0000, 0xb2b4, 0x0000, 0x0000, 0x0000, 0xb2b2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb2b5, 0x0000, 0x0000, 0x0000, 0xb2b6, 0x0000, 0xb2b7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_5[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb2b9, 0x0000, 0x0000, 0x0000, 0xb2b8, 0xb2ba, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb2bb, 0xb2bc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb2bd, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_16[] = { /*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb0e8, 0x000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xa0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};
	unsigned int c_dfa_gga_6[] = {	/*  */
	/*0xa0*/     -1, 0xb2c0, 0x0000, 0x0000, 0xb2c1, 0x0000, 0xb2c2, 0x0000, 0xb2bf, 0xb2c3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb2c4, 0xb2c5, 0x0000, 0x0000, 0xb2c6, 0x0000, 0xb2c7, 0xb2c8, 0x0000, 0xb2c9, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_7[] = {	/*  */
	/*0xa0*/     -1, 0xb2cb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb2ca, 0xb2cc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb2cd, 0xb2ce, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_8[] = {	/*  */
	/*0xa0*/     -1, 0xb2d0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb2cf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb2d1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_9[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb2d3, 0x0000, 0x0000, 0x0000, 0xb2d2, 0xb2d4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb2d5, 0xb2d6, 0x0000, 0x0000, 0x0000, 0x0000, 0xb2d7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_17[] = { /*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb2d8, 0x000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xa0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_10[] = {	/*  */
	/*0xa0*/     -1, 0xb2da, 0x0000, 0x0000, 0xb2db, 0x0000, 0x0000, 0x0000, 0xb2d9, 0xb2dc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0xb2dd, 0xb2de, 0xb2df, 0x0000, 0x0000, 0xb2e0, 0x0000, 0xb2d1, 0xb2e2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_11[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb2e3, 0xb2e4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb2e5, 0xb2e6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_12[] = {	/*  */
	/*0xa0*/     -1, 0xb2e8, 0x0000, 0x0000, 0xb2e9, 0x0000, 0x0000, 0x0000, 0xb2e7, 0xb2ea, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb2eb, 0xb2ec, 0x0000, 0x0000, 0x0000, 0xb2ed, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb2ef, 0x0000, 0x0000, 0x0000, 0xb2ee, 0xb2f0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb2f1, 0xb2f2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_18[] = { /*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb2f3, 0x000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xa0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_14[] = {	/*  */
	/*0xa0*/     -1, 0xb2f5, 0x0000, 0x0000, 0xb2f6, 0x0000, 0xb2f7, 0x0000, 0xb2f4, 0xb2f8, 0x0000, 0xb2f9, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0xb2fa, 0xb2fb, 0xb2fc, 0x0000, 0x0000, 0xb2fd, 0x0000, 0xb2fe, 0x0000, 0x0000, 0x0000, 0x0000, 0xb3a1, 0x0000, 0x0000
	};

	unsigned int c_dfa_gga_15[] = {	/*  */
	/*0xa0*/     -1, 0xb3a3, 0x0000, 0x0000, 0xb3a4, 0x0000, 0x0000, 0x0000, 0xb3a2, 0xb3a5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb3a6, 0xb3a7, 0x0000, 0x0000, 0xb3a8, 0x0000, 0xb3a9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_0[] = {	/*  */
	/*0xa0*/     -1, 0xb3ab, 0xb3ac, 0x0000, 0xb3ad, 0x0000, 0x0000, 0xb3ae, 0xb3aa, 0xb3af, 0xb3b0, 0xb3b1, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb3b2, 0xb3b3, 0x0000, 0x0000, 0xb3b4, 0xb3b5, 0xb3b6, 0xb3b7, 0x0000, 0xb3b8, 0x0000, 0xb3b9, 0x0000, 0xb3ba
	};

	unsigned int c_dfa_na_1[] = {	/*  */
	/*0xa0*/     -1, 0xb3bc, 0x0000, 0x0000, 0xb3bd, 0x0000, 0x0000, 0x0000, 0xb3bb, 0xb3be, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb3bf, 0xb3c0, 0x0000, 0x0000, 0xb3c1, 0xb3c2, 0xb3c3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_2[] = {	/*  */
	/*0xa0*/     -1, 0xb3c5, 0x0000, 0x0000, 0xb3c6, 0x0000, 0x0000, 0x0000, 0xb3c4, 0xb3c7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb3c8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb3c9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_3[] = {	/*  */
	/*0xa0*/     -1, 0xb3cb, 0x0000, 0xb3cc, 0xb3cd, 0x0000, 0x0000, 0x0000, 0xb3ca, 0xb3ce, 0x0000, 0xb3cf, 0xb3d0, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb3d1, 0xb3d2, 0x0000, 0x0000, 0xb3d3, 0xb3d4, 0xb3d5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb3d6
	};

	unsigned int c_dfa_na_4[] = {	/*  */
	/*0xa0*/     -1, 0xb3d8, 0x0000, 0x0000, 0xb3d9, 0x0000, 0x0000, 0x0000, 0xb3d7, 0xb3da, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb3db, 0xb3dc, 0x0000, 0x0000, 0xb3dd, 0xb3de, 0xb3df, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_5[] = {	/*  */
	/*0xa0*/     -1, 0xb3e1, 0x0000, 0x0000, 0xb3e2, 0x0000, 0x0000, 0x0000, 0xb3e0, 0xb3e3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb3e4, 0xb3e5, 0x0000, 0x0000, 0x0000, 0xb3e6, 0xb3e7, 0x0000, 0x0000, 0x0000, 0xb3e8, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_6[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb3ea, 0x0000, 0x0000, 0x0000, 0xb3e9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_7[] = {	/*  */
	/*0xa0*/     -1, 0xb3ec, 0x0000, 0x0000, 0xb3ed, 0x0000, 0x0000, 0x0000, 0xb3eb, 0xb3ee, 0x0000, 0xb3ef, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb3f0, 0xb3f1, 0x0000, 0x0000, 0xb3f2, 0x0000, 0xb3f3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb3f4, 0xb3f5
	};

	unsigned int c_dfa_na_8[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb3f7, 0x0000, 0x0000, 0x0000, 0xb3f6, 0xb3f8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb3f9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_9[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb3fb, 0x0000, 0x0000, 0x0000, 0xb3fa, 0xb4fc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb3fd, 0xb3fe, 0x0000, 0x0000, 0xb4a1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_10[] = {	/*  */
	/*0xa0*/     -1, 0xb4a3, 0x0000, 0x0000, 0xb4a4, 0x0000, 0x0000, 0x0000, 0xb4a2, 0xb4a5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xb4a6, 0x0000, 0x0000, 0xb4a7, 0x0000, 0xb4a8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_11[] = {	/*  */
	/*0xa0*/     -1, 0xb4aa, 0x0000, 0x0000, 0xb4ab, 0x0000, 0x0000, 0xb4ac, 0xb4a9, 0xb4ad, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb4ae, 0xb4af, 0x0000, 0x0000, 0xb4b0, 0x0000, 0xb4b1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_12[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb4b2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb4b3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_18[] = { /*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb4b4, 0x000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xa0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb4b6, 0x0000, 0x0000, 0x0000, 0xb4b5, 0xb4b7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb4b8, 0xb4b9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_14[] = {	/*  */
	/*0xa0*/     -1, 0xb4bb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb4ba, 0xb4bc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb4bd, 0xb4be, 0x0000, 0x0000, 0x0000, 0x0000, 0xb4bf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_15[] = {	/*  */
	/*0xa0*/     -1, 0xb4c1, 0x0000, 0x0000, 0xb4c2, 0x0000, 0x0000, 0x0000, 0xb4c0, 0xb4c3, 0xb4c4, 0xb4c5, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb4c6, 0xb4c7, 0x0000, 0x0000, 0xb4c8, 0x0000, 0xb4c9, 0xb4ca, 0x0000, 0x0000, 0x0000, 0x0000, 0xb4cb, 0x0000
	};

	unsigned int c_dfa_na_16[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb4cd, 0x0000, 0x0000, 0x0000, 0xb4cc, 0xb4ce, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_na_17[] = {	/*  */
	/*0xa0*/     -1, 0xb4d0, 0x0000, 0x0000, 0xb4d1, 0x0000, 0x0000, 0x0000, 0xb4cf, 0xb4d2, 0x0000, 0xb4d3, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb4d4, 0xb4d5, 0x0000, 0x0000, 0xb4d6, 0x0000, 0xb4d7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb4d8, 0x0000
	};

	unsigned int c_dfa_da_0[] = {	/*  */
	/*0xa0*/     -1, 0xb4da, 0xb4db, 0x0000, 0xb4dc, 0x0000, 0x0000, 0xb4dd, 0xb4d9, 0xb4de, 0xb4df, 0xb4e0, 0xb4e1, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0xb4e2, 0xb4e3, 0xb4e4, 0x0000, 0x0000, 0xb4e5, 0xb4e6, 0xb4e7, 0xb4e8, 0x0000, 0xb4e9, 0x0000, 0x0000, 0x0000, 0xb4ea
	};

	unsigned int c_dfa_da_1[] = {	/*  */
	/*0xa0*/     -1, 0xb4ec, 0x0000, 0x0000, 0xb4ed, 0x0000, 0x0000, 0x0000, 0xb4eb, 0xb4ee, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb4ef, 0xb4f0, 0x0000, 0x0000, 0xb4f1, 0xb4f2, 0xb4f3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_18[] = { /*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb4f4, 0x000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xa0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_2[] = {	/*  */
	/*0xa0*/     -1, 0xb4f6, 0xb4f7, 0x0000, 0xb4f8, 0x0000, 0x0000, 0xb4f9, 0xb4f5, 0xb4fa, 0x0000, 0xb4fb, 0xb4fc, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb4fd, 0xb4fe, 0x0000, 0x0000, 0xb5a1, 0x0000, 0xb5a2, 0x0000, 0x0000, 0xb5a3, 0x0000, 0x0000, 0xb5a4, 0x0000
	};

	unsigned int c_dfa_da_3[] = {	/*  */
	/*0xa0*/     -1, 0xb5a6, 0x0000, 0x0000, 0xb5a7, 0x0000, 0x0000, 0x0000, 0xb5a5, 0xb5a8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb5a9, 0xb5aa, 0x0000, 0x0000, 0xb5ab, 0xb5ac, 0xb5ad, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_4[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb5af, 0x0000, 0x0000, 0x0000, 0xb5ae, 0xb5b0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb5b1, 0xb5b2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_5[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb5b4, 0x0000, 0x0000, 0x0000, 0xb5b3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_6[] = {	/*  */
	/*0xa0*/     -1, 0xb5b6, 0x0000, 0x0000, 0xb5b7, 0x0000, 0x0000, 0xb5b7, 0xb5b5, 0xb5b9, 0x0000, 0xb5ba, 0x0000, 0xb5bb, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb5bc, 0xb5bd, 0x0000, 0x0000, 0xb5be, 0x0000, 0xb5bf, 0x0000, 0x0000, 0xb5c0, 0x0000, 0xb5c1, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_7[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb5c3, 0x0000, 0x0000, 0x0000, 0xb5c2, 0xb5c4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_8[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb5c5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb5c6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_9[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb5c8, 0x0000, 0x0000, 0x0000, 0xb5c7, 0xb5c9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb5ca, 0xb5cb, 0x0000, 0x0000, 0xb5cc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_19[] = { /*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb5cd, 0x000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xa0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_10[] = {	/*  */
	/*0xa0*/     -1, 0xb5cf, 0x0000, 0x0000, 0xb5d0, 0x0000, 0x0000, 0x0000, 0xb5ce, 0xb5d1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb5d2, 0xb5d3, 0x0000, 0x0000, 0xb5d4, 0x0000, 0xb5d5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_11[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb5d6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb5d7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_12[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb5d8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb5d9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb5db, 0x0000, 0x0000, 0x0000, 0xb5da, 0xb5dc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xb5dd, 0x0000, 0x0000, 0xb5de, 0x0000, 0xb5df, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_14[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb5e1, 0x0000, 0x0000, 0x0000, 0xb5e0, 0xb5e2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb5e3, 0xb5e4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_15[] = {	/*  */
	/*0xa0*/     -1, 0xb5e6, 0x0000, 0x0000, 0xb5e7, 0x0000, 0x0000, 0xb5e8, 0xb5e5, 0xb5e9, 0x0000, 0xb5ea, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb5eb, 0xb5ec, 0x0000, 0x0000, 0xb5ed, 0x0000, 0xb5ee, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_16[] = {	/*   */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb5ef, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_da_17[] = {	/*   */
	/*0xa0*/     -1, 0xb5f1, 0x0000, 0x0000, 0xb5f2, 0x0000, 0x0000, 0xb5f3, 0xb5f0, 0xb5f4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb5f5, 0xb5f6, 0x0000, 0x0000, 0xb5f7, 0xb5f8, 0xb5f9, 0xb5fa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_0[] = {	/*  */
	/*0xa0*/     -1, 0xb5fc, 0x0000, 0x0000, 0xb5fd, 0x0000, 0x0000, 0x0000, 0xb5fb, 0xb5fe, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb6a1, 0xb6a2, 0x0000, 0x0000, 0xb6a3, 0xb6a4, 0xb6a5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb6a6
	};

	unsigned int c_dfa_dda_1[] = {	/*  */
	/*0xa0*/     -1, 0xb6a8, 0x0000, 0x0000, 0xb6a9, 0x0000, 0x0000, 0x0000, 0xb6a7, 0xb6aa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb6ab, 0xb6ac, 0x0000, 0x0000, 0xb6ad, 0xb6ae, 0xb6af, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_2[] = {	/*  */
	/*0xa0*/     -1, 0xb6b1, 0x0000, 0x0000, 0xb6b2, 0x0000, 0x0000, 0x0000, 0xb6b0, 0xb6b3, 0x0000, 0xb6b4, 0xb6b5, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb6b6, 0xb6b7, 0x0000, 0x0000, 0xb6b8, 0xb6b9, 0xb6ba, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb6bb
	};

	unsigned int c_dfa_dda_3[] = {	/*  */
	/*0xa0*/     -1, 0xb6bd, 0x0000, 0x0000, 0xb6be, 0x0000, 0x0000, 0x0000, 0xb6bc, 0xb6bf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb6c0, 0xb6c1, 0x0000, 0x0000, 0xb6c2, 0xb6c3, 0xb6c4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_4[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb6c5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb6c6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_5[] = {	/*  */
	/*0xa0*/     -1, 0xb6c8, 0x0000, 0x0000, 0xb6c9, 0x0000, 0x0000, 0x0000, 0xb6c7, 0xb6ca, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb6cb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_6[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb6cc, 0xb6cd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_7[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb6ce, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_8[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb6d0, 0x0000, 0x0000, 0x0000, 0xb6cf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_9[] = {	/*  */
	/*0xa0*/     -1, 0xb6d2, 0x0000, 0x0000, 0xb6d3, 0x0000, 0x0000, 0x0000, 0xb6d1, 0xb6d4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0xb6d5, 0xb6d6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb6d7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_10[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb6d8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_11[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb6da, 0x0000, 0x0000, 0x0000, 0xb6d9, 0xb6db, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb6dc, 0xb6dd, 0x0000, 0x0000, 0x0000, 0x0000, 0xb6de, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_12[] = {	/*  */
	/*0xa0*/     -1, 0xb6e0, 0x0000, 0x0000, 0xb6e1, 0x0000, 0x0000, 0xb6e2, 0xb6df, 0xb6e3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb6e4, 0xb6e5, 0x0000, 0x0000, 0xb6e6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb6e8, 0x0000, 0x0000, 0x0000, 0xb6e7, 0xb6e9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb6ea, 0xb6eb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_dda_14[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb6ed, 0x0000, 0x0000, 0x0000, 0xb6ec, 0xb6ee, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb6ef, 0xb6f0, 0x0000, 0x0000, 0xb6f1, 0x0000, 0xb6f2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_0[] = {	/*  */
	/*0xa0*/     -1, 0xb6f4, 0x0000, 0x0000, 0xb6f5, 0x0000, 0x0000, 0x0000, 0xb6f3, 0xb6f6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb6f7, 0xb6f8, 0x0000, 0x0000, 0xb6f9, 0xb6fa, 0xb6fb, 0xb6fc, 0x0000, 0x0000, 0x0000, 0x0000, 0xb6fd, 0xb6fe
	};

	unsigned int c_dfa_ra_1[] = {	/*  */
	/*0xa0*/     -1, 0xb7a2, 0x0000, 0x0000, 0xb7a3, 0x0000, 0x0000, 0x0000, 0xb7a1, 0xb7a4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb7a5, 0xb7a6, 0x0000, 0x0000, 0xb7a7, 0xb7a8, 0xb7a9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_2[] = {	/*  */
	/*0xa0*/     -1, 0xb7ab, 0x0000, 0x0000, 0xb7ac, 0x0000, 0x0000, 0x0000, 0xb7aa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb7ad, 0x0000, 0xb7ae, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_3[] = {	/*  */
	/*0xa0*/     -1, 0xb7b0, 0x0000, 0x0000, 0xb7b1, 0x0000, 0x0000, 0x0000, 0xb7af, 0xb7b2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb7b3, 0xb7b4, 0x0000, 0x0000, 0xb7b5, 0xb7b6, 0xb7b7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb7b8
	};

	unsigned int c_dfa_ra_4[] = {	/*  */
	/*0xa0*/     -1, 0xb7ba, 0x0000, 0x0000, 0xb7bb, 0x0000, 0x0000, 0x0000, 0xb7b9, 0xb7bc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb7bd, 0xb7be, 0x0000, 0x0000, 0xb7bf, 0x0000, 0xb7c0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_5[] = {	/*  */
	/*0xa0*/     -1, 0xb7c2, 0x0000, 0x0000, 0xb7c3, 0x0000, 0x0000, 0x0000, 0xb7c1, 0xb7c4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb7c5, 0xb7c6, 0x0000, 0x0000, 0xb7c7, 0xb7c8, 0xb8c9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_6[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb7cb, 0x0000, 0x0000, 0x0000, 0xb7ca, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xb7cc, 0x0000, 0x0000, 0xb7cd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_7[] = {	/*  */
	/*0xa0*/     -1, 0xb7cf, 0x0000, 0x0000, 0xb7d0, 0x0000, 0x0000, 0x0000, 0xb7ce, 0xb7d1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb7d2, 0xb7d3, 0x0000, 0x0000, 0xb7d4, 0x0000, 0xb7d5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_8[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb7d7, 0x0000, 0x0000, 0x0000, 0xb7d6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb7d8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_9[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb7d9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_10[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb7db, 0x0000, 0x0000, 0x0000, 0xb7da, 0xb7dc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb7dd, 0xb7de, 0x0000, 0x0000, 0xb7df, 0x0000, 0xb7e0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_11[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb7e2, 0x0000, 0x0000, 0x0000, 0xb7e1, 0xb7e3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb7e5, 0x0000, 0xb6e6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_12[] = {	/*  */
	/*0xa0*/     -1, 0xb7e8, 0x0000, 0x0000, 0xb7e9, 0x0000, 0x0000, 0x0000, 0xb7e7, 0xb7ea, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb7eb, 0xb7ec, 0x0000, 0x0000, 0xb7ed, 0x0000, 0xb7ee, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb7ef, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb7f0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_14[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb7f1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_15[] = {	/*  */
	/*0xa0*/     -1, 0xb7f3, 0x0000, 0x0000, 0xb7f4, 0x0000, 0x0000, 0x0000, 0xb7f2, 0xb7f5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb7f6, 0x0000, 0x0000, 0x0000, 0xb7f7, 0x0000, 0xb7f8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_16[] = {	/*  */
	/*0xa0*/     -1, 0xb7fa, 0x0000, 0x0000, 0xb7fb, 0x0000, 0x0000, 0x0000, 0xb7f9, 0xb7fc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb7fd, 0xb7fe, 0x0000, 0x0000, 0xb8a1, 0x0000, 0xb8a2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ra_17[] = {	/*  */
	/*0xa0*/     -1, 0xb8a4, 0x0000, 0x0000, 0xb8a5, 0x0000, 0x0000, 0x0000, 0xb8a3, 0xb8a6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb8a7, 0xb8a8, 0x0000, 0x0000, 0xb8a9, 0x0000, 0xb8aa, 0xb8ab, 0x0000, 0x0000, 0x0000, 0xb8ac, 0xb8ad, 0x0000
	};

	unsigned int c_dfa_ra_18[] = {	/*  */
	/*0xa0*/     -1, 0xb8af, 0x0000, 0x0000, 0xb8b0, 0x0000, 0x0000, 0x0000, 0xb8ae, 0xb8b1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb8b2, 0xb8b3, 0x0000, 0x0000, 0xb8b4, 0x0000, 0xb8b5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};


	unsigned int c_dfa_ma_0[] = {	/*  */
	/*0xa0*/     -1, 0xb8b7, 0x0000, 0x0000, 0xb8b8, 0x0000, 0xb8b9, 0xb8ba, 0xb8b6, 0xb8bb, 0xb8bc, 0xb8bd, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb8be, 0xb8bf, 0x0000, 0x0000, 0xb8c0, 0x0000, 0xb8c1, 0xb8c2, 0x0000, 0x0000, 0x0000, 0xb8c3, 0x0000, 0xb8c4
	};

	unsigned int c_dfa_ma_1[] = {	/*  */
	/*0xa0*/     -1, 0xb8c6, 0x0000, 0x0000, 0xb8c7, 0x0000, 0x0000, 0x0000, 0xb8c5, 0xb8c8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb8c9, 0xb8ca, 0x0000, 0x0000, 0xb8cb, 0xb8cc, 0xb8cd, 0xb8ce, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_2[] = {	/*  */
	/*0xa0*/     -1, 0xb8d0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb8cf, 0xb8d1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb8d2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_3[] = {	/*  */
	/*0xa0*/     -1, 0xb8d4, 0x0000, 0x0000, 0xb8d5, 0x0000, 0x0000, 0x0000, 0xb8d3, 0xb8d6, 0x0000, 0xb8d7, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb8d8, 0xb8d9, 0x0000, 0x0000, 0xb8da, 0x0000, 0xb8db, 0xb8dc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb8dd
	};

	unsigned int c_dfa_ma_4[] = {	/*  */
	/*0xa0*/     -1, 0xb8df, 0x0000, 0x0000, 0xb8e0, 0x0000, 0x0000, 0x0000, 0xb8de, 0xb8e1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb8e2, 0xb8e3, 0x0000, 0x0000, 0xb8e4, 0xb8e5, 0xb8e6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_5[] = {	/*  */
	/*0xa0*/     -1, 0xb8e8, 0x0000, 0x0000, 0xb8e9, 0x0000, 0x0000, 0x0000, 0xb8e7, 0xb8ea, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb8eb, 0xb8ec, 0xb8ed, 0x0000, 0x0000, 0xb8ee, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_6[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb8ef, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_7[] = {	/*  */
	/*0xa0*/     -1, 0xb8f1, 0x0000, 0xb8f2, 0xb8f3, 0x0000, 0x0000, 0x0000, 0xb8f0, 0xb8f4, 0x0000, 0xb8f5, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb8f6, 0xb8f7, 0x0000, 0x0000, 0xb8f8, 0x0000, 0xb8f9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_8[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb8fb, 0x0000, 0x0000, 0x0000, 0xb8fa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb8fc, 0xb8fd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_9[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb9a1, 0x0000, 0x0000, 0x0000, 0xb8fe, 0xb9a2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xb9a3, 0x0000, 0x0000, 0xb9a4, 0x0000, 0xb9a5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_10[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb9a7, 0x0000, 0x0000, 0x0000, 0xb9a6, 0xb9a8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xb9a9, 0x0000, 0x0000, 0xb9aa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_11[] = {	/*  */
	/*0xa0*/     -1, 0xb9ac, 0xb9ad, 0x0000, 0xb9ae, 0x0000, 0x0000, 0xb9af, 0xb9ab, 0xb9b0, 0xb9b1, 0xb9b2, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb9b3, 0xb9b4, 0x0000, 0x0000, 0xb9b5, 0x0000, 0xb9b6, 0x0000, 0x0000, 0x0000, 0x0000, 0xb9b7, 0x0000, 0xb9b8
	};

	unsigned int c_dfa_ma_12[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb9ba, 0x0000, 0x0000, 0x0000, 0xb9b9, 0xb9bb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xb9bc, 0x0000, 0x0000, 0xb9bd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xb9be, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_14[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb9c0, 0x0000, 0x0000, 0x0000, 0xb9bf, 0xb9c1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};
	
	unsigned int c_dfa_ma_15[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb9c3, 0x0000, 0x0000, 0x0000, 0xb9c2, 0xb9c4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb9c5, 0x0000, 0x0000, 0x0000, 0xb9c6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_16[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xb9c8, 0x0000, 0x0000, 0x0000, 0xb9c7, 0xb9c9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb9ca, 0x0000, 0x0000, 0x0000, 0xb9cb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ma_17[] = {	/*  */
	/*0xa0*/     -1, 0xb9cd, 0x0000, 0x0000, 0xb9ce, 0x0000, 0x0000, 0xb9cf, 0xb9cc, 0xb9d0, 0x0000, 0xb9d1, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb9d2, 0xb9d3, 0x0000, 0x0000, 0xb9d4, 0xb9d5, 0xb9d6, 0x0000, 0x0000, 0xb9d7, 0x0000, 0xb9d8, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_0[] = {	/*  */
	/*0xa0*/     -1, 0xb9da, 0xb9db, 0xb9dc, 0xb9dd, 0x0000, 0x0000, 0xb9de, 0xb9d9, 0xb9df, 0xb9e0, 0xb9e1, 0xb9e2, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb9e3, 0xb9e4, 0x0000, 0x0000, 0xb9e5, 0x0000, 0xb9e6, 0x0000, 0x0000, 0x0000, 0x0000, 0xb9e7, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_1[] = {	/*  */
	/*0xa0*/     -1, 0xb9e9, 0x0000, 0x0000, 0xb9ea, 0x0000, 0x0000, 0x0000, 0xb9e8, 0xb9eb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb9ec, 0xb9ed, 0x0000, 0x0000, 0xb9ee, 0xb9ef, 0xb9f0, 0x0000, 0x0000, 0x0000, 0x0000, 0xb9f1, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_2[] = {	/*  */
	/*0xa0*/     -1, 0xb9f3, 0x0000, 0x0000, 0xb9f4, 0x0000, 0x0000, 0x0000, 0xb9f2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xb9f5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_3[] = {	/*  */
	/*0xa0*/     -1, 0xb9f7, 0x0000, 0x0000, 0xb9f8, 0x0000, 0x0000, 0xb9f9, 0xb9f6, 0xb9fa, 0x0000, 0xb9fb, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xb9fc, 0xb9fd, 0x0000, 0x0000, 0xb9fe, 0x0000, 0xbaa1, 0xbaa2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_4[] = {	/*  */
	/*0xa0*/     -1, 0xbaa4, 0x0000, 0x0000, 0xbaa5, 0x0000, 0x0000, 0xbaa6, 0xbaa3, 0xbaa7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbaa8, 0xbaa9, 0x0000, 0x0000, 0xbaaa, 0xbaab, 0xbaac, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_5[] = {	/*  */
	/*0xa0*/     -1, 0xbaae, 0x0000, 0x0000, 0xbaaf, 0x0000, 0x0000, 0x0000, 0xbaad, 0xbab0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xbab1, 0x0000, 0x0000, 0xbab2, 0xbab3, 0xbab4, 0x0000, 0x0000, 0x0000, 0x0000, 0xbab5, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_6[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbab7, 0x0000, 0x0000, 0x0000, 0xbab6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_7[] = {	/*  */
	/*0xa0*/     -1, 0xbab9, 0xbaba, 0x0000, 0xbabb, 0x0000, 0x0000, 0x0000, 0xbab8, 0xbabc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbabd, 0xbabe, 0x0000, 0x0000, 0xbabf, 0x0000, 0xbac0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_8[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbac2, 0x0000, 0x0000, 0x0000, 0xbac1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbac3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_9[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbac4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbac5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_10[] = {	/*  */
	/*0xa0*/     -1, 0xbac7, 0x0000, 0x0000, 0xbac8, 0x0000, 0x0000, 0x0000, 0xbac6, 0xbac9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbaca, 0xbacb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_11[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbacd, 0x0000, 0x0000, 0x0000, 0xbacc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_12[] = {	/*  */
	/*0xa0*/     -1, 0xbacf, 0x0000, 0x0000, 0xbad0, 0x0000, 0x0000, 0xbad1, 0xbace, 0xbad2, 0xbad3, 0xbad4, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbad5, 0xbad6, 0x0000, 0x0000, 0xbad7, 0x0000, 0xbad8, 0x0000, 0x0000, 0x0000, 0x0000, 0xbad9, 0xbada, 0x0000
	};

	unsigned int c_dfa_ba_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbadb, 0xbadc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbadd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_14[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbade, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_15[] = {	/*  */
	/*0xa0*/     -1, 0xbae0, 0x0000, 0x0000, 0xbae1, 0x0000, 0x0000, 0x0000, 0xbadf, 0xbae2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbae3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_16[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbae5, 0x0000, 0x0000, 0x0000, 0xbae4, 0xbae6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbae7, 0x0000, 0x0000, 0x0000, 0xbae8, 0x0000, 0xbae9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_17[] = {	/*  */
	/*0xa0*/     -1, 0xbaeb, 0x0000, 0x0000, 0xbaec, 0x0000, 0x0000, 0x0000, 0xbaea, 0xbaed, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbaee, 0xbaef, 0x0000, 0x0000, 0xbaf0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ba_18[] = {	/*  */
	/*0xa0*/     -1, 0xbaf2, 0x0000, 0x0000, 0xbaf3, 0x0000, 0x0000, 0x0000, 0xbaf1, 0xbaf4, 0x0000, 0xbaf5, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbaf6, 0xbaf7, 0x0000, 0x0000, 0xbaf8, 0x0000, 0xbaf9, 0xbafa, 0x0000, 0xbafb, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_bba_0[] = {	/*  */
	/*0xa0*/     -1, 0xbafd, 0x0000, 0x0000, 0xbafe, 0x0000, 0x0000, 0x0000, 0xbafc, 0xbba1, 0x0000, 0xbba2, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbba3, 0xbba4, 0x0000, 0x0000, 0xbba5, 0xbba6, 0xbba7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbba8
	};

	unsigned int c_dfa_bba_1[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0xbbaa, 0x0000, 0xbbab, 0x0000, 0x0000, 0x0000, 0xbba9, 0xbbac, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbbad, 0xbbae, 0x0000, 0x0000, 0xbbaf, 0xbbb0, 0xbbb1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_bba_2[] = {	/*  */
	/*0xa0*/     -1, 0xbbb3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbbb2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbbb4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_bba_3[] = {	/*  */
	/*0xa0*/     -1, 0xbbb6, 0x0000, 0x0000, 0xbbb7, 0x0000, 0x0000, 0xbbb8, 0xbbb5, 0xbbb9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbbba, 0x0000, 0x0000, 0x0000, 0xbbbb, 0xbbbc, 0xbbbd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_bba_4[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbbbe, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbbbf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_bba_5[] = {	/*  */
	/*0xa0*/     -1, 0xbbc1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbbc0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbbc2, 0xbbc3, 0x0000, 0x0000, 0xbbc4, 0xbbc5, 0xbbc6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_bba_6[] = {	/*  */
	/*0xa0*/     -1, 0xbbc8, 0x0000, 0x0000, 0xbbc9, 0x0000, 0x0000, 0x0000, 0xbbc7, 0xbbca, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbbcb, 0xbbcc, 0x0000, 0x0000, 0x0000, 0x0000, 0xbbcd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_bba_7[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbbce, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_bba_8[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbbcf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbbd0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_bba_9[] = {	/*  */
	/*0xa0*/     -1, 0xbbd2, 0x0000, 0x0000, 0xbbd3, 0x0000, 0x0000, 0x0000, 0xbbd1, 0xbbd4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbbd5, 0x0000, 0x0000, 0x0000, 0xbbd6, 0x0000, 0xbbd7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_bba_10[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbbd8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbbd9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_bba_11[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbbdb, 0x0000, 0x0000, 0x0000, 0xbbda, 0xbbdc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbbdd, 0xbbde, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_bba_12[] = {	/*  */
	/*0xa0*/     -1, 0xbbe0, 0x0000, 0x0000, 0xbbe1, 0x0000, 0x0000, 0x0000, 0xbbdf, 0xbbe2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbbe3, 0xbbe4, 0x0000, 0x0000, 0xbbe5, 0x0000, 0xbbe6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_0[] = {	/*  */
	/*0xa0*/     -1, 0xbbe8, 0x0000, 0xbbe9, 0xbbea, 0x0000, 0x0000, 0xbbeb, 0xbbe7, 0xbbec, 0xbbed, 0xbbee, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbbef, 0xbbf0, 0x0000, 0x0000, 0xbbf1, 0xbbf2, 0xbbf3, 0x0000, 0x0000, 0x0000, 0x0000, 0xbbf4, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_1[] = {	/*  */
	/*0xa0*/     -1, 0xbbf6, 0x0000, 0x0000, 0xbbf7, 0x0000, 0x0000, 0x0000, 0xbbf5, 0xbbf8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbbf9, 0xbbfa, 0x0000, 0x0000, 0xbbfb, 0xbbfc, 0xbbfd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_2[] = {	/*  */
	/*0xa0*/     -1, 0xbca1, 0x0000, 0x0000, 0xbca2, 0x0000, 0x0000, 0x0000, 0xbbfe, 0xbca3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbca4, 0xbca5, 0x0000, 0x0000, 0xbca6, 0x0000, 0xbca7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_3[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbca9, 0x0000, 0x0000, 0x0000, 0xbca8, 0xbcaa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbcab, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbcac, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_4[] = {	/*  */
	/*0xa0*/     -1, 0xbcae, 0xbcaf, 0xbcb0, 0xbcb1, 0x0000, 0x0000, 0xbcb2, 0xbcad, 0xbcb3, 0x0000, 0xbcb4, 0xbcb5, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbcb6, 0xbcb7, 0x0000, 0x0000, 0xbcb8, 0xbcb9, 0xbcba, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbcbb, 0x0000
	};

	unsigned int c_dfa_sa_5[] = {	/*  */
	/*0xa0*/     -1, 0xbcbd, 0x0000, 0x0000, 0xbcbe, 0x0000, 0x0000, 0x0000, 0xbcbc, 0xbcbf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbcc0, 0xbcc1, 0x0000, 0x0000, 0xbcc2, 0xbcc3, 0xbcc4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_6[] = {	/*  */
	/*0xa0*/     -1, 0xbcc6, 0x0000, 0x0000, 0xbcc7, 0x0000, 0x0000, 0x0000, 0xbcc5, 0xbcc8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbcc9, 0xbcca, 0x0000, 0x0000, 0xbccb, 0xbccc, 0xbccd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_7[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbccf, 0x0000, 0x0000, 0x0000, 0xbcce, 0xbcd0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbcd1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_8[] = {	/*  */
	/*0xa0*/     -1, 0xbcd3, 0xbcd4, 0x0000, 0xbcd5, 0x0000, 0x0000, 0x0000, 0xbcd2, 0xbcd6, 0x0000, 0xbcd7, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbcd8, 0xbcd9, 0x0000, 0x0000, 0xbcda, 0x0000, 0xbcdb, 0x0000, 0x0000, 0x0000, 0x0000, 0xbcdc, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_9[] = {	/*  */
	/*0xa0*/     -1, 0xbcde, 0x0000, 0x0000, 0xbcdf, 0x0000, 0x0000, 0x0000, 0xbcdd, 0xbce0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbce1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_10[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbce3, 0x0000, 0x0000, 0x0000, 0xbce2, 0xbce4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbce5, 0x0000, 0x0000, 0x0000, 0xbce6, 0xbce7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_11[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbce9, 0x0000, 0x0000, 0x0000, 0xbce8, 0xbcea, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbceb, 0xbcec, 0x0000, 0x0000, 0xbced, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_12[] = {	/*  */
	/*0xa0*/     -1, 0xbcef, 0x0000, 0x0000, 0xbcf0, 0x0000, 0x0000, 0x0000, 0xbcee, 0xbcf1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbcf2, 0xbcf3, 0x0000, 0x0000, 0xbcf4, 0x0000, 0xbcf5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_13[] = {	/*  */
	/*0xa0*/     -1, 0xbcf7, 0x0000, 0x0000, 0xbcf8, 0x0000, 0x0000, 0xbcf9, 0xbcf6, 0xbcfa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbcfb, 0xbcfc, 0x0000, 0x0000, 0xbcfd, 0x0000, 0xbcfe, 0x0000, 0x0000, 0xbda1, 0x0000, 0xbda2, 0xbda3, 0x0000
	};

	unsigned int c_dfa_sa_14[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbda4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbda5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_15[] = {	/*  */
	/*0xa0*/     -1, 0xbda7, 0x0000, 0x0000, 0xbda8, 0x0000, 0x0000, 0x0000, 0xbda6, 0xbda9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbdaa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbdab, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_16[] = {	/*  */
	/*0xa0*/     -1, 0xbdad, 0x0000, 0x0000, 0xbdae, 0x0000, 0x0000, 0x0000, 0xbdac, 0xbdaf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbdb0, 0xbdb1, 0x0000, 0x0000, 0xbdb2, 0x0000, 0xbdb3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_17[] = {	/*  */
	/*0xa0*/     -1, 0xbdb5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbdb4, 0xbdb6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbdb7, 0x0000, 0x0000, 0x0000, 0xbdb8, 0x0000, 0xbdb9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_18[] = {	/*  */
	/*0xa0*/     -1, 0xbdbb, 0x0000, 0x0000, 0xbdbc, 0x0000, 0x0000, 0x0000, 0xbdba, 0xbdbd, 0xbdbe, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbdbf, 0xbdc0, 0x0000, 0x0000, 0xbdc1, 0x0000, 0xbdc2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_sa_19[] = {	/*  */
	/*0xa0*/     -1, 0xbdc4, 0x0000, 0x0000, 0xbdc5, 0x0000, 0x0000, 0xbdc6, 0xbdc3, 0xbdc7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0xbdc8, 0xbdc9, 0xbdca, 0x0000, 0x0000, 0xbdcb, 0x0000, 0xbdcc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbdcd, 0x0000
	};

	unsigned int c_dfa_ssa_0[] = {	/*  */
	/*0xa0*/     -1, 0xbdcf, 0x0000, 0xbdd0, 0xbdd1, 0x0000, 0x0000, 0x0000, 0xbdce, 0xbdd2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbdd3, 0xbdd4, 0x0000, 0x0000, 0x0000, 0xbdd5, 0xbdd6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbdd7
	};

	unsigned int c_dfa_ssa_1[] = {	/*  */
	/*0xa0*/     -1, 0xbdd9, 0x0000, 0x0000, 0xbdda, 0x0000, 0x0000, 0x0000, 0xbdd8, 0xbddb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbddc, 0xbddd, 0x0000, 0x0000, 0x0000, 0xbdde, 0xbddf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_2[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbde0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_3[] = {	/*  */
	/*0xa0*/     -1, 0xbde2, 0x0000, 0x0000, 0xbde3, 0x0000, 0x0000, 0x0000, 0xbde1, 0xbde4, 0x0000, 0xbde5, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbde6, 0xbde7, 0x0000, 0x0000, 0x0000, 0xbde8, 0xbde9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_4[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbdeb, 0x0000, 0x0000, 0x0000, 0xbdea, 0xbdec, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_5[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbded, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_6[] = {	/*  */
	/*0xa0*/     -1, 0xbdef, 0x0000, 0x0000, 0xbdf0, 0x0000, 0x0000, 0xbdf1, 0xbdee, 0xbdf2, 0x0000, 0xbdf3, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbdf4, 0xbdf5, 0x0000, 0x0000, 0x0000, 0x0000, 0xbdf6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_7[] = {	/*  */
	/*0xa0*/     -1, 0xbdf8, 0x0000, 0x0000, 0xbdf9, 0x0000, 0x0000, 0x0000, 0xbdf7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbdfa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_8[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbdfb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbdfc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_9[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbdfe, 0x0000, 0x0000, 0x0000, 0xbdfd, 0xbea1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbea2, 0xbea3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_10[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbea4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_11[] = {	/*  */
	/*0xa0*/     -1, 0xbea6, 0x0000, 0x0000, 0xbea7, 0x0000, 0x0000, 0x0000, 0xbea5, 0xbea8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbea9, 0xbeaa, 0x0000, 0x0000, 0x0000, 0x0000, 0xbeab, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_12[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbeac, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbead, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbeae, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_14[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbeb0, 0x0000, 0x0000, 0x0000, 0xbeaf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_15[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xbeb1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_16[] = {	/*  */
	/*0xa0*/     -1, 0xbeb3, 0x0000, 0x0000, 0xbeb4, 0x0000, 0x0000, 0x0000, 0xbeb2, 0xbeb5, 0x0000, 0xbeb6, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0xbeb7, 0xbeb8, 0xbeb9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_17[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbebb, 0x0000, 0x0000, 0x0000, 0xbeba, 0xbebc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbebd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ssa_18[] = {	/*  */
	/*0xa0*/     -1, 0xbebf, 0x0000, 0x0000, 0xbec0, 0x0000, 0x0000, 0x0000, 0xbebe, 0xbec1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbec2, 0xbec3, 0x0000, 0x0000, 0xbec4, 0x0000, 0xbec5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_0[] = {	/*  */
	/*0xa0*/     -1, 0xbec7, 0x0000, 0x0000, 0xbec8, 0xbec9, 0xbeca, 0x0000, 0xbec6, 0xbecb, 0xbecc, 0xbecd, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0xbece, 0xbecf, 0xbed0, 0x0000, 0x0000, 0xbed1, 0xbed2, 0xbed3, 0x0000, 0x0000, 0x0000, 0x0000, 0xbed4, 0xbed5, 0x0000
	};

	unsigned int c_dfa_a_1[] = {	/*  */
	/*0xa0*/     -1, 0xbed7, 0x0000, 0x0000, 0xbed8, 0x0000, 0x0000, 0x0000, 0xbed6, 0xbed9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbeda, 0xbedb, 0x0000, 0x0000, 0xbedc, 0xbedd, 0xbede, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_2[] = {	/*  */
	/*0xa0*/     -1, 0xbee0, 0x0000, 0x0000, 0xbee1, 0x0000, 0x0000, 0x0000, 0xbedf, 0xbee2, 0x0000, 0x0000, 0xbee3, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbee4, 0xbee5, 0x0000, 0x0000, 0xbee6, 0x0000, 0xbee7, 0x0000, 0x0000, 0x0000, 0x0000, 0xbee8, 0x0000, 0xbee9
	};

	unsigned int c_dfa_a_3[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbeeb, 0x0000, 0x0000, 0x0000, 0xbeea, 0xbeec, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xbeed, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_4[] = {	/*  */
	/*0xa0*/     -1, 0xbeef, 0x0000, 0x0000, 0xbef0, 0xbef1, 0x0000, 0xbef2, 0xbeee, 0xbef3, 0xbef4, 0xbef5, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbef6, 0xbef7, 0x0000, 0xbef8, 0xbef9, 0xbefa, 0xbefb, 0xbefc, 0x0000, 0x0000, 0xbefd, 0x0000, 0xbefe, 0x0000
	};

	unsigned int c_dfa_a_5[] = {	/*  */
	/*0xa0*/     -1, 0xbfa2, 0x0000, 0x0000, 0xbfa3, 0x0000, 0x0000, 0x0000, 0xbfa1, 0xbfa4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbfa5, 0xbfa6, 0x0000, 0x0000, 0xbfa7, 0x0000, 0xbfa8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_6[] = {	/*  */
	/*0xa0*/     -1, 0xbfaa, 0xbfab, 0x0000, 0xbfac, 0x0000, 0x0000, 0x0000, 0xbfa9, 0xbfad, 0x0000, 0xbfae, 0xbfaf, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbfb0, 0xbfb1, 0x0000, 0xbfb2, 0xbfb3, 0xbfb4, 0xbfb5, 0x0000, 0x0000, 0x0000, 0x0000, 0xbfb6, 0xbfb7, 0xbfb8
	};

	unsigned int c_dfa_a_7[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xbfba, 0x0000, 0x0000, 0x0000, 0xbfb9, 0xbfbb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbfbc, 0xbfbd, 0x0000, 0x0000, 0xbdbe, 0xbfbf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_8[] = {	/*  */
	/*0xa0*/     -1, 0xbfc1, 0x0000, 0x0000, 0xbfc2, 0x0000, 0x0000, 0x0000, 0xbfc0, 0xbfc3, 0xbfc4, 0xbfc5, 0x0000, 0xbfc6, 0x0000, 0x0000,
	/*0xb0*/ 0xbfc7, 0xbfc8, 0xbfc9, 0x0000, 0x0000, 0xbfca, 0x0000, 0xbfcb, 0x0000, 0x0000, 0xbfcc, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_9[] = {	/*  */
	/*0xa0*/     -1, 0xbfce, 0x0000, 0x0000, 0xbfcf, 0x0000, 0x0000, 0x0000, 0xbfcd, 0xbfd0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbfd1, 0xbfd2, 0x0000, 0x0000, 0xbfd3, 0xbfd4, 0xbfd5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_10[] = {	/*  */
	/*0xa0*/     -1, 0xbfd7, 0x0000, 0x0000, 0xbfd8, 0x0000, 0x0000, 0x0000, 0xbfd6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbfd9, 0x0000, 0x0000, 0x0000, 0xbfda, 0x0000, 0xbfdb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_11[] = {	/*  */
	/*0xa0*/     -1, 0xbfdd, 0x0000, 0x0000, 0xbfde, 0x0000, 0x0000, 0x0000, 0xbfdc, 0xbddf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbfe0, 0xbfe1, 0x0000, 0x0000, 0xbfe2, 0x0000, 0xbfe3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_12[] = {	/*  */
	/*0xa0*/     -1, 0xbfe5, 0x0000, 0x0000, 0xbfe6, 0x0000, 0x0000, 0x0000, 0xbfe4, 0xbfe7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbfe8, 0xbfe9, 0x0000, 0x0000, 0xbfea, 0x0000, 0xbfeb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_13[] = {	/*  */
	/*0xa0*/     -1, 0xbfed, 0x0000, 0x0000, 0xbfee, 0x0000, 0x0000, 0x0000, 0xbfec, 0xbfef, 0xbff0, 0xbff1, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbff2, 0xbff3, 0x0000, 0x0000, 0xbff4, 0x0000, 0xbff5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_14[] = {	/*  */
	/*0xa0*/     -1, 0xbff7, 0x0000, 0x0000, 0xbff8, 0x0000, 0x0000, 0x0000, 0xbff6, 0xbff9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xbffa, 0xbffb, 0x0000, 0x0000, 0x0000, 0xbffc, 0xbffd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_15[] = {	/*  */
	/*0xa0*/     -1, 0xc0a1, 0x0000, 0x0000, 0xc0a2, 0x0000, 0x0000, 0x0000, 0xbffe, 0xc0a3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc0a4, 0xc0a5, 0x0000, 0x0000, 0x0000, 0x0000, 0xc0a6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_16[] = {	/*  */
	/*0xa0*/     -1, 0xc0a8, 0x0000, 0x0000, 0xc0a9, 0x0000, 0x0000, 0x0000, 0xc0a7, 0xc0aa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc0ab, 0xc0ac, 0x0000, 0x0000, 0xc0ad, 0x0000, 0xc0ae, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_17[] = {	/*  */
	/*0xa0*/     -1, 0xc0b0, 0x0000, 0x0000, 0xc0b1, 0x0000, 0x0000, 0x0000, 0xc0af, 0xc0b2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc0b3, 0xc0b4, 0x0000, 0x0000, 0xc0b5, 0x0000, 0xc0b6, 0x0000, 0x0000, 0xc0b7, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_18[] = {	/*  */
	/*0xa0*/     -1, 0xc0b9, 0x0000, 0x0000, 0xc0ba, 0x0000, 0x0000, 0x0000, 0xc0b8, 0xc0bb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc0bc,
	/*0xb0*/ 0x0000, 0xc0bd, 0xc0be, 0x0000, 0x0000, 0xc0bf, 0x0000, 0xc0c0, 0xc0c1, 0x0000, 0xc0c2, 0xc0c3, 0xc0c4, 0xc0c5, 0xc0c6
	};

	unsigned int c_dfa_a_19[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc0c8, 0x0000, 0x0000, 0x0000, 0xc0c7, 0xc0c9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc0ca, 0x0000, 0x0000, 0x0000, 0xc0cb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_a_20[] = {	/*  */
	/*0xa0*/     -1, 0xc0cd, 0x0000, 0x0000, 0xc0ce, 0x0000, 0x0000, 0x0000, 0xc0cc, 0xc0cf, 0xc0d0, 0xc0d1, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0xc0d2, 0xc0d3, 0xc0d4, 0x0000, 0x0000, 0xc0d5, 0xc0d6, 0xc0d7, 0xc0d8, 0x0000, 0x0000, 0x0000, 0x0000, 0xc0d9, 0x0000
	};

	unsigned int c_dfa_ja_0[] = {	/*  */
	/*0xa0*/     -1, 0xc0db, 0x0000, 0x0000, 0xc0dc, 0x0000, 0xc0dd, 0xc0de, 0xc0da, 0xc0df, 0x0000, 0xc0e0, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc0e1, 0xc0e2, 0x0000, 0x0000, 0xc0e3, 0xc0e4, 0xc0e5, 0xc0e6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_1[] = {	/*  */
	/*0xa0*/     -1, 0xc0e8, 0x0000, 0x0000, 0xc0e9, 0x0000, 0x0000, 0x0000, 0xc0e7, 0xc0ea, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc0eb, 0xc0ec, 0x0000, 0x0000, 0xc0ed, 0xc0ee, 0xc0ef, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_2[] = {	/*  */
	/*0xa0*/     -1, 0xc0f1, 0x0000, 0x0000, 0xc0f2, 0x0000, 0xc0f3, 0x0000, 0xc0f0, 0xc0f4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc0f5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc0f6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_3[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc0f8, 0x0000, 0x0000, 0x0000, 0xc0f7, 0xc0f9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_4[] = {	/*  */
	/*0xa0*/     -1, 0xc0fb, 0x0000, 0x0000, 0xc0fc, 0x0000, 0x0000, 0x0000, 0xc0fa, 0xc0fd, 0x0000, 0xc0fe, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc1a1, 0xc1a2, 0x0000, 0x0000, 0xc1a3, 0x0000, 0xc1a4, 0xc1a5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_5[] = {	/*  */
	/*0xa0*/     -1, 0xc1a7, 0x0000, 0x0000, 0xc1a8, 0x0000, 0x0000, 0x0000, 0xc1a6, 0xc1a9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc1aa, 0xc1ab, 0x0000, 0x0000, 0xc1ac, 0x0000, 0xc1ad, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_6[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc1af, 0x0000, 0x0000, 0x0000, 0xc1ae, 0xc1b0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc1b1, 0xc1b2, 0x0000, 0x0000, 0x0000, 0xc1b3, 0xc1b4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_7[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc1b5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_8[] = {	/*  */
	/*0xa0*/     -1, 0xc1b7, 0x0000, 0x0000, 0xc1b8, 0x0000, 0x0000, 0x0000, 0xc1b6, 0xc1b9, 0x0000, 0xc1ba, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc1bb, 0xc1bc, 0x0000, 0x0000, 0xc1bd, 0x0000, 0xc1be, 0xc1bf, 0x0000, 0xc1c0, 0x0000, 0x0000, 0x0000, 0xc1c1
	};

	unsigned int c_dfa_ja_9[] = {	/*  */
	/*0xa0*/     -1, 0xc1c3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc1c2, 0xc1c4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xc1c5, 0x0000, 0x0000, 0xc1c6, 0x0000, 0xc1c7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_10[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc1c8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc1c9, 0xc1ca, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_11[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc1cc, 0x0000, 0x0000, 0x0000, 0xc1cb, 0xc1cd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc1ce, 0xc1cf, 0x0000, 0x0000, 0xc1d0, 0x0000, 0xc1d1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_12[] = {	/*  */
	/*0xa0*/     -1, 0xc1d3, 0x0000, 0x0000, 0xc1d4, 0x0000, 0x0000, 0x0000, 0xc1d2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc1d5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_13[] = {	/*  */
	/*0xa0*/     -1, 0xc1d7, 0x0000, 0x0000, 0xc1d8, 0x0000, 0x0000, 0x0000, 0xc1d6, 0xc1d9, 0xc1da, 0xc1db, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc1dc, 0xc1dd, 0x0000, 0x0000, 0xc1de, 0x0000, 0xc1df, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_14[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc1e0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc1e1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_15[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc1e2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_16[] = {	/*  */
	/*0xa0*/     -1, 0xc1e4, 0x0000, 0x0000, 0xc1e5, 0x0000, 0x0000, 0x0000, 0xc1e3, 0xc1e6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc1e7, 0xc1e8, 0x0000, 0x0000, 0xc1e9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_17[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc1eb, 0x0000, 0x0000, 0x0000, 0xc1ea, 0xc1ec, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc1ed, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_18[] = {	/*  */
	/*0xa0*/     -1, 0xc1ef, 0x0000, 0x0000, 0xc1f0, 0x0000, 0x0000, 0x0000, 0xc1ee, 0xc1f1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc1f2, 0xc1f3, 0x0000, 0x0000, 0xc1f4, 0x0000, 0xc1f5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ja_19[] = {	/*  */
	/*0xa0*/     -1, 0xc1f7, 0x0000, 0x0000, 0xc1f8, 0x0000, 0x0000, 0xc1f9, 0xc1f6, 0xc1fa, 0x0000, 0xc1fb, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc1fc, 0xc1fd, 0x0000, 0x0000, 0xc1fe, 0x0000, 0xc2a1, 0xc2a2, 0x0000, 0x0000, 0x0000, 0xc2a3, 0xc2a4, 0x0000
	};

	unsigned int c_dfa_jja_0[] = {	/* ¥ */
	/*0xa0*/     -1, 0xc2a6, 0x0000, 0x0000, 0xc2a7, 0x0000, 0xc2a8, 0x0000, 0xc2a5, 0xc2a9, 0x0000, 0x0000, 0xc2aa, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc2ab, 0xc2ac, 0x0000, 0x0000, 0xc2ad, 0xc2ae, 0xc2af, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_1[] = {	/* ° */
	/*0xa0*/     -1, 0xc2b1, 0x0000, 0x0000, 0xc2b2, 0x0000, 0x0000, 0x0000, 0xc2b0, 0xc2b3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc2b4, 0xc2b5, 0x0000, 0x0000, 0xc2b6, 0xc2b7, 0xc2b8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_2[] = {	/* ¹ */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc2ba, 0x0000, 0x0000, 0x0000, 0xc2b9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2bb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_3[] = {	/* ¼ */
	/*0xa0*/     -1, 0xc2bd, 0x0000, 0x0000, 0xc2be, 0x0000, 0x0000, 0x0000, 0xc2bc, 0xc2bf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc2c0, 0xc2c1, 0x0000, 0x0000, 0xc2c2, 0xc2c3, 0xc2c4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_4[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2c5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2c6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_5[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2c7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2c8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_6[] = {	/*  */
	/*0xa0*/     -1, 0xc2ca, 0x0000, 0x0000, 0xc2cb, 0x0000, 0x0000, 0x0000, 0xc2c9, 0xc2cc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc2cd, 0xc2ce, 0x0000, 0x0000, 0xc2cf, 0x0000, 0xc2d0, 0x0000, 0x0000, 0xc2d1, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_7[] = {	/*  */
	/*0xa0*/     -1, 0xc2d3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2d2, 0xc2d4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2d5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_8[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2d6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2d7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_9[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc2d9, 0x0000, 0x0000, 0x0000, 0xc2d8, 0xc2da, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc2db, 0xc2dc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_10[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2dd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_11[] = {	/*  */
	/*0xa0*/     -1, 0xc2df, 0x0000, 0x0000, 0xc2e0, 0x0000, 0x0000, 0x0000, 0xc2de, 0xc2e1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc2e2, 0xc2e3, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2e4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_12[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2e5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2e6, 0xc2e7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2e8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_14[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2e9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_15[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2ea, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc2eb, 0x0000, 0x0000, 0x0000, 0xc2ec, 0x0000, 0xc2ed, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_jja_16[] = {	/*  */
	/*0xa0*/     -1, 0xc2ef, 0x0000, 0x0000, 0xc2f0, 0x0000, 0x0000, 0x0000, 0xc2ee, 0xc2f1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc2f2, 0xc2f3, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2f4, 0xc2f5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc2f6
	};

	unsigned int c_dfa_cha_0[] = {	/*  */
	/*0xa0*/     -1, 0xc2f8, 0x0000, 0x0000, 0xc2f9, 0x0000, 0xc2fa, 0x0000, 0xc2f7, 0xc2fb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc2fc, 0xc2fd, 0x0000, 0x0000, 0xc2fe, 0xc3a1, 0xc3a2, 0xc3a3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_1[] = {	/* ä */
	/*0xa0*/     -1, 0xc3a5, 0x0000, 0x0000, 0xc3a6, 0x0000, 0x0000, 0x0000, 0xc3a4, 0xc3a7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc3a8, 0xc3a9, 0x0000, 0x0000, 0xc3aa, 0xc3ab, 0xc3ac, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_2[] = {	/* í */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc3ae, 0x0000, 0xc3af, 0x0000, 0xc3ad, 0xc3b0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc3b1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc3b2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_3[] = {	/* ó */
	/*0xa0*/     -1, 0xc3b4, 0x0000, 0x0000, 0xc3b5, 0x0000, 0x0000, 0x0000, 0xc3b3, 0xc3b6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc3b7, 0xc3b8, 0x0000, 0x0000, 0xc3b9, 0xc3ba, 0xc3bb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_4[] = {	/* ü */
	/*0xa0*/     -1, 0xc3bd, 0x0000, 0x0000, 0xc3be, 0x0000, 0x0000, 0x0000, 0xc3bc, 0xc3bf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc3c0, 0xc3c1, 0x0000, 0x0000, 0xc3c2, 0x0000, 0xc3c3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_5[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc3c5, 0x0000, 0x0000, 0x0000, 0xc3c4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc3c6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_6[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc3c8, 0x0000, 0x0000, 0x0000, 0xc3c7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc3c9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_7[] = {	/*  */
	/*0xa0*/     -1, 0xc3cb, 0x0000, 0x0000, 0xc3cc, 0x0000, 0x0000, 0x0000, 0xc3ca, 0xc3cd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc3ce, 0xc3cf, 0x0000, 0x0000, 0xc3d0, 0x0000, 0xc3d1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_8[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc3d3, 0x0000, 0x0000, 0x0000, 0xc3d2, 0xc3d4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc3d5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_9[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc3d7, 0x0000, 0x0000, 0x0000, 0xc3d6, 0xc3d8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc3d9, 0xc3da, 0x0000, 0x0000, 0xc3db, 0x0000, 0xc3dc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_10[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc3dd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc3de, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_11[] = {	/*  */
	/*0xa0*/     -1, 0xc3e0, 0x0000, 0x0000, 0xc3e1, 0x0000, 0x0000, 0x0000, 0xc3df, 0xc3e2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc3e3, 0xc3e4, 0x0000, 0x0000, 0xc3e5, 0x0000, 0xc3e6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_12[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc3e7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc3e8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc3ea, 0x0000, 0x0000, 0x0000, 0xc3e9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_14[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc3ec, 0x0000, 0x0000, 0x0000, 0xc3eb, 0xc3ed, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc2ee, 0xc3ef, 0x0000, 0x0000, 0xc3f0, 0x0000, 0xc3f1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_15[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc3f3, 0x0000, 0x0000, 0x0000, 0xc3f2, 0xc3f4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc3f5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc3f6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_16[] = {	/*  */
	/*0xa0*/     -1, 0xc3f8, 0x0000, 0x0000, 0xc3f9, 0x0000, 0x0000, 0x0000, 0xc3f7, 0xc3fa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc3fb, 0xc3fc, 0x0000, 0x0000, 0xc3fd, 0x0000, 0xc3fe, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_cha_17[] = {	/* ġ */
	/*0xa0*/     -1, 0xc4a2, 0x0000, 0x0000, 0xc4a3, 0x0000, 0x0000, 0xc4a4, 0xc4a1, 0xc4a5, 0xc4a6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc4a7, 0xc4a8, 0x0000, 0x0000, 0xc4a9, 0x0000, 0xc4aa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_0[] = {	/* ī */
	/*0xa0*/     -1, 0xc4ac, 0x0000, 0x0000, 0xc4ad, 0x0000, 0x0000, 0x0000, 0xc4ab, 0xc4ae, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc4af, 0xc4b0, 0x0000, 0x0000, 0xc4b1, 0x0000, 0xc4b2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_1[] = {	/* ĳ */
	/*0xa0*/     -1, 0xc4b4, 0x0000, 0x0000, 0xc4b5, 0x0000, 0x0000, 0x0000, 0xc4b3, 0xc4b6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc4b7, 0xc4b8, 0x0000, 0x0000, 0xc4b9, 0xc4ba, 0xc4bb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_2[] = {	/* ļ */
	/*0xa0*/     -1, 0xc4bd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc4bc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc4be, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_3[] = {	/* Ŀ */
	/*0xa0*/     -1, 0xc4c0, 0x0000, 0x0000, 0xc4c1, 0x0000, 0x0000, 0xc4c2, 0xc4bf, 0xc4c3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc4c4, 0xc4c5, 0x0000, 0x0000, 0xc4c6, 0xc4c7, 0xc4c8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_4[] = {	/*  */
	/*0xa0*/     -1, 0xc4ca, 0x0000, 0x0000, 0xc4cb, 0x0000, 0x0000, 0x0000, 0xc4c9, 0xc4cc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc4cd, 0xc4ce, 0x0000, 0x0000, 0xc4cf, 0x0000, 0xc4d0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_5[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc4d2, 0x0000, 0x0000, 0x0000, 0xc4d1, 0xc4d3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc4d4, 0xc4d5, 0x0000, 0x0000, 0xc4d6, 0xc4d7, 0xc4d8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_6[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc4d9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_7[] = {	/*  */
	/*0xa0*/     -1, 0xc4db, 0x0000, 0x0000, 0xc4dc, 0x0000, 0x0000, 0x0000, 0xc4da, 0xc4dd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc4de, 0xc4df, 0x0000, 0x0000, 0xc4e0, 0x0000, 0xc4e1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_8[] = {	/*  */
	/*0xa0*/     -1, 0xc4e3, 0x0000, 0x0000, 0xc4e4, 0x0000, 0x0000, 0x0000, 0xc4e2, 0xc4e5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc4e6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc4e7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_9[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc4e8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc4e9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_10[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc4ea, 0xc4eb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_11[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc4ec, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_12[] = {	/*  */
	/*0xa0*/     -1, 0xc4ee, 0x0000, 0x0000, 0xc4ef, 0x0000, 0x0000, 0x0000, 0xc4ed, 0xc4f0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc4f1, 0xc4f2, 0x0000, 0x0000, 0xc4f3, 0x0000, 0xc4f4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc4f6, 0x0000, 0x0000, 0x0000, 0xc4f5, 0xc4f7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc4f8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_14[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc4f9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc4fa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_15[] = {	/*  */
	/*0xa0*/     -1, 0xc4fc, 0x0000, 0x0000, 0xc4fd, 0x0000, 0x0000, 0x0000, 0xc4fb, 0xc4fe, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc5a1, 0xc5a2, 0x0000, 0x0000, 0xc5a3, 0x0000, 0xc5a4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_16[] = {	/* ť */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc5a6, 0x0000, 0x0000, 0x0000, 0xc5a5, 0xc5a7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc5a8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_17[] = {	/* ũ */
	/*0xa0*/     -1, 0xc5aa, 0x0000, 0x0000, 0xc5ab, 0x0000, 0x0000, 0x0000, 0xc5a9, 0xc5ac, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc5ad, 0xc5ae, 0x0000, 0x0000, 0x0000, 0x0000, 0xc5af, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ka_18[] = {	/* Ű */
	/*0xa0*/     -1, 0xc5b1, 0x0000, 0x0000, 0xc5b2, 0x0000, 0x0000, 0x0000, 0xc5b0, 0xc5b3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc5b4, 0xc5b5, 0x0000, 0x0000, 0xc5b6, 0x0000, 0xc5b7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_0[] = {	/* Ÿ */
	/*0xa0*/     -1, 0xc5b9, 0x0000, 0x0000, 0xc5ba, 0x0000, 0x0000, 0x0000, 0xc5b8, 0xc5bb, 0xc5bc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc5bd, 0xc5be, 0x0000, 0x0000, 0xc5bf, 0xc5c0, 0xc5c1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_1[] = {	/*  */
	/*0xa0*/     -1, 0xc5c3, 0x0000, 0x0000, 0xc5c4, 0x0000, 0x0000, 0x0000, 0xc5c2, 0xc5c5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc5c6, 0xc5c7, 0x0000, 0x0000, 0xc5c8, 0xc5c9, 0xc5ca, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_2[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc5cb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc5cc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_3[] = {	/*  */
	/*0xa0*/     -1, 0xc5ce, 0x0000, 0x0000, 0xc5cf, 0x0000, 0x0000, 0x0000, 0xc5cd, 0xc5d0, 0x0000, 0xc5d1, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc5d2, 0xc5d3, 0x0000, 0x0000, 0xc5d4, 0xc5d5, 0xc5d6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_4[] = {	/*  */
	/*0xa0*/     -1, 0xc5d8, 0x0000, 0x0000, 0xc5d9, 0x0000, 0x0000, 0x0000, 0xc5d7, 0xc5da, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc5db, 0xc5dc, 0x0000, 0x0000, 0xc5dd, 0x0000, 0xc5de, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_5[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc5e0, 0x0000, 0x0000, 0x0000, 0xc5df, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc5e1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_6[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc5e3, 0x0000, 0x0000, 0x0000, 0xc5e2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_7[] = {	/*  */
	/*0xa0*/     -1, 0xc5e5, 0x0000, 0x0000, 0xc5e6, 0x0000, 0x0000, 0x0000, 0xc5e4, 0xc5e7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc5e8, 0xc5e9, 0x0000, 0x0000, 0xc5ea, 0x0000, 0xc5eb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc5ec, 0x0000
	};

	unsigned int c_dfa_ta_8[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc5ee, 0x0000, 0x0000, 0x0000, 0xc5ed, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};
	
	unsigned int c_dfa_ta_9[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc5ef, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_10[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc5f1, 0x0000, 0x0000, 0x0000, 0xc5f0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc5f2, 0x0000, 0xc5f3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_11[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc5f4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_12[] = {	/*  */
	/*0xa0*/     -1, 0xc5f6, 0x0000, 0x0000, 0xc5f7, 0x0000, 0x0000, 0x0000, 0xc5f5, 0xc5f8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc5f9, 0xc5fa, 0x0000, 0x0000, 0xc5fb, 0x0000, 0xc5fc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc5fd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc5fe, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_14[] = {	/* ơ */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc5a1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_15[] = {	/* Ƣ */
	/*0xa0*/     -1, 0xc6a3, 0x0000, 0x0000, 0xc6a4, 0x0000, 0x0000, 0x0000, 0xc6a2, 0xc6a5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc6a6, 0xc6a7, 0x0000, 0x0000, 0x0000, 0x0000, 0xc6a8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_16[] = {	/* Ʃ */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc6aa, 0x0000, 0x0000, 0x0000, 0xc6a9, 0xc6ab, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc6ac, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc6ad, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_17[] = {	/* Ʈ */
	/*0xa0*/     -1, 0xc6af, 0x0000, 0x0000, 0xc6b0, 0x0000, 0x0000, 0xc6b1, 0xc6ae, 0xc6b2, 0x0000, 0xc6b3, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc6b4, 0xc6b5, 0x0000, 0x0000, 0xc6b6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_18[] = {	/* Ʒ */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc6b8, 0x0000, 0x0000, 0x0000, 0xc6b7, 0xc6b9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc6ba, 0xc6bb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ta_19[] = {	/* Ƽ */
	/*0xa0*/     -1, 0xc6bd, 0x0000, 0x0000, 0xc6be, 0x0000, 0x0000, 0x0000, 0xc6bc, 0xc6bf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc6c0, 0xc6c1, 0x0000, 0x0000, 0xc6c2, 0x0000, 0xc6c3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_0[] = {	/*  */
	/*0xa0*/     -1, 0xc6c5, 0xc6c6, 0x0000, 0xc6c7, 0x0000, 0x0000, 0x0000, 0xc6c4, 0xc6c8, 0x0000, 0xc6c9, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc6ca, 0xc6cb, 0x0000, 0x0000, 0xc6cc, 0xc6cd, 0xc6ce, 0x0000, 0x0000, 0x0000, 0x0000, 0xc6cf, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_1[] = {	/*  */
	/*0xa0*/     -1, 0xc6d1, 0x0000, 0x0000, 0xc6d2, 0x0000, 0x0000, 0x0000, 0xc6d0, 0xc6d3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc6d4, 0xc6d5, 0x0000, 0x0000, 0xc6d6, 0xc6d7, 0xc6d8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_2[] = {	/*  */
	/*0xa0*/     -1, 0xc6da, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc6d9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_3[] = {	/*  */
	/*0xa0*/     -1, 0xc6dc, 0x0000, 0x0000, 0xc6dd, 0x0000, 0x0000, 0x0000, 0xc6db, 0xc6de, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc6df, 0xc6e0, 0x0000, 0x0000, 0xc6e1, 0xc6e2, 0xc6e3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_4[] = {	/*  */
	/*0xa0*/     -1, 0xc6e5, 0x0000, 0x0000, 0xc6e6, 0x0000, 0x0000, 0x0000, 0xc6e4, 0xc6e7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc6e8, 0xc6e9, 0x0000, 0x0000, 0xc6ea, 0x0000, 0xc6eb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_5[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc6ed, 0x0000, 0x0000, 0x0000, 0xc6ec, 0xc6ee, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc6ef, 0xc6f0, 0x0000, 0x0000, 0x0000, 0xc6f1, 0xc6f2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_6[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc6f3, 0xc6f4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xc6f5, 0x0000, 0x0000, 0xc6f6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_7[] = {	/*  */
	/*0xa0*/     -1, 0xc6f8, 0x0000, 0x0000, 0xc6f9, 0x0000, 0x0000, 0x0000, 0xc6f7, 0xc6fa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xc6fc, 0x0000, 0x0000, 0xc6fd, 0x0000, 0xc6fe, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_8[] = {	/* ǡ */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc7a1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc7a2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_9[] = {	/* ǣ */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc7a4, 0x0000, 0x0000, 0x0000, 0xc7a3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_10[] = {	/* ǥ */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc7a6, 0x0000, 0x0000, 0x0000, 0xc7a5, 0xc7a7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xc7a8, 0x0000, 0x0000, 0xc7a9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_11[] = {	/* Ǫ */
	/*0xa0*/     -1, 0xc7ab, 0x0000, 0x0000, 0xc7ac, 0x0000, 0x0000, 0xc7ad, 0xc7aa, 0xc7ae, 0x0000, 0xc7af, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc7b0, 0xc7b1, 0x0000, 0x0000, 0xc7b2, 0x0000, 0xc7b3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_12[] = {	/* Ǵ */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc7b4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc7b5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_13[] = {	/* Ƕ */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc7b7, 0x0000, 0x0000, 0x0000, 0xc7b6, 0xc7b8, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc7b9, 0x0000, 0x0000, 0x0000, 0xc7ba, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_14[] = {	/* ǻ */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc7bc, 0x0000, 0x0000, 0x0000, 0xc7bb, 0xc7bd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc7be, 0x0000, 0x0000, 0x0000, 0xc7bf, 0x0000, 0xc7c0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_15[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc7c2, 0x0000, 0x0000, 0x0000, 0xc7c1, 0xc7c3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc7c4, 0xc7c5, 0x0000, 0x0000, 0xc7c6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_pa_16[] = {	/*  */
	/*0xa0*/     -1, 0xc7c8, 0x0000, 0x0000, 0xc7c9, 0x0000, 0x0000, 0x0000, 0xc7c7, 0xc7ca, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc7cb, 0xc7cc, 0x0000, 0x0000, 0xc7cd, 0x0000, 0xc7ce, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_0[] = {	/*  */
	/*0xa0*/     -1, 0xc7d0, 0x0000, 0x0000, 0xc7d1, 0x0000, 0x0000, 0x0000, 0xc7cf, 0xc7d2, 0x0000, 0x0000, 0x0000, 0x0000, 0xc7d3, 0x0000,
	/*0xb0*/ 0x0000, 0xc7d4, 0xc7d5, 0x0000, 0x0000, 0xc7d6, 0x0000, 0xc7d7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_1[] = {	/*  */
	/*0xa0*/     -1, 0xc7d9, 0x0000, 0x0000, 0xc7da, 0x0000, 0x0000, 0x0000, 0xc7d8, 0xc7db, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc7dc, 0xc7dd, 0x0000, 0x0000, 0xc7de, 0xc7df, 0xc7e0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_2[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc7e1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc7e2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_3[] = {	/*  */
	/*0xa0*/     -1, 0xc7e4, 0x0000, 0x0000, 0xc7e5, 0x0000, 0x0000, 0x0000, 0xc7e3, 0xc7e6, 0x0000, 0xc7e7, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc7e8, 0xc7e9, 0x0000, 0x0000, 0xc7ea, 0x0000, 0xc7eb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_4[] = {	/*  */
	/*0xa0*/     -1, 0xc7ed, 0x0000, 0x0000, 0xc7ee, 0x0000, 0x0000, 0x0000, 0xc7ec, 0xc7ef, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc7f0, 0xc7f1, 0x0000, 0x0000, 0xc7f2, 0x0000, 0xc7f3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_5[] = {	/*  */
	/*0xa0*/     -1, 0xc7f5, 0x0000, 0x0000, 0xc7f6, 0x0000, 0x0000, 0x0000, 0xc7f4, 0xc7f7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc7f8, 0xc7f9, 0x0000, 0x0000, 0xc7fa, 0xc7fb, 0xc7fc, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_6[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc7fe, 0x0000, 0x0000, 0x0000, 0xc7fd, 0xc8a1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xc8a2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_7[] = {	/* ȣ */
	/*0xa0*/     -1, 0xc8a4, 0x0000, 0x0000, 0xc8a5, 0x0000, 0x0000, 0x0000, 0xc8a3, 0xc8a6, 0x0000, 0x0000, 0x0000, 0x0000, 0xc8a7, 0x0000,
	/*0xb0*/ 0x0000, 0xc8a8, 0xc8a9, 0x0000, 0x0000, 0xc8aa, 0x0000, 0xc8ab, 0x0000, 0x0000, 0x0000, 0x0000, 0xc8ac, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_8[] = {	/* ȭ */
	/*0xa0*/     -1, 0xc8ae, 0x0000, 0x0000, 0xc8af, 0x0000, 0x0000, 0x0000, 0xc8ad, 0xc8b0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc8b1, 0x0000, 0xc8b2, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_9[] = {	/* ȳ */
	/*0xa0*/     -1, 0xc8b4, 0x0000, 0x0000, 0xc8b5, 0x0000, 0x0000, 0x0000, 0xc8b3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc8b6, 0x0000, 0xc8b7, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_10[] = {	/* ȸ */
	/*0xa0*/     -1, 0xc8b9, 0x0000, 0x0000, 0xc8ba, 0x0000, 0x0000, 0x0000, 0xc8b8, 0xc8bb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xc8bc, 0x0000, 0x0000, 0xc8bd, 0x0000, 0xc8be, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_11[] = {	/* ȿ */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc8c0, 0x0000, 0x0000, 0x0000, 0xc8bf, 0xc8c1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0xc8c2, 0x0000, 0x0000, 0xc8c3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_12[] = {	/*  */
	/*0xa0*/     -1, 0xc8c5, 0x0000, 0x0000, 0xc8c6, 0x0000, 0x0000, 0x0000, 0xc8c4, 0xc8c7, 0x0000, 0x0000, 0x0000, 0x0000, 0xc8c8, 0x0000,
	/*0xb0*/ 0x0000, 0xc8c9, 0x0000, 0x0000, 0x0000, 0xc8ca, 0x0000, 0xc8cb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_13[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc8cd, 0x0000, 0x0000, 0x0000, 0xc8cc, 0xc8ce, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc8cf, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc8d0, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_14[] = {	/*  */
	/*0xa0*/     -1, 0xc8d2, 0x0000, 0x0000, 0xc8d3, 0x0000, 0x0000, 0x0000, 0xc8d1, 0xc8d4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0xc8d5, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_15[] = {	/*  */
	/*0xa0*/     -1, 0xc8d7, 0x0000, 0x0000, 0xc8d8, 0x0000, 0x0000, 0x0000, 0xc8d6, 0xc8d9, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc8da, 0xc8db, 0x0000, 0x0000, 0xc8dc, 0x0000, 0xc8dd, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_16[] = {	/*  */
	/*0xa0*/     -1, 0xc8df, 0x0000, 0x0000, 0xc8e0, 0x0000, 0x0000, 0x0000, 0xc8de, 0xc8e1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc8e2, 0x0000, 0x0000, 0x0000, 0xc8e3, 0x0000, 0xc8e4, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_17[] = {	/*  */
	/*0xa0*/     -1, 0xc8e6, 0x0000, 0x0000, 0xc8e7, 0x0000, 0xc8e8, 0xc8e9, 0xc8e5, 0xc8ea, 0xc8eb, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc8ec, 0xc8ed, 0x0000, 0x0000, 0xc8ee, 0x0000, 0xc8ef, 0x0000, 0x0000, 0x0000, 0x0000, 0xc8f0, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_18[] = {	/*  */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0xc8f2, 0x0000, 0x0000, 0x0000, 0xc8f1, 0xc8f3, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc8f4, 0xc8f5, 0x0000, 0x0000, 0x0000, 0x0000, 0xc8f6, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};

	unsigned int c_dfa_ha_19[] = {	/*  */
	/*0xa0*/     -1, 0xc8f8, 0x0000, 0x0000, 0xc8f9, 0x0000, 0x0000, 0x0000, 0xc8f7, 0xc8fa, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*0xb0*/ 0x0000, 0xc8fb, 0xc8fc, 0x0000, 0x0000, 0xc8fd, 0x0000, 0xc8fe, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};
#if 0	/*  Դϴ. */
	unsigned int c_dfa_[] = {	/*  */
	/*	 0       1       2       3       4       5       6       7       8       9       a       b       c       d       e       f    */
	/*                                                                                      */
	/*0xa0*/     -1, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
	/*                                                                                                      */
	/*0xb0*/ 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000
	};
#endif

	MALLOC(hg_dfa, unsigned int *, 512);	/* 16  */
	hg_dfa[0] = c_dfa;			/* ʼ */
	hg_dfa[1] = c_dfa1_1;
	hg_dfa[2] = c_dfa1_2;
	hg_dfa[3] = c_dfa1_3;
	hg_dfa[4] = c_dfa1_4;
	hg_dfa[5] = c_dfa1_5;
	hg_dfa[6] = c_dfa1_6;
	hg_dfa[7] = c_dfa1_7;
	hg_dfa[8] = c_dfa1_8;
	hg_dfa[9] = c_dfa1_9;
	hg_dfa[10] = c_dfa1_10;
	hg_dfa[11] = c_dfa1_11;
	hg_dfa[12] = c_dfa1_12;
	hg_dfa[13] = c_dfa1_13;
	hg_dfa[14] = c_dfa1_14;
	hg_dfa[15] = c_dfa1_15;
	hg_dfa[16] = c_dfa1_16;
	hg_dfa[17] = c_dfa1_17;
	hg_dfa[18] = c_dfa_ga_0;
	hg_dfa[19] = c_dfa_ga_1;
	hg_dfa[20] = c_dfa_ga_2;
	hg_dfa[21] = c_dfa_ga_3;
	hg_dfa[22] = c_dfa_ga_4;
	hg_dfa[23] = c_dfa_ga_5;
	hg_dfa[24] = c_dfa_ga_6;
	hg_dfa[25] = c_dfa_ga_7;
	hg_dfa[26] = c_dfa_ga_8;
	hg_dfa[27] = c_dfa_ga_9;
	hg_dfa[28] = c_dfa_ga_10;
	hg_dfa[29] = c_dfa_ga_11;
	hg_dfa[30] = c_dfa_ga_12;
	hg_dfa[31] = c_dfa_ga_13;
	hg_dfa[32] = c_dfa_ga_14;
	hg_dfa[33] = c_dfa_ga_15;
	hg_dfa[34] = c_dfa_ga_16;
	hg_dfa[35] = c_dfa_ga_17;
	hg_dfa[36] = c_dfa_ga_18;
	hg_dfa[37] = c_dfa_ga_19;
	hg_dfa[38] = c_dfa_gga_0;
	hg_dfa[39] = c_dfa_gga_1;
	hg_dfa[40] = c_dfa_gga_2;
	hg_dfa[41] = c_dfa_gga_3;
	hg_dfa[42] = c_dfa_gga_4;
	hg_dfa[43] = c_dfa_gga_5;
	hg_dfa[44] = c_dfa_gga_6;
	hg_dfa[45] = c_dfa_gga_7;
	hg_dfa[46] = c_dfa_gga_8;
	hg_dfa[47] = c_dfa_gga_9;
	hg_dfa[48] = c_dfa_gga_10;
	hg_dfa[49] = c_dfa_gga_11;
	hg_dfa[50] = c_dfa_gga_12;
	hg_dfa[51] = c_dfa_gga_13;
	hg_dfa[52] = c_dfa_gga_14;
	hg_dfa[53] = c_dfa_gga_15;
	hg_dfa[54] = c_dfa_na_0;
	hg_dfa[55] = c_dfa_na_1;
	hg_dfa[56] = c_dfa_na_2;
	hg_dfa[57] = c_dfa_na_3;
	hg_dfa[58] = c_dfa_na_4;
	hg_dfa[59] = c_dfa_na_5;
	hg_dfa[60] = c_dfa_na_6;
	hg_dfa[61] = c_dfa_na_7;
	hg_dfa[62] = c_dfa_na_8;
	hg_dfa[63] = c_dfa_na_9;
	hg_dfa[64] = c_dfa_na_10;
	hg_dfa[65] = c_dfa_na_11;
	hg_dfa[66] = c_dfa_na_12;
	hg_dfa[67] = c_dfa_na_13;
	hg_dfa[68] = c_dfa_na_14;
	hg_dfa[69] = c_dfa_na_15;
	hg_dfa[70] = c_dfa_na_16;
	hg_dfa[71] = c_dfa_na_17;
	hg_dfa[72] = c_dfa_da_0;
	hg_dfa[73] = c_dfa_da_1;
	hg_dfa[74] = c_dfa_da_2;
	hg_dfa[75] = c_dfa_da_3;
	hg_dfa[76] = c_dfa_da_4;
	hg_dfa[77] = c_dfa_da_5;
	hg_dfa[78] = c_dfa_da_6;
	hg_dfa[79] = c_dfa_da_7;
	hg_dfa[80] = c_dfa_da_8;
	hg_dfa[81] = c_dfa_da_9;
	hg_dfa[82] = c_dfa_da_10;
	hg_dfa[83] = c_dfa_da_11;
	hg_dfa[84] = c_dfa_da_12;
	hg_dfa[85] = c_dfa_da_13;
	hg_dfa[86] = c_dfa_da_14;
	hg_dfa[87] = c_dfa_da_15;
	hg_dfa[88] = c_dfa_da_16;
	hg_dfa[89] = c_dfa_da_17;
	hg_dfa[90] = c_dfa_dda_0;
	hg_dfa[91] = c_dfa_dda_1;
	hg_dfa[92] = c_dfa_dda_2;
	hg_dfa[93] = c_dfa_dda_3;
	hg_dfa[94] = c_dfa_dda_4;
	hg_dfa[95] = c_dfa_dda_5;
	hg_dfa[96] = c_dfa_dda_6;
	hg_dfa[97] = c_dfa_dda_7;
	hg_dfa[98] = c_dfa_dda_8;
	hg_dfa[99] = c_dfa_dda_9;
	hg_dfa[100] = c_dfa_dda_10;
	hg_dfa[101] = c_dfa_dda_11;
	hg_dfa[102] = c_dfa_dda_12;
	hg_dfa[103] = c_dfa_dda_13;
	hg_dfa[104] = c_dfa_dda_14;
	hg_dfa[105] = c_dfa_ra_0;
	hg_dfa[106] = c_dfa_ra_1;
	hg_dfa[107] = c_dfa_ra_2;
	hg_dfa[108] = c_dfa_ra_3;
	hg_dfa[109] = c_dfa_ra_4;
	hg_dfa[110] = c_dfa_ra_5;
	hg_dfa[111] = c_dfa_ra_6;
	hg_dfa[112] = c_dfa_ra_7;
	hg_dfa[113] = c_dfa_ra_8;
	hg_dfa[114] = c_dfa_ra_9;
	hg_dfa[115] = c_dfa_ra_10;
	hg_dfa[116] = c_dfa_ra_11;
	hg_dfa[117] = c_dfa_ra_12;
	hg_dfa[118] = c_dfa_ra_13;
	hg_dfa[119] = c_dfa_ra_14;
	hg_dfa[120] = c_dfa_ra_15;
	hg_dfa[121] = c_dfa_ra_16;
	hg_dfa[122] = c_dfa_ra_17;
	hg_dfa[123] = c_dfa_ra_18;
	hg_dfa[124] = c_dfa_ma_0;
	hg_dfa[125] = c_dfa_ma_1;
	hg_dfa[126] = c_dfa_ma_2;
	hg_dfa[127] = c_dfa_ma_3;
	hg_dfa[128] = c_dfa_ma_4;
	hg_dfa[129] = c_dfa_ma_5;
	hg_dfa[130] = c_dfa_ma_6;
	hg_dfa[131] = c_dfa_ma_7;
	hg_dfa[132] = c_dfa_ma_8;
	hg_dfa[133] = c_dfa_ma_9;
	hg_dfa[134] = c_dfa_ma_10;
	hg_dfa[135] = c_dfa_ma_11;
	hg_dfa[136] = c_dfa_ma_12;
	hg_dfa[137] = c_dfa_ma_13;
	hg_dfa[138] = c_dfa_ma_14;
	hg_dfa[139] = c_dfa_ma_15;
	hg_dfa[140] = c_dfa_ma_16;
	hg_dfa[141] = c_dfa_ma_17;
	hg_dfa[142] = c_dfa_ba_0;
	hg_dfa[143] = c_dfa_ba_1;
	hg_dfa[144] = c_dfa_ba_2;
	hg_dfa[145] = c_dfa_ba_3;
	hg_dfa[146] = c_dfa_ba_4;
	hg_dfa[147] = c_dfa_ba_5;
	hg_dfa[148] = c_dfa_ba_6;
	hg_dfa[149] = c_dfa_ba_7;
	hg_dfa[150] = c_dfa_ba_8;
	hg_dfa[151] = c_dfa_ba_9;
	hg_dfa[152] = c_dfa_ba_10;
	hg_dfa[153] = c_dfa_ba_11;
	hg_dfa[154] = c_dfa_ba_12;
	hg_dfa[155] = c_dfa_ba_13;
	hg_dfa[156] = c_dfa_ba_14;
	hg_dfa[157] = c_dfa_ba_15;
	hg_dfa[158] = c_dfa_ba_16;
	hg_dfa[159] = c_dfa_ba_17;
	hg_dfa[160] = c_dfa_ba_18;
	hg_dfa[161] = c_dfa_bba_0;
	hg_dfa[162] = c_dfa_bba_1;
	hg_dfa[163] = c_dfa_bba_2;
	hg_dfa[164] = c_dfa_bba_3;
	hg_dfa[165] = c_dfa_bba_4;
	hg_dfa[166] = c_dfa_bba_5;
	hg_dfa[167] = c_dfa_bba_6;
	hg_dfa[168] = c_dfa_bba_7;
	hg_dfa[169] = c_dfa_bba_8;
	hg_dfa[170] = c_dfa_bba_9;
	hg_dfa[171] = c_dfa_bba_10;
	hg_dfa[172] = c_dfa_bba_11;
	hg_dfa[173] = c_dfa_bba_12;
	hg_dfa[174] = c_dfa1_18;	/* !   Ǽ " + ߼" 
					   մϴ. */
	hg_dfa[175] = c_dfa_sa_0;
	hg_dfa[176] = c_dfa_sa_1;
	hg_dfa[177] = c_dfa_sa_2;
	hg_dfa[178] = c_dfa_sa_3;
	hg_dfa[179] = c_dfa_sa_4;
	hg_dfa[180] = c_dfa_sa_5;
	hg_dfa[181] = c_dfa_sa_6;
	hg_dfa[182] = c_dfa_sa_7;
	hg_dfa[183] = c_dfa_sa_8;
	hg_dfa[184] = c_dfa_sa_9;
	hg_dfa[185] = c_dfa_sa_10;
	hg_dfa[186] = c_dfa_sa_11;
	hg_dfa[187] = c_dfa_sa_12;
	hg_dfa[188] = c_dfa_sa_13;
	hg_dfa[189] = c_dfa_sa_14;
	hg_dfa[190] = c_dfa_sa_15;
	hg_dfa[191] = c_dfa_sa_16;
	hg_dfa[192] = c_dfa_sa_17;
	hg_dfa[193] = c_dfa_sa_18;
	hg_dfa[194] = c_dfa_sa_19;

	hg_dfa[195] = c_dfa_ssa_0;
	hg_dfa[196] = c_dfa_ssa_1;
	hg_dfa[197] = c_dfa_ssa_2;
	hg_dfa[198] = c_dfa_ssa_3;
	hg_dfa[199] = c_dfa_ssa_4;
	hg_dfa[200] = c_dfa_ssa_5;
	hg_dfa[201] = c_dfa_ssa_6;
	hg_dfa[202] = c_dfa_ssa_7;
	hg_dfa[203] = c_dfa_ssa_8;
	hg_dfa[204] = c_dfa_ssa_9;
	hg_dfa[205] = c_dfa_ssa_10;
	hg_dfa[206] = c_dfa_ssa_11;
	hg_dfa[207] = c_dfa_ssa_12;
	hg_dfa[208] = c_dfa_ssa_13;
	hg_dfa[209] = c_dfa_ssa_14;
	hg_dfa[210] = c_dfa_ssa_15;
	hg_dfa[211] = c_dfa_ssa_16;
	hg_dfa[212] = c_dfa_ssa_17;
	hg_dfa[213] = c_dfa_ssa_18;
	hg_dfa[214] = c_dfa_a_0;
	hg_dfa[215] = c_dfa_a_1;
	hg_dfa[216] = c_dfa_a_2;
	hg_dfa[217] = c_dfa_a_3;
	hg_dfa[218] = c_dfa_a_4;
	hg_dfa[219] = c_dfa_a_5;
	hg_dfa[220] = c_dfa_a_6;
	hg_dfa[221] = c_dfa_a_7;
	hg_dfa[222] = c_dfa_a_8;
	hg_dfa[223] = c_dfa_a_9;
	hg_dfa[224] = c_dfa_a_10;
	hg_dfa[225] = c_dfa_a_11;
	hg_dfa[226] = c_dfa_a_12;
	hg_dfa[227] = c_dfa_a_13;
	hg_dfa[228] = c_dfa_a_14;
	hg_dfa[229] = c_dfa_a_15;
	hg_dfa[230] = c_dfa_a_16;
	hg_dfa[231] = c_dfa_a_17;
	hg_dfa[232] = c_dfa_a_18;
	hg_dfa[233] = c_dfa_a_19;
	hg_dfa[234] = c_dfa_a_20;
	hg_dfa[235] = c_dfa_ja_0;
	hg_dfa[236] = c_dfa_ja_1;
	hg_dfa[237] = c_dfa_ja_2;
	hg_dfa[238] = c_dfa_ja_3;
	hg_dfa[239] = c_dfa_ja_4;
	hg_dfa[240] = c_dfa_ja_5;
	hg_dfa[241] = c_dfa_ja_6;
	hg_dfa[242] = c_dfa_ja_7;
	hg_dfa[243] = c_dfa_ja_8;
	hg_dfa[244] = c_dfa_ja_9;
	hg_dfa[245] = c_dfa_ja_10;
	hg_dfa[246] = c_dfa_ja_11;
	hg_dfa[247] = c_dfa_ja_12;
	hg_dfa[248] = c_dfa_ja_13;
	hg_dfa[249] = c_dfa_ja_14;
	hg_dfa[250] = c_dfa_ja_15;
	hg_dfa[251] = c_dfa_ja_16;
	hg_dfa[252] = c_dfa_ja_17;
	hg_dfa[253] = c_dfa_ja_18;
	hg_dfa[254] = c_dfa_ja_19;
	hg_dfa[255] = c_dfa1_19;		/* ! " + ߼"  ⿡ ֽϴ. ˼մϴ. */
	hg_dfa[256] = c_dfa_jja_0;
	hg_dfa[257] = c_dfa_jja_1;
	hg_dfa[258] = c_dfa_jja_2;
	hg_dfa[259] = c_dfa_jja_3;
	hg_dfa[260] = c_dfa_jja_4;
	hg_dfa[261] = c_dfa_jja_5;
	hg_dfa[262] = c_dfa_jja_6;
	hg_dfa[263] = c_dfa_jja_7;
	hg_dfa[264] = c_dfa_jja_8;
	hg_dfa[265] = c_dfa_jja_9;
	hg_dfa[266] = c_dfa_jja_10;
	hg_dfa[267] = c_dfa_jja_11;
	hg_dfa[268] = c_dfa_jja_12;
	hg_dfa[269] = c_dfa_jja_13;
	hg_dfa[270] = c_dfa_jja_14;
	hg_dfa[271] = c_dfa_jja_15;
	hg_dfa[272] = c_dfa_jja_16;
	hg_dfa[273] = c_dfa_cha_0;
	hg_dfa[274] = c_dfa_cha_1;
	hg_dfa[275] = c_dfa_cha_2;
	hg_dfa[276] = c_dfa_cha_3;
	hg_dfa[277] = c_dfa_cha_4;
	hg_dfa[278] = c_dfa_cha_5;
	hg_dfa[279] = c_dfa_cha_6;
	hg_dfa[280] = c_dfa_cha_7;
	hg_dfa[281] = c_dfa_cha_8;
	hg_dfa[282] = c_dfa_cha_9;
	hg_dfa[283] = c_dfa_cha_10;
	hg_dfa[284] = c_dfa_cha_11;
	hg_dfa[285] = c_dfa_cha_12;
	hg_dfa[286] = c_dfa_cha_13;
	hg_dfa[287] = c_dfa_cha_14;
	hg_dfa[288] = c_dfa_cha_15;
	hg_dfa[289] = c_dfa_cha_16;
	hg_dfa[290] = c_dfa_cha_17;
	hg_dfa[291] = c_dfa_ka_0;
	hg_dfa[292] = c_dfa_ka_1;
	hg_dfa[293] = c_dfa_ka_2;
	hg_dfa[294] = c_dfa_ka_3;
	hg_dfa[295] = c_dfa_ka_4;
	hg_dfa[296] = c_dfa_ka_5;
	hg_dfa[297] = c_dfa_ka_6;
	hg_dfa[298] = c_dfa_ka_7;
	hg_dfa[299] = c_dfa_ka_8;
	hg_dfa[300] = c_dfa_ka_9;
	hg_dfa[301] = c_dfa_ka_10;
	hg_dfa[302] = c_dfa_ka_11;
	hg_dfa[303] = c_dfa_ka_12;
	hg_dfa[304] = c_dfa_ka_13;
	hg_dfa[305] = c_dfa_ka_14;
	hg_dfa[306] = c_dfa_ka_15;
	hg_dfa[307] = c_dfa_ka_16;
	hg_dfa[308] = c_dfa_ka_17;
	hg_dfa[309] = c_dfa_ka_18;
	hg_dfa[310] = c_dfa_ta_0;
	hg_dfa[311] = c_dfa_ta_1;
	hg_dfa[312] = c_dfa_ta_2;
	hg_dfa[313] = c_dfa_ta_3;
	hg_dfa[314] = c_dfa_ta_4;
	hg_dfa[315] = c_dfa_ta_5;
	hg_dfa[316] = c_dfa_ta_6;
	hg_dfa[317] = c_dfa_ta_7;
	hg_dfa[318] = c_dfa_ta_8;
	hg_dfa[319] = c_dfa_ta_9;
	hg_dfa[320] = c_dfa_ta_10;
	hg_dfa[321] = c_dfa_ta_11;
	hg_dfa[322] = c_dfa_ta_12;
	hg_dfa[323] = c_dfa_ta_13;
	hg_dfa[324] = c_dfa_ta_14;
	hg_dfa[325] = c_dfa_ta_15;
	hg_dfa[326] = c_dfa_ta_16;
	hg_dfa[327] = c_dfa_ta_17;
	hg_dfa[328] = c_dfa_ta_18;
	hg_dfa[329] = c_dfa_ta_19;
	hg_dfa[330] = c_dfa_pa_0;
	hg_dfa[331] = c_dfa_pa_1;
	hg_dfa[332] = c_dfa_pa_2;
	hg_dfa[333] = c_dfa_pa_3;
	hg_dfa[334] = c_dfa_pa_4;
	hg_dfa[335] = c_dfa_pa_5;
	hg_dfa[336] = c_dfa_pa_6;
	hg_dfa[337] = c_dfa_pa_7;
	hg_dfa[338] = c_dfa_pa_8;
	hg_dfa[339] = c_dfa_pa_9;
	hg_dfa[340] = c_dfa_pa_10;
	hg_dfa[341] = c_dfa_pa_11;
	hg_dfa[342] = c_dfa_pa_12;
	hg_dfa[343] = c_dfa_pa_13;
	hg_dfa[344] = c_dfa_pa_14;
	hg_dfa[345] = c_dfa_pa_15;
	hg_dfa[346] = c_dfa_pa_16;
	hg_dfa[347] = c_dfa_ha_0;
	hg_dfa[348] = c_dfa_ha_1;
	hg_dfa[349] = c_dfa_ha_2;
	hg_dfa[350] = c_dfa_ha_3;
	hg_dfa[351] = c_dfa_ha_4;
	hg_dfa[352] = c_dfa_ha_5;
	hg_dfa[353] = c_dfa_ha_6;
	hg_dfa[354] = c_dfa_ha_7;
	hg_dfa[355] = c_dfa_ha_8;
	hg_dfa[356] = c_dfa_ha_9;
	hg_dfa[357] = c_dfa_ha_10;
	hg_dfa[358] = c_dfa_ha_11;
	hg_dfa[359] = c_dfa_ha_12;
	hg_dfa[360] = c_dfa_ha_13;
	hg_dfa[361] = c_dfa_ha_14;
	hg_dfa[362] = c_dfa_ha_15;
	hg_dfa[363] = c_dfa_ha_16;
	hg_dfa[364] = c_dfa_ha_17;
	hg_dfa[365] = c_dfa_ha_18;
	hg_dfa[366] = c_dfa_ha_19;
	hg_dfa[367] = c_dfa_ga_20;	/* ⼭ Ʒ 7   Ǽ ߸ κ */
	hg_dfa[368] = c_dfa_gga_16;	/* Դϴ. */
	hg_dfa[369] = c_dfa_gga_17;
	hg_dfa[370] = c_dfa_gga_18;
	hg_dfa[371] = c_dfa_na_18;
	hg_dfa[372] = c_dfa_da_18;
	hg_dfa[373] = c_dfa_da_19;
	hg_dfa[374] = NULL;

	return hg_dfa;
}

/*  Լ ϼ(KS5601) Ÿ ʼ, ߼,    
 * װ ϼ ڵ ۸ ȯմϴ. */
unsigned char * 
hg_make_ks5601_f(unsigned char  c, unsigned char c1, unsigned char c2,
		    unsigned char c3, unsigned char c4, unsigned char c5)
{
	unsigned char * hg_char;
	unsigned int ** hg_dfa;
	int s=0, s1=0, tmp=0;
	/* ,  ϼ ѱۿ  0xa4  ϱ 
	 * 0xa4   ù° Ʈ    ֽϴ. */
	unsigned char hg[] = { (c1-0xa0), (c3-0xa0), (c5-0xa0), '\0' };
	unsigned int * t;
	unsigned char * hg_p;

	MALLOC(hg_char, unsigned char, 3);

	hg_dfa = hg_make_hgdfa_f();
	
	hg_p = hg;

	while ((t = hg_dfa[s]) != 0 && s != -1) {
		s1 = t[*hg_p++];
		if ( s1 > 512 ) {
			tmp = s ; s = s1 ; s1 = tmp ;
			break;
		}
		if ((t = hg_dfa[s1]) == 0) {
			tmp = s ; s = s1 ; s1 = tmp ;
			break;
		} else
			if( s1 == -1 )
				break;
		s = t[*hg_p++];
		if ( s > 512 )
			break;
	}

	free(hg_dfa);

	if( s != -1) {
		hg_char[0] = (unsigned char) ((s >> 8) & 0xff);
		hg_char[1] = (unsigned char) (s & 0xff);
		return hg_char;
	}

	free(hg_char);
	return NULL;
}

/*  Լ ϼ(KS5601) Ÿ  ڰ   ,
 * װ ʼ, ߼,  ڵ尡  ۸ ȯմϴ. */
unsigned char * 
hg_make_ks5601_b(unsigned char  c, unsigned char c1)
{
	unsigned int ** hg_dfa_a4;
	unsigned int * t;
	unsigned char * hg_char;
	unsigned char *hg_p, hg[] = { (c-0xa0), (c1-0xa0), '\0' };
	int s=0, s1=0, tmp=0;

	MALLOC(hg_char, unsigned char, 7);

	hg_dfa_a4 = hg_make_hgdfa_b();

	hg_p = hg;

	while ((t = hg_dfa_a4[s]) != 0 && s != -1) {
		s1 = t[*hg_p++];
		if ( s1 > 512 ) {
			tmp = s ; s = s1 ; s1 = tmp ;
			break;
		}
		if ((t = hg_dfa_a4[s1]) == 0) {
			tmp = s ; s = s1 ; s1 = tmp ;
			break;
		} else
			if( s1 == -1 )
				break;
		s = t[*hg_p++];
		if ( s > 512 )
			break;
	}

	free(hg_dfa_a4);
	
	if(s > 512) {
		if(((s >> 16) & 0xff) == 0xff) {
			hg_char[0] = ' ';
			hg_char[1] = ' ';
		} else {
			hg_char[0] = 0xa4;
			hg_char[1] = (unsigned char)((s >> 16) & 0xff);
		}
		if(((s >> 8) & 0xff) == 0xff) {
			hg_char[2] = ' ';
			hg_char[3] = ' ';
		} else {
			hg_char[2] = 0xa4;
			hg_char[3] = (unsigned char)((s >> 8) & 0xff);
		}
		if((s & 0xff)) {
			if((s & 0xff) == 0xff) {
				hg_char[4] = ' ';
				hg_char[5] = ' ';
			} else {
			hg_char[4] = 0xa4;
				hg_char[5] = (unsigned char)(s & 0xff);
			}
		}
	}

	return hg_char;
}
